// The MIT License (MIT)

// Copyright (c) 2017-2020 Uber Technologies Inc.

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

// Code generated by protoc-gen-yarpc-go. DO NOT EDIT.
// source: uber/cadence/admin/v1/service.proto

package adminv1

import (
	"context"
	"io/ioutil"
	"reflect"

	"github.com/gogo/protobuf/jsonpb"
	"github.com/gogo/protobuf/proto"
	"go.uber.org/fx"
	"go.uber.org/yarpc"
	"go.uber.org/yarpc/api/transport"
	"go.uber.org/yarpc/api/x/restriction"
	"go.uber.org/yarpc/encoding/protobuf"
	"go.uber.org/yarpc/encoding/protobuf/reflection"
)

var _ = ioutil.NopCloser

// AdminAPIYARPCClient is the YARPC client-side interface for the AdminAPI service.
type AdminAPIYARPCClient interface {
	DescribeWorkflowExecution(context.Context, *DescribeWorkflowExecutionRequest, ...yarpc.CallOption) (*DescribeWorkflowExecutionResponse, error)
	DescribeHistoryHost(context.Context, *DescribeHistoryHostRequest, ...yarpc.CallOption) (*DescribeHistoryHostResponse, error)
	DescribeShardDistribution(context.Context, *DescribeShardDistributionRequest, ...yarpc.CallOption) (*DescribeShardDistributionResponse, error)
	CloseShard(context.Context, *CloseShardRequest, ...yarpc.CallOption) (*CloseShardResponse, error)
	RemoveTask(context.Context, *RemoveTaskRequest, ...yarpc.CallOption) (*RemoveTaskResponse, error)
	ResetQueue(context.Context, *ResetQueueRequest, ...yarpc.CallOption) (*ResetQueueResponse, error)
	DescribeQueue(context.Context, *DescribeQueueRequest, ...yarpc.CallOption) (*DescribeQueueResponse, error)
	GetWorkflowExecutionRawHistoryV2(context.Context, *GetWorkflowExecutionRawHistoryV2Request, ...yarpc.CallOption) (*GetWorkflowExecutionRawHistoryV2Response, error)
	GetReplicationMessages(context.Context, *GetReplicationMessagesRequest, ...yarpc.CallOption) (*GetReplicationMessagesResponse, error)
	GetDLQReplicationMessages(context.Context, *GetDLQReplicationMessagesRequest, ...yarpc.CallOption) (*GetDLQReplicationMessagesResponse, error)
	GetDomainReplicationMessages(context.Context, *GetDomainReplicationMessagesRequest, ...yarpc.CallOption) (*GetDomainReplicationMessagesResponse, error)
	ReapplyEvents(context.Context, *ReapplyEventsRequest, ...yarpc.CallOption) (*ReapplyEventsResponse, error)
	AddSearchAttribute(context.Context, *AddSearchAttributeRequest, ...yarpc.CallOption) (*AddSearchAttributeResponse, error)
	DescribeCluster(context.Context, *DescribeClusterRequest, ...yarpc.CallOption) (*DescribeClusterResponse, error)
	ReadDLQMessages(context.Context, *ReadDLQMessagesRequest, ...yarpc.CallOption) (*ReadDLQMessagesResponse, error)
	PurgeDLQMessages(context.Context, *PurgeDLQMessagesRequest, ...yarpc.CallOption) (*PurgeDLQMessagesResponse, error)
	MergeDLQMessages(context.Context, *MergeDLQMessagesRequest, ...yarpc.CallOption) (*MergeDLQMessagesResponse, error)
	RefreshWorkflowTasks(context.Context, *RefreshWorkflowTasksRequest, ...yarpc.CallOption) (*RefreshWorkflowTasksResponse, error)
	ResendReplicationTasks(context.Context, *ResendReplicationTasksRequest, ...yarpc.CallOption) (*ResendReplicationTasksResponse, error)
	GetCrossClusterTasks(context.Context, *GetCrossClusterTasksRequest, ...yarpc.CallOption) (*GetCrossClusterTasksResponse, error)
	GetDynamicConfig(context.Context, *GetDynamicConfigRequest, ...yarpc.CallOption) (*GetDynamicConfigResponse, error)
	UpdateDynamicConfig(context.Context, *UpdateDynamicConfigRequest, ...yarpc.CallOption) (*UpdateDynamicConfigResponse, error)
	RestoreDynamicConfig(context.Context, *RestoreDynamicConfigRequest, ...yarpc.CallOption) (*RestoreDynamicConfigResponse, error)
	ListDynamicConfig(context.Context, *ListDynamicConfigRequest, ...yarpc.CallOption) (*ListDynamicConfigResponse, error)
}

func newAdminAPIYARPCClient(clientConfig transport.ClientConfig, anyResolver jsonpb.AnyResolver, options ...protobuf.ClientOption) AdminAPIYARPCClient {
	return &_AdminAPIYARPCCaller{protobuf.NewStreamClient(
		protobuf.ClientParams{
			ServiceName:  "uber.cadence.admin.v1.AdminAPI",
			ClientConfig: clientConfig,
			AnyResolver:  anyResolver,
			Options:      options,
		},
	)}
}

// NewAdminAPIYARPCClient builds a new YARPC client for the AdminAPI service.
func NewAdminAPIYARPCClient(clientConfig transport.ClientConfig, options ...protobuf.ClientOption) AdminAPIYARPCClient {
	return newAdminAPIYARPCClient(clientConfig, nil, options...)
}

// AdminAPIYARPCServer is the YARPC server-side interface for the AdminAPI service.
type AdminAPIYARPCServer interface {
	DescribeWorkflowExecution(context.Context, *DescribeWorkflowExecutionRequest) (*DescribeWorkflowExecutionResponse, error)
	DescribeHistoryHost(context.Context, *DescribeHistoryHostRequest) (*DescribeHistoryHostResponse, error)
	DescribeShardDistribution(context.Context, *DescribeShardDistributionRequest) (*DescribeShardDistributionResponse, error)
	CloseShard(context.Context, *CloseShardRequest) (*CloseShardResponse, error)
	RemoveTask(context.Context, *RemoveTaskRequest) (*RemoveTaskResponse, error)
	ResetQueue(context.Context, *ResetQueueRequest) (*ResetQueueResponse, error)
	DescribeQueue(context.Context, *DescribeQueueRequest) (*DescribeQueueResponse, error)
	GetWorkflowExecutionRawHistoryV2(context.Context, *GetWorkflowExecutionRawHistoryV2Request) (*GetWorkflowExecutionRawHistoryV2Response, error)
	GetReplicationMessages(context.Context, *GetReplicationMessagesRequest) (*GetReplicationMessagesResponse, error)
	GetDLQReplicationMessages(context.Context, *GetDLQReplicationMessagesRequest) (*GetDLQReplicationMessagesResponse, error)
	GetDomainReplicationMessages(context.Context, *GetDomainReplicationMessagesRequest) (*GetDomainReplicationMessagesResponse, error)
	ReapplyEvents(context.Context, *ReapplyEventsRequest) (*ReapplyEventsResponse, error)
	AddSearchAttribute(context.Context, *AddSearchAttributeRequest) (*AddSearchAttributeResponse, error)
	DescribeCluster(context.Context, *DescribeClusterRequest) (*DescribeClusterResponse, error)
	ReadDLQMessages(context.Context, *ReadDLQMessagesRequest) (*ReadDLQMessagesResponse, error)
	PurgeDLQMessages(context.Context, *PurgeDLQMessagesRequest) (*PurgeDLQMessagesResponse, error)
	MergeDLQMessages(context.Context, *MergeDLQMessagesRequest) (*MergeDLQMessagesResponse, error)
	RefreshWorkflowTasks(context.Context, *RefreshWorkflowTasksRequest) (*RefreshWorkflowTasksResponse, error)
	ResendReplicationTasks(context.Context, *ResendReplicationTasksRequest) (*ResendReplicationTasksResponse, error)
	GetCrossClusterTasks(context.Context, *GetCrossClusterTasksRequest) (*GetCrossClusterTasksResponse, error)
	GetDynamicConfig(context.Context, *GetDynamicConfigRequest) (*GetDynamicConfigResponse, error)
	UpdateDynamicConfig(context.Context, *UpdateDynamicConfigRequest) (*UpdateDynamicConfigResponse, error)
	RestoreDynamicConfig(context.Context, *RestoreDynamicConfigRequest) (*RestoreDynamicConfigResponse, error)
	ListDynamicConfig(context.Context, *ListDynamicConfigRequest) (*ListDynamicConfigResponse, error)
}

type buildAdminAPIYARPCProceduresParams struct {
	Server      AdminAPIYARPCServer
	AnyResolver jsonpb.AnyResolver
}

func buildAdminAPIYARPCProcedures(params buildAdminAPIYARPCProceduresParams) []transport.Procedure {
	handler := &_AdminAPIYARPCHandler{params.Server}
	return protobuf.BuildProcedures(
		protobuf.BuildProceduresParams{
			ServiceName: "uber.cadence.admin.v1.AdminAPI",
			UnaryHandlerParams: []protobuf.BuildProceduresUnaryHandlerParams{
				{
					MethodName: "DescribeWorkflowExecution",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.DescribeWorkflowExecution,
							NewRequest:  newAdminAPIServiceDescribeWorkflowExecutionYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "DescribeHistoryHost",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.DescribeHistoryHost,
							NewRequest:  newAdminAPIServiceDescribeHistoryHostYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "DescribeShardDistribution",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.DescribeShardDistribution,
							NewRequest:  newAdminAPIServiceDescribeShardDistributionYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "CloseShard",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.CloseShard,
							NewRequest:  newAdminAPIServiceCloseShardYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "RemoveTask",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.RemoveTask,
							NewRequest:  newAdminAPIServiceRemoveTaskYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "ResetQueue",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.ResetQueue,
							NewRequest:  newAdminAPIServiceResetQueueYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "DescribeQueue",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.DescribeQueue,
							NewRequest:  newAdminAPIServiceDescribeQueueYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "GetWorkflowExecutionRawHistoryV2",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.GetWorkflowExecutionRawHistoryV2,
							NewRequest:  newAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "GetReplicationMessages",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.GetReplicationMessages,
							NewRequest:  newAdminAPIServiceGetReplicationMessagesYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "GetDLQReplicationMessages",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.GetDLQReplicationMessages,
							NewRequest:  newAdminAPIServiceGetDLQReplicationMessagesYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "GetDomainReplicationMessages",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.GetDomainReplicationMessages,
							NewRequest:  newAdminAPIServiceGetDomainReplicationMessagesYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "ReapplyEvents",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.ReapplyEvents,
							NewRequest:  newAdminAPIServiceReapplyEventsYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "AddSearchAttribute",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.AddSearchAttribute,
							NewRequest:  newAdminAPIServiceAddSearchAttributeYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "DescribeCluster",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.DescribeCluster,
							NewRequest:  newAdminAPIServiceDescribeClusterYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "ReadDLQMessages",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.ReadDLQMessages,
							NewRequest:  newAdminAPIServiceReadDLQMessagesYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "PurgeDLQMessages",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.PurgeDLQMessages,
							NewRequest:  newAdminAPIServicePurgeDLQMessagesYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "MergeDLQMessages",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.MergeDLQMessages,
							NewRequest:  newAdminAPIServiceMergeDLQMessagesYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "RefreshWorkflowTasks",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.RefreshWorkflowTasks,
							NewRequest:  newAdminAPIServiceRefreshWorkflowTasksYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "ResendReplicationTasks",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.ResendReplicationTasks,
							NewRequest:  newAdminAPIServiceResendReplicationTasksYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "GetCrossClusterTasks",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.GetCrossClusterTasks,
							NewRequest:  newAdminAPIServiceGetCrossClusterTasksYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "GetDynamicConfig",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.GetDynamicConfig,
							NewRequest:  newAdminAPIServiceGetDynamicConfigYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "UpdateDynamicConfig",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.UpdateDynamicConfig,
							NewRequest:  newAdminAPIServiceUpdateDynamicConfigYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "RestoreDynamicConfig",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.RestoreDynamicConfig,
							NewRequest:  newAdminAPIServiceRestoreDynamicConfigYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
				{
					MethodName: "ListDynamicConfig",
					Handler: protobuf.NewUnaryHandler(
						protobuf.UnaryHandlerParams{
							Handle:      handler.ListDynamicConfig,
							NewRequest:  newAdminAPIServiceListDynamicConfigYARPCRequest,
							AnyResolver: params.AnyResolver,
						},
					),
				},
			},
			OnewayHandlerParams: []protobuf.BuildProceduresOnewayHandlerParams{},
			StreamHandlerParams: []protobuf.BuildProceduresStreamHandlerParams{},
		},
	)
}

// BuildAdminAPIYARPCProcedures prepares an implementation of the AdminAPI service for YARPC registration.
func BuildAdminAPIYARPCProcedures(server AdminAPIYARPCServer) []transport.Procedure {
	return buildAdminAPIYARPCProcedures(buildAdminAPIYARPCProceduresParams{Server: server})
}

// FxAdminAPIYARPCClientParams defines the input
// for NewFxAdminAPIYARPCClient. It provides the
// paramaters to get a AdminAPIYARPCClient in an
// Fx application.
type FxAdminAPIYARPCClientParams struct {
	fx.In

	Provider    yarpc.ClientConfig
	AnyResolver jsonpb.AnyResolver  `name:"yarpcfx" optional:"true"`
	Restriction restriction.Checker `optional:"true"`
}

// FxAdminAPIYARPCClientResult defines the output
// of NewFxAdminAPIYARPCClient. It provides a
// AdminAPIYARPCClient to an Fx application.
type FxAdminAPIYARPCClientResult struct {
	fx.Out

	Client AdminAPIYARPCClient

	// We are using an fx.Out struct here instead of just returning a client
	// so that we can add more values or add named versions of the client in
	// the future without breaking any existing code.
}

// NewFxAdminAPIYARPCClient provides a AdminAPIYARPCClient
// to an Fx application using the given name for routing.
//
//  fx.Provide(
//    adminv1.NewFxAdminAPIYARPCClient("service-name"),
//    ...
//  )
func NewFxAdminAPIYARPCClient(name string, options ...protobuf.ClientOption) interface{} {
	return func(params FxAdminAPIYARPCClientParams) FxAdminAPIYARPCClientResult {
		cc := params.Provider.ClientConfig(name)

		if params.Restriction != nil {
			if namer, ok := cc.GetUnaryOutbound().(transport.Namer); ok {
				if err := params.Restriction.Check(protobuf.Encoding, namer.TransportName()); err != nil {
					panic(err.Error())
				}
			}
		}

		return FxAdminAPIYARPCClientResult{
			Client: newAdminAPIYARPCClient(cc, params.AnyResolver, options...),
		}
	}
}

// FxAdminAPIYARPCProceduresParams defines the input
// for NewFxAdminAPIYARPCProcedures. It provides the
// paramaters to get AdminAPIYARPCServer procedures in an
// Fx application.
type FxAdminAPIYARPCProceduresParams struct {
	fx.In

	Server      AdminAPIYARPCServer
	AnyResolver jsonpb.AnyResolver `name:"yarpcfx" optional:"true"`
}

// FxAdminAPIYARPCProceduresResult defines the output
// of NewFxAdminAPIYARPCProcedures. It provides
// AdminAPIYARPCServer procedures to an Fx application.
//
// The procedures are provided to the "yarpcfx" value group.
// Dig 1.2 or newer must be used for this feature to work.
type FxAdminAPIYARPCProceduresResult struct {
	fx.Out

	Procedures     []transport.Procedure `group:"yarpcfx"`
	ReflectionMeta reflection.ServerMeta `group:"yarpcfx"`
}

// NewFxAdminAPIYARPCProcedures provides AdminAPIYARPCServer procedures to an Fx application.
// It expects a AdminAPIYARPCServer to be present in the container.
//
//  fx.Provide(
//    adminv1.NewFxAdminAPIYARPCProcedures(),
//    ...
//  )
func NewFxAdminAPIYARPCProcedures() interface{} {
	return func(params FxAdminAPIYARPCProceduresParams) FxAdminAPIYARPCProceduresResult {
		return FxAdminAPIYARPCProceduresResult{
			Procedures: buildAdminAPIYARPCProcedures(buildAdminAPIYARPCProceduresParams{
				Server:      params.Server,
				AnyResolver: params.AnyResolver,
			}),
			ReflectionMeta: reflection.ServerMeta{
				ServiceName:     "uber.cadence.admin.v1.AdminAPI",
				FileDescriptors: yarpcFileDescriptorClosurec6fc96d64a8b67fd,
			},
		}
	}
}

type _AdminAPIYARPCCaller struct {
	streamClient protobuf.StreamClient
}

func (c *_AdminAPIYARPCCaller) DescribeWorkflowExecution(ctx context.Context, request *DescribeWorkflowExecutionRequest, options ...yarpc.CallOption) (*DescribeWorkflowExecutionResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "DescribeWorkflowExecution", request, newAdminAPIServiceDescribeWorkflowExecutionYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*DescribeWorkflowExecutionResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceDescribeWorkflowExecutionYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) DescribeHistoryHost(ctx context.Context, request *DescribeHistoryHostRequest, options ...yarpc.CallOption) (*DescribeHistoryHostResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "DescribeHistoryHost", request, newAdminAPIServiceDescribeHistoryHostYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*DescribeHistoryHostResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceDescribeHistoryHostYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) DescribeShardDistribution(ctx context.Context, request *DescribeShardDistributionRequest, options ...yarpc.CallOption) (*DescribeShardDistributionResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "DescribeShardDistribution", request, newAdminAPIServiceDescribeShardDistributionYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*DescribeShardDistributionResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceDescribeShardDistributionYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) CloseShard(ctx context.Context, request *CloseShardRequest, options ...yarpc.CallOption) (*CloseShardResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "CloseShard", request, newAdminAPIServiceCloseShardYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*CloseShardResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceCloseShardYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) RemoveTask(ctx context.Context, request *RemoveTaskRequest, options ...yarpc.CallOption) (*RemoveTaskResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "RemoveTask", request, newAdminAPIServiceRemoveTaskYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*RemoveTaskResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceRemoveTaskYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) ResetQueue(ctx context.Context, request *ResetQueueRequest, options ...yarpc.CallOption) (*ResetQueueResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "ResetQueue", request, newAdminAPIServiceResetQueueYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*ResetQueueResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceResetQueueYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) DescribeQueue(ctx context.Context, request *DescribeQueueRequest, options ...yarpc.CallOption) (*DescribeQueueResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "DescribeQueue", request, newAdminAPIServiceDescribeQueueYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*DescribeQueueResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceDescribeQueueYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) GetWorkflowExecutionRawHistoryV2(ctx context.Context, request *GetWorkflowExecutionRawHistoryV2Request, options ...yarpc.CallOption) (*GetWorkflowExecutionRawHistoryV2Response, error) {
	responseMessage, err := c.streamClient.Call(ctx, "GetWorkflowExecutionRawHistoryV2", request, newAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*GetWorkflowExecutionRawHistoryV2Response)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) GetReplicationMessages(ctx context.Context, request *GetReplicationMessagesRequest, options ...yarpc.CallOption) (*GetReplicationMessagesResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "GetReplicationMessages", request, newAdminAPIServiceGetReplicationMessagesYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*GetReplicationMessagesResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceGetReplicationMessagesYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) GetDLQReplicationMessages(ctx context.Context, request *GetDLQReplicationMessagesRequest, options ...yarpc.CallOption) (*GetDLQReplicationMessagesResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "GetDLQReplicationMessages", request, newAdminAPIServiceGetDLQReplicationMessagesYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*GetDLQReplicationMessagesResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceGetDLQReplicationMessagesYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) GetDomainReplicationMessages(ctx context.Context, request *GetDomainReplicationMessagesRequest, options ...yarpc.CallOption) (*GetDomainReplicationMessagesResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "GetDomainReplicationMessages", request, newAdminAPIServiceGetDomainReplicationMessagesYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*GetDomainReplicationMessagesResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceGetDomainReplicationMessagesYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) ReapplyEvents(ctx context.Context, request *ReapplyEventsRequest, options ...yarpc.CallOption) (*ReapplyEventsResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "ReapplyEvents", request, newAdminAPIServiceReapplyEventsYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*ReapplyEventsResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceReapplyEventsYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) AddSearchAttribute(ctx context.Context, request *AddSearchAttributeRequest, options ...yarpc.CallOption) (*AddSearchAttributeResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "AddSearchAttribute", request, newAdminAPIServiceAddSearchAttributeYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*AddSearchAttributeResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceAddSearchAttributeYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) DescribeCluster(ctx context.Context, request *DescribeClusterRequest, options ...yarpc.CallOption) (*DescribeClusterResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "DescribeCluster", request, newAdminAPIServiceDescribeClusterYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*DescribeClusterResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceDescribeClusterYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) ReadDLQMessages(ctx context.Context, request *ReadDLQMessagesRequest, options ...yarpc.CallOption) (*ReadDLQMessagesResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "ReadDLQMessages", request, newAdminAPIServiceReadDLQMessagesYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*ReadDLQMessagesResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceReadDLQMessagesYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) PurgeDLQMessages(ctx context.Context, request *PurgeDLQMessagesRequest, options ...yarpc.CallOption) (*PurgeDLQMessagesResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "PurgeDLQMessages", request, newAdminAPIServicePurgeDLQMessagesYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*PurgeDLQMessagesResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServicePurgeDLQMessagesYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) MergeDLQMessages(ctx context.Context, request *MergeDLQMessagesRequest, options ...yarpc.CallOption) (*MergeDLQMessagesResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "MergeDLQMessages", request, newAdminAPIServiceMergeDLQMessagesYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*MergeDLQMessagesResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceMergeDLQMessagesYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) RefreshWorkflowTasks(ctx context.Context, request *RefreshWorkflowTasksRequest, options ...yarpc.CallOption) (*RefreshWorkflowTasksResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "RefreshWorkflowTasks", request, newAdminAPIServiceRefreshWorkflowTasksYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*RefreshWorkflowTasksResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceRefreshWorkflowTasksYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) ResendReplicationTasks(ctx context.Context, request *ResendReplicationTasksRequest, options ...yarpc.CallOption) (*ResendReplicationTasksResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "ResendReplicationTasks", request, newAdminAPIServiceResendReplicationTasksYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*ResendReplicationTasksResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceResendReplicationTasksYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) GetCrossClusterTasks(ctx context.Context, request *GetCrossClusterTasksRequest, options ...yarpc.CallOption) (*GetCrossClusterTasksResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "GetCrossClusterTasks", request, newAdminAPIServiceGetCrossClusterTasksYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*GetCrossClusterTasksResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceGetCrossClusterTasksYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) GetDynamicConfig(ctx context.Context, request *GetDynamicConfigRequest, options ...yarpc.CallOption) (*GetDynamicConfigResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "GetDynamicConfig", request, newAdminAPIServiceGetDynamicConfigYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*GetDynamicConfigResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceGetDynamicConfigYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) UpdateDynamicConfig(ctx context.Context, request *UpdateDynamicConfigRequest, options ...yarpc.CallOption) (*UpdateDynamicConfigResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "UpdateDynamicConfig", request, newAdminAPIServiceUpdateDynamicConfigYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*UpdateDynamicConfigResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceUpdateDynamicConfigYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) RestoreDynamicConfig(ctx context.Context, request *RestoreDynamicConfigRequest, options ...yarpc.CallOption) (*RestoreDynamicConfigResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "RestoreDynamicConfig", request, newAdminAPIServiceRestoreDynamicConfigYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*RestoreDynamicConfigResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceRestoreDynamicConfigYARPCResponse, responseMessage)
	}
	return response, err
}

func (c *_AdminAPIYARPCCaller) ListDynamicConfig(ctx context.Context, request *ListDynamicConfigRequest, options ...yarpc.CallOption) (*ListDynamicConfigResponse, error) {
	responseMessage, err := c.streamClient.Call(ctx, "ListDynamicConfig", request, newAdminAPIServiceListDynamicConfigYARPCResponse, options...)
	if responseMessage == nil {
		return nil, err
	}
	response, ok := responseMessage.(*ListDynamicConfigResponse)
	if !ok {
		return nil, protobuf.CastError(emptyAdminAPIServiceListDynamicConfigYARPCResponse, responseMessage)
	}
	return response, err
}

type _AdminAPIYARPCHandler struct {
	server AdminAPIYARPCServer
}

func (h *_AdminAPIYARPCHandler) DescribeWorkflowExecution(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *DescribeWorkflowExecutionRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*DescribeWorkflowExecutionRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceDescribeWorkflowExecutionYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.DescribeWorkflowExecution(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) DescribeHistoryHost(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *DescribeHistoryHostRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*DescribeHistoryHostRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceDescribeHistoryHostYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.DescribeHistoryHost(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) DescribeShardDistribution(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *DescribeShardDistributionRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*DescribeShardDistributionRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceDescribeShardDistributionYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.DescribeShardDistribution(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) CloseShard(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *CloseShardRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*CloseShardRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceCloseShardYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.CloseShard(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) RemoveTask(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *RemoveTaskRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*RemoveTaskRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceRemoveTaskYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.RemoveTask(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) ResetQueue(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *ResetQueueRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*ResetQueueRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceResetQueueYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.ResetQueue(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) DescribeQueue(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *DescribeQueueRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*DescribeQueueRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceDescribeQueueYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.DescribeQueue(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) GetWorkflowExecutionRawHistoryV2(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *GetWorkflowExecutionRawHistoryV2Request
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*GetWorkflowExecutionRawHistoryV2Request)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCRequest, requestMessage)
		}
	}
	response, err := h.server.GetWorkflowExecutionRawHistoryV2(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) GetReplicationMessages(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *GetReplicationMessagesRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*GetReplicationMessagesRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceGetReplicationMessagesYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.GetReplicationMessages(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) GetDLQReplicationMessages(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *GetDLQReplicationMessagesRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*GetDLQReplicationMessagesRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceGetDLQReplicationMessagesYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.GetDLQReplicationMessages(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) GetDomainReplicationMessages(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *GetDomainReplicationMessagesRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*GetDomainReplicationMessagesRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceGetDomainReplicationMessagesYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.GetDomainReplicationMessages(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) ReapplyEvents(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *ReapplyEventsRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*ReapplyEventsRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceReapplyEventsYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.ReapplyEvents(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) AddSearchAttribute(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *AddSearchAttributeRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*AddSearchAttributeRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceAddSearchAttributeYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.AddSearchAttribute(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) DescribeCluster(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *DescribeClusterRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*DescribeClusterRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceDescribeClusterYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.DescribeCluster(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) ReadDLQMessages(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *ReadDLQMessagesRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*ReadDLQMessagesRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceReadDLQMessagesYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.ReadDLQMessages(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) PurgeDLQMessages(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *PurgeDLQMessagesRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*PurgeDLQMessagesRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServicePurgeDLQMessagesYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.PurgeDLQMessages(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) MergeDLQMessages(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *MergeDLQMessagesRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*MergeDLQMessagesRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceMergeDLQMessagesYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.MergeDLQMessages(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) RefreshWorkflowTasks(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *RefreshWorkflowTasksRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*RefreshWorkflowTasksRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceRefreshWorkflowTasksYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.RefreshWorkflowTasks(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) ResendReplicationTasks(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *ResendReplicationTasksRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*ResendReplicationTasksRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceResendReplicationTasksYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.ResendReplicationTasks(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) GetCrossClusterTasks(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *GetCrossClusterTasksRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*GetCrossClusterTasksRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceGetCrossClusterTasksYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.GetCrossClusterTasks(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) GetDynamicConfig(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *GetDynamicConfigRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*GetDynamicConfigRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceGetDynamicConfigYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.GetDynamicConfig(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) UpdateDynamicConfig(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *UpdateDynamicConfigRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*UpdateDynamicConfigRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceUpdateDynamicConfigYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.UpdateDynamicConfig(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) RestoreDynamicConfig(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *RestoreDynamicConfigRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*RestoreDynamicConfigRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceRestoreDynamicConfigYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.RestoreDynamicConfig(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func (h *_AdminAPIYARPCHandler) ListDynamicConfig(ctx context.Context, requestMessage proto.Message) (proto.Message, error) {
	var request *ListDynamicConfigRequest
	var ok bool
	if requestMessage != nil {
		request, ok = requestMessage.(*ListDynamicConfigRequest)
		if !ok {
			return nil, protobuf.CastError(emptyAdminAPIServiceListDynamicConfigYARPCRequest, requestMessage)
		}
	}
	response, err := h.server.ListDynamicConfig(ctx, request)
	if response == nil {
		return nil, err
	}
	return response, err
}

func newAdminAPIServiceDescribeWorkflowExecutionYARPCRequest() proto.Message {
	return &DescribeWorkflowExecutionRequest{}
}

func newAdminAPIServiceDescribeWorkflowExecutionYARPCResponse() proto.Message {
	return &DescribeWorkflowExecutionResponse{}
}

func newAdminAPIServiceDescribeHistoryHostYARPCRequest() proto.Message {
	return &DescribeHistoryHostRequest{}
}

func newAdminAPIServiceDescribeHistoryHostYARPCResponse() proto.Message {
	return &DescribeHistoryHostResponse{}
}

func newAdminAPIServiceDescribeShardDistributionYARPCRequest() proto.Message {
	return &DescribeShardDistributionRequest{}
}

func newAdminAPIServiceDescribeShardDistributionYARPCResponse() proto.Message {
	return &DescribeShardDistributionResponse{}
}

func newAdminAPIServiceCloseShardYARPCRequest() proto.Message {
	return &CloseShardRequest{}
}

func newAdminAPIServiceCloseShardYARPCResponse() proto.Message {
	return &CloseShardResponse{}
}

func newAdminAPIServiceRemoveTaskYARPCRequest() proto.Message {
	return &RemoveTaskRequest{}
}

func newAdminAPIServiceRemoveTaskYARPCResponse() proto.Message {
	return &RemoveTaskResponse{}
}

func newAdminAPIServiceResetQueueYARPCRequest() proto.Message {
	return &ResetQueueRequest{}
}

func newAdminAPIServiceResetQueueYARPCResponse() proto.Message {
	return &ResetQueueResponse{}
}

func newAdminAPIServiceDescribeQueueYARPCRequest() proto.Message {
	return &DescribeQueueRequest{}
}

func newAdminAPIServiceDescribeQueueYARPCResponse() proto.Message {
	return &DescribeQueueResponse{}
}

func newAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCRequest() proto.Message {
	return &GetWorkflowExecutionRawHistoryV2Request{}
}

func newAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCResponse() proto.Message {
	return &GetWorkflowExecutionRawHistoryV2Response{}
}

func newAdminAPIServiceGetReplicationMessagesYARPCRequest() proto.Message {
	return &GetReplicationMessagesRequest{}
}

func newAdminAPIServiceGetReplicationMessagesYARPCResponse() proto.Message {
	return &GetReplicationMessagesResponse{}
}

func newAdminAPIServiceGetDLQReplicationMessagesYARPCRequest() proto.Message {
	return &GetDLQReplicationMessagesRequest{}
}

func newAdminAPIServiceGetDLQReplicationMessagesYARPCResponse() proto.Message {
	return &GetDLQReplicationMessagesResponse{}
}

func newAdminAPIServiceGetDomainReplicationMessagesYARPCRequest() proto.Message {
	return &GetDomainReplicationMessagesRequest{}
}

func newAdminAPIServiceGetDomainReplicationMessagesYARPCResponse() proto.Message {
	return &GetDomainReplicationMessagesResponse{}
}

func newAdminAPIServiceReapplyEventsYARPCRequest() proto.Message {
	return &ReapplyEventsRequest{}
}

func newAdminAPIServiceReapplyEventsYARPCResponse() proto.Message {
	return &ReapplyEventsResponse{}
}

func newAdminAPIServiceAddSearchAttributeYARPCRequest() proto.Message {
	return &AddSearchAttributeRequest{}
}

func newAdminAPIServiceAddSearchAttributeYARPCResponse() proto.Message {
	return &AddSearchAttributeResponse{}
}

func newAdminAPIServiceDescribeClusterYARPCRequest() proto.Message {
	return &DescribeClusterRequest{}
}

func newAdminAPIServiceDescribeClusterYARPCResponse() proto.Message {
	return &DescribeClusterResponse{}
}

func newAdminAPIServiceReadDLQMessagesYARPCRequest() proto.Message {
	return &ReadDLQMessagesRequest{}
}

func newAdminAPIServiceReadDLQMessagesYARPCResponse() proto.Message {
	return &ReadDLQMessagesResponse{}
}

func newAdminAPIServicePurgeDLQMessagesYARPCRequest() proto.Message {
	return &PurgeDLQMessagesRequest{}
}

func newAdminAPIServicePurgeDLQMessagesYARPCResponse() proto.Message {
	return &PurgeDLQMessagesResponse{}
}

func newAdminAPIServiceMergeDLQMessagesYARPCRequest() proto.Message {
	return &MergeDLQMessagesRequest{}
}

func newAdminAPIServiceMergeDLQMessagesYARPCResponse() proto.Message {
	return &MergeDLQMessagesResponse{}
}

func newAdminAPIServiceRefreshWorkflowTasksYARPCRequest() proto.Message {
	return &RefreshWorkflowTasksRequest{}
}

func newAdminAPIServiceRefreshWorkflowTasksYARPCResponse() proto.Message {
	return &RefreshWorkflowTasksResponse{}
}

func newAdminAPIServiceResendReplicationTasksYARPCRequest() proto.Message {
	return &ResendReplicationTasksRequest{}
}

func newAdminAPIServiceResendReplicationTasksYARPCResponse() proto.Message {
	return &ResendReplicationTasksResponse{}
}

func newAdminAPIServiceGetCrossClusterTasksYARPCRequest() proto.Message {
	return &GetCrossClusterTasksRequest{}
}

func newAdminAPIServiceGetCrossClusterTasksYARPCResponse() proto.Message {
	return &GetCrossClusterTasksResponse{}
}

func newAdminAPIServiceGetDynamicConfigYARPCRequest() proto.Message {
	return &GetDynamicConfigRequest{}
}

func newAdminAPIServiceGetDynamicConfigYARPCResponse() proto.Message {
	return &GetDynamicConfigResponse{}
}

func newAdminAPIServiceUpdateDynamicConfigYARPCRequest() proto.Message {
	return &UpdateDynamicConfigRequest{}
}

func newAdminAPIServiceUpdateDynamicConfigYARPCResponse() proto.Message {
	return &UpdateDynamicConfigResponse{}
}

func newAdminAPIServiceRestoreDynamicConfigYARPCRequest() proto.Message {
	return &RestoreDynamicConfigRequest{}
}

func newAdminAPIServiceRestoreDynamicConfigYARPCResponse() proto.Message {
	return &RestoreDynamicConfigResponse{}
}

func newAdminAPIServiceListDynamicConfigYARPCRequest() proto.Message {
	return &ListDynamicConfigRequest{}
}

func newAdminAPIServiceListDynamicConfigYARPCResponse() proto.Message {
	return &ListDynamicConfigResponse{}
}

var (
	emptyAdminAPIServiceDescribeWorkflowExecutionYARPCRequest         = &DescribeWorkflowExecutionRequest{}
	emptyAdminAPIServiceDescribeWorkflowExecutionYARPCResponse        = &DescribeWorkflowExecutionResponse{}
	emptyAdminAPIServiceDescribeHistoryHostYARPCRequest               = &DescribeHistoryHostRequest{}
	emptyAdminAPIServiceDescribeHistoryHostYARPCResponse              = &DescribeHistoryHostResponse{}
	emptyAdminAPIServiceDescribeShardDistributionYARPCRequest         = &DescribeShardDistributionRequest{}
	emptyAdminAPIServiceDescribeShardDistributionYARPCResponse        = &DescribeShardDistributionResponse{}
	emptyAdminAPIServiceCloseShardYARPCRequest                        = &CloseShardRequest{}
	emptyAdminAPIServiceCloseShardYARPCResponse                       = &CloseShardResponse{}
	emptyAdminAPIServiceRemoveTaskYARPCRequest                        = &RemoveTaskRequest{}
	emptyAdminAPIServiceRemoveTaskYARPCResponse                       = &RemoveTaskResponse{}
	emptyAdminAPIServiceResetQueueYARPCRequest                        = &ResetQueueRequest{}
	emptyAdminAPIServiceResetQueueYARPCResponse                       = &ResetQueueResponse{}
	emptyAdminAPIServiceDescribeQueueYARPCRequest                     = &DescribeQueueRequest{}
	emptyAdminAPIServiceDescribeQueueYARPCResponse                    = &DescribeQueueResponse{}
	emptyAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCRequest  = &GetWorkflowExecutionRawHistoryV2Request{}
	emptyAdminAPIServiceGetWorkflowExecutionRawHistoryV2YARPCResponse = &GetWorkflowExecutionRawHistoryV2Response{}
	emptyAdminAPIServiceGetReplicationMessagesYARPCRequest            = &GetReplicationMessagesRequest{}
	emptyAdminAPIServiceGetReplicationMessagesYARPCResponse           = &GetReplicationMessagesResponse{}
	emptyAdminAPIServiceGetDLQReplicationMessagesYARPCRequest         = &GetDLQReplicationMessagesRequest{}
	emptyAdminAPIServiceGetDLQReplicationMessagesYARPCResponse        = &GetDLQReplicationMessagesResponse{}
	emptyAdminAPIServiceGetDomainReplicationMessagesYARPCRequest      = &GetDomainReplicationMessagesRequest{}
	emptyAdminAPIServiceGetDomainReplicationMessagesYARPCResponse     = &GetDomainReplicationMessagesResponse{}
	emptyAdminAPIServiceReapplyEventsYARPCRequest                     = &ReapplyEventsRequest{}
	emptyAdminAPIServiceReapplyEventsYARPCResponse                    = &ReapplyEventsResponse{}
	emptyAdminAPIServiceAddSearchAttributeYARPCRequest                = &AddSearchAttributeRequest{}
	emptyAdminAPIServiceAddSearchAttributeYARPCResponse               = &AddSearchAttributeResponse{}
	emptyAdminAPIServiceDescribeClusterYARPCRequest                   = &DescribeClusterRequest{}
	emptyAdminAPIServiceDescribeClusterYARPCResponse                  = &DescribeClusterResponse{}
	emptyAdminAPIServiceReadDLQMessagesYARPCRequest                   = &ReadDLQMessagesRequest{}
	emptyAdminAPIServiceReadDLQMessagesYARPCResponse                  = &ReadDLQMessagesResponse{}
	emptyAdminAPIServicePurgeDLQMessagesYARPCRequest                  = &PurgeDLQMessagesRequest{}
	emptyAdminAPIServicePurgeDLQMessagesYARPCResponse                 = &PurgeDLQMessagesResponse{}
	emptyAdminAPIServiceMergeDLQMessagesYARPCRequest                  = &MergeDLQMessagesRequest{}
	emptyAdminAPIServiceMergeDLQMessagesYARPCResponse                 = &MergeDLQMessagesResponse{}
	emptyAdminAPIServiceRefreshWorkflowTasksYARPCRequest              = &RefreshWorkflowTasksRequest{}
	emptyAdminAPIServiceRefreshWorkflowTasksYARPCResponse             = &RefreshWorkflowTasksResponse{}
	emptyAdminAPIServiceResendReplicationTasksYARPCRequest            = &ResendReplicationTasksRequest{}
	emptyAdminAPIServiceResendReplicationTasksYARPCResponse           = &ResendReplicationTasksResponse{}
	emptyAdminAPIServiceGetCrossClusterTasksYARPCRequest              = &GetCrossClusterTasksRequest{}
	emptyAdminAPIServiceGetCrossClusterTasksYARPCResponse             = &GetCrossClusterTasksResponse{}
	emptyAdminAPIServiceGetDynamicConfigYARPCRequest                  = &GetDynamicConfigRequest{}
	emptyAdminAPIServiceGetDynamicConfigYARPCResponse                 = &GetDynamicConfigResponse{}
	emptyAdminAPIServiceUpdateDynamicConfigYARPCRequest               = &UpdateDynamicConfigRequest{}
	emptyAdminAPIServiceUpdateDynamicConfigYARPCResponse              = &UpdateDynamicConfigResponse{}
	emptyAdminAPIServiceRestoreDynamicConfigYARPCRequest              = &RestoreDynamicConfigRequest{}
	emptyAdminAPIServiceRestoreDynamicConfigYARPCResponse             = &RestoreDynamicConfigResponse{}
	emptyAdminAPIServiceListDynamicConfigYARPCRequest                 = &ListDynamicConfigRequest{}
	emptyAdminAPIServiceListDynamicConfigYARPCResponse                = &ListDynamicConfigResponse{}
)

var yarpcFileDescriptorClosurec6fc96d64a8b67fd = [][]byte{
	// uber/cadence/admin/v1/service.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xdc, 0x1a, 0x4b, 0x6f, 0x1b, 0xc7,
		0xd9, 0x4b, 0x4a, 0xb2, 0xf4, 0x51, 0xcf, 0xb1, 0x24, 0x52, 0x94, 0x1f, 0xf2, 0x3a, 0x8e, 0x95,
		0x47, 0x29, 0x8b, 0x8a, 0xdd, 0x24, 0x46, 0xda, 0xe8, 0x61, 0x4b, 0x4a, 0xec, 0xd8, 0x5e, 0x29,
		0x4e, 0x51, 0x14, 0xdd, 0x2e, 0xb9, 0x23, 0x69, 0x2b, 0x72, 0x97, 0xde, 0x19, 0xd2, 0x66, 0x10,
		0xb4, 0x41, 0x91, 0xde, 0xfa, 0x44, 0x0f, 0x3d, 0xf6, 0xd0, 0x5b, 0x7b, 0x28, 0x7a, 0xef, 0xad,
		0x40, 0xcf, 0xed, 0x9f, 0xc8, 0xa5, 0x40, 0x81, 0xa2, 0x97, 0x1e, 0x8b, 0x79, 0x2c, 0xb9, 0xaf,
		0xe1, 0x43, 0x75, 0xe1, 0x22, 0x37, 0xee, 0x37, 0xdf, 0x6b, 0xbe, 0xf9, 0xe6, 0x7b, 0x0d, 0xe1,
		0x5a, 0xb3, 0x82, 0xfd, 0xb5, 0xaa, 0x65, 0x63, 0xb7, 0x8a, 0xd7, 0x2c, 0xbb, 0xee, 0xb8, 0x6b,
		0xad, 0xf5, 0x35, 0x82, 0xfd, 0x96, 0x53, 0xc5, 0xa5, 0x86, 0xef, 0x51, 0x0f, 0x2d, 0x30, 0xa4,
		0x92, 0x44, 0x2a, 0x71, 0xa4, 0x52, 0x6b, 0xbd, 0x78, 0xe5, 0xd8, 0xf3, 0x8e, 0x6b, 0x78, 0x8d,
		0x23, 0x55, 0x9a, 0x47, 0x6b, 0xd4, 0xa9, 0x63, 0x42, 0xad, 0x7a, 0x43, 0xd0, 0x15, 0x2f, 0xc7,
		0x11, 0x9e, 0xf9, 0x56, 0xa3, 0x81, 0x7d, 0x22, 0xd7, 0x57, 0xa2, 0xc2, 0x1b, 0x0e, 0x13, 0x5d,
		0xf5, 0xea, 0x75, 0xcf, 0x95, 0x18, 0xaf, 0xa4, 0x61, 0xb4, 0x1c, 0xe2, 0x54, 0x9c, 0x9a, 0x43,
		0xdb, 0xa9, 0x58, 0xe4, 0xc4, 0xf2, 0xb1, 0xcd, 0x59, 0xd5, 0x9a, 0x84, 0x62, 0xbf, 0x0f, 0xd6,
		0x89, 0x43, 0xa8, 0xe7, 0x07, 0xbc, 0x74, 0x05, 0xd6, 0xd3, 0x26, 0x6e, 0x4a, 0x7b, 0x14, 0x57,
		0x15, 0x38, 0x3e, 0x6e, 0xd4, 0x9c, 0xaa, 0x45, 0x9d, 0x40, 0x7f, 0xfd, 0x97, 0x1a, 0xac, 0xec,
		0x60, 0x52, 0xf5, 0x9d, 0x0a, 0xfe, 0xc4, 0xf3, 0x4f, 0x8f, 0x6a, 0xde, 0xb3, 0xbb, 0xcf, 0x71,
		0xb5, 0xc9, 0x70, 0x0c, 0xfc, 0xb4, 0x89, 0x09, 0x45, 0x8b, 0x30, 0x66, 0x7b, 0x75, 0xcb, 0x71,
		0x0b, 0xda, 0x8a, 0xb6, 0x3a, 0x61, 0xc8, 0x2f, 0xf4, 0x31, 0xa0, 0x67, 0x92, 0xc6, 0xc4, 0x01,
		0x51, 0x21, 0xb3, 0xa2, 0xad, 0xe6, 0xca, 0xaf, 0x96, 0xa2, 0x67, 0xd2, 0x70, 0x4a, 0xad, 0xf5,
		0x52, 0x52, 0xc4, 0xdc, 0xb3, 0x38, 0x48, 0xff, 0x9b, 0x06, 0x57, 0x7b, 0xe8, 0x44, 0x1a, 0x9e,
		0x4b, 0x30, 0x5a, 0x82, 0x71, 0xb6, 0x31, 0xdb, 0x74, 0x6c, 0xae, 0xd6, 0xa8, 0x71, 0x9e, 0x7f,
		0xef, 0xdb, 0xe8, 0x2a, 0x4c, 0x4a, 0x9b, 0x99, 0x96, 0x6d, 0xfb, 0x5c, 0xa3, 0x09, 0x23, 0x27,
		0x61, 0x9b, 0xb6, 0xed, 0xa3, 0x0d, 0x58, 0xac, 0x37, 0xa9, 0x55, 0xa9, 0x61, 0x93, 0x50, 0x8b,
		0x62, 0xd3, 0x71, 0xcd, 0xaa, 0x55, 0x3d, 0xc1, 0x85, 0x2c, 0x47, 0xbe, 0x20, 0x57, 0x0f, 0xd8,
		0xe2, 0xbe, 0xbb, 0xcd, 0x96, 0xd0, 0x3b, 0xb0, 0x94, 0x20, 0xb2, 0x2d, 0x6a, 0x55, 0x2c, 0x82,
		0x0b, 0x23, 0x9c, 0x6e, 0x31, 0x4a, 0xb7, 0x23, 0x57, 0xf5, 0xbf, 0x68, 0x50, 0x0c, 0xf6, 0xb4,
		0x27, 0xf4, 0xd8, 0xf3, 0x08, 0x0d, 0x2c, 0x7c, 0x0d, 0x26, 0x4f, 0x3c, 0x42, 0xb9, 0xba, 0x98,
		0x10, 0x61, 0xe7, 0xbd, 0x73, 0x46, 0x8e, 0x41, 0x37, 0x05, 0x10, 0x2d, 0x87, 0x76, 0xcc, 0xb6,
		0x34, 0xba, 0x77, 0xae, 0xbb, 0xe7, 0x4f, 0x52, 0xcf, 0x22, 0x3b, 0xcc, 0x59, 0xec, 0x9d, 0x4b,
		0x39, 0x8d, 0xad, 0x29, 0xc8, 0xd9, 0x52, 0x71, 0xb3, 0xd2, 0xd6, 0xbf, 0xd5, 0xf5, 0x97, 0x03,
		0x26, 0x7a, 0xc7, 0x21, 0xd4, 0x77, 0x2a, 0x11, 0x7f, 0x59, 0x86, 0x89, 0x86, 0x75, 0x8c, 0x4d,
		0xe2, 0x7c, 0x8a, 0xe5, 0xd9, 0x8c, 0x33, 0xc0, 0x81, 0xf3, 0x29, 0x46, 0x79, 0x38, 0xcf, 0x17,
		0x83, 0x4d, 0x18, 0x63, 0xec, 0x73, 0xdf, 0xd6, 0xbf, 0x0c, 0x1d, 0x7b, 0x0a, 0x6b, 0x79, 0xec,
		0xab, 0x30, 0xeb, 0x36, 0xeb, 0x15, 0xec, 0x9b, 0xde, 0x91, 0xc9, 0x37, 0x4f, 0xa4, 0x88, 0x69,
		0x01, 0x7f, 0x78, 0xc4, 0x89, 0x09, 0xfa, 0x0e, 0x8c, 0xc9, 0xf5, 0xcc, 0x4a, 0x76, 0x35, 0x57,
		0xde, 0x29, 0xa5, 0x46, 0x89, 0x52, 0x5f, 0x99, 0x25, 0xc1, 0xf0, 0xae, 0x4b, 0xfd, 0xb6, 0x21,
		0x79, 0x16, 0xdf, 0x81, 0x5c, 0x08, 0x8c, 0x66, 0x21, 0x7b, 0x8a, 0xdb, 0x52, 0x13, 0xf6, 0x13,
		0xcd, 0xc3, 0x68, 0xcb, 0xaa, 0x35, 0xb1, 0xf4, 0x3e, 0xf1, 0xf1, 0x6e, 0xe6, 0x6d, 0x4d, 0xff,
		0x51, 0x06, 0x96, 0x53, 0x7d, 0x61, 0xe8, 0x2d, 0x2e, 0xc3, 0x44, 0xe0, 0x11, 0x62, 0x97, 0xa3,
		0xc6, 0xb8, 0x74, 0x08, 0x82, 0x3e, 0x80, 0x49, 0x71, 0x4f, 0x43, 0x8e, 0x9d, 0x2b, 0xdf, 0x88,
		0x5a, 0x41, 0xc4, 0x06, 0x6e, 0x06, 0x8e, 0xcb, 0x1d, 0x7d, 0xdf, 0x3d, 0xf2, 0x8c, 0x9c, 0xdd,
		0x05, 0xa0, 0xdb, 0x90, 0x17, 0x82, 0xaa, 0x9e, 0x4b, 0x7d, 0xaf, 0x56, 0xc3, 0x3e, 0xbf, 0x02,
		0x4d, 0x22, 0xfd, 0x7e, 0x81, 0x2f, 0x6f, 0x77, 0x56, 0x0f, 0xf8, 0x22, 0x2a, 0xc0, 0xf9, 0xc0,
		0xa5, 0x47, 0x39, 0x5e, 0xf0, 0xa9, 0x97, 0x60, 0x6e, 0xbb, 0xe6, 0x11, 0x61, 0xf5, 0xc0, 0x71,
		0xd4, 0x77, 0x5a, 0x9f, 0x07, 0x14, 0xc6, 0x17, 0xa6, 0xd2, 0xff, 0xa1, 0xc1, 0x9c, 0x81, 0xeb,
		0x5e, 0x0b, 0x1f, 0x5a, 0xe4, 0xb4, 0x3f, 0x1b, 0xf4, 0x1e, 0x4c, 0x50, 0x8b, 0x9c, 0x9a, 0xb4,
		0xdd, 0x10, 0x27, 0x33, 0x5d, 0x5e, 0x51, 0x59, 0x84, 0xb1, 0x3c, 0x6c, 0x37, 0xb0, 0x31, 0x4e,
		0xe5, 0x2f, 0xe6, 0xbc, 0x9c, 0xdc, 0xb1, 0xb9, 0x39, 0xb3, 0xc6, 0x18, 0xfb, 0xdc, 0xb7, 0xd1,
		0x36, 0xcc, 0x74, 0xa3, 0xbe, 0xc9, 0xf2, 0x0c, 0x37, 0x4c, 0xae, 0x5c, 0x2c, 0x89, 0x1c, 0x53,
		0x0a, 0x72, 0x4c, 0xe9, 0x30, 0x48, 0x42, 0xc6, 0x74, 0x97, 0x84, 0x01, 0x59, 0xdc, 0x92, 0x19,
		0xc1, 0x74, 0xad, 0x3a, 0x96, 0x26, 0xcb, 0x49, 0xd8, 0x47, 0x56, 0x1d, 0x33, 0x33, 0x84, 0xf7,
		0x2b, 0xcd, 0xf0, 0x0b, 0x6e, 0x06, 0x82, 0xe9, 0x63, 0x96, 0x04, 0x06, 0x30, 0x43, 0x5c, 0x52,
		0x26, 0x21, 0x29, 0x6a, 0xa9, 0xec, 0xb0, 0x96, 0x12, 0x8a, 0x76, 0x35, 0x92, 0x8a, 0xfe, 0x4a,
		0x83, 0xf9, 0xc0, 0xf5, 0xff, 0x7f, 0x74, 0x7d, 0x08, 0x0b, 0x31, 0xa5, 0xe4, 0x4d, 0xbc, 0x0d,
		0xf9, 0x86, 0xef, 0x55, 0x31, 0x21, 0x8e, 0x7b, 0x6c, 0xf2, 0x0c, 0x2b, 0x22, 0x3f, 0xbb, 0x90,
		0x59, 0xe6, 0xf6, 0xdd, 0x65, 0x4e, 0xc9, 0xc3, 0x3e, 0xd1, 0xff, 0x95, 0x81, 0x1b, 0xbb, 0x98,
		0x26, 0x93, 0x97, 0xf5, 0x4c, 0x5e, 0xf8, 0x27, 0xe5, 0x97, 0x93, 0x5c, 0xd1, 0x87, 0x90, 0x23,
		0xd4, 0xf2, 0xa9, 0x89, 0x5b, 0xd8, 0xa5, 0x32, 0x28, 0xbc, 0xae, 0x32, 0xd6, 0x13, 0xec, 0x13,
		0x96, 0x19, 0x84, 0xd2, 0xfb, 0x14, 0xd7, 0x0d, 0xe0, 0xe4, 0x77, 0x19, 0x35, 0xda, 0x85, 0x09,
		0xec, 0xda, 0x92, 0xd5, 0xc8, 0xd0, 0xac, 0xc6, 0xb1, 0x6b, 0x0b, 0x46, 0x91, 0x8c, 0x31, 0x1a,
		0xcb, 0x18, 0xaf, 0xc2, 0x8c, 0x8b, 0x9f, 0x53, 0x93, 0x63, 0x50, 0xef, 0x14, 0xbb, 0x85, 0xb1,
		0x15, 0x6d, 0x75, 0xd2, 0x98, 0x62, 0xe0, 0x47, 0xd6, 0x31, 0x3e, 0x64, 0x40, 0xfd, 0xef, 0x1a,
		0xac, 0xf6, 0xb7, 0xba, 0x3c, 0xda, 0x14, 0xa6, 0x5a, 0x0a, 0x53, 0x74, 0x0f, 0x66, 0x82, 0x5a,
		0xa2, 0x62, 0xd1, 0xea, 0x09, 0x0e, 0xd2, 0xc9, 0xa5, 0xd4, 0x33, 0x60, 0x09, 0x7f, 0xab, 0xe6,
		0x55, 0x8c, 0x69, 0x49, 0xb5, 0x25, 0x88, 0xd0, 0x43, 0x98, 0x69, 0x09, 0x0b, 0x98, 0x72, 0x25,
		0x3d, 0x39, 0xab, 0x0c, 0x66, 0x4c, 0xb7, 0x22, 0xdf, 0xfa, 0x17, 0x1a, 0x5c, 0xda, 0xc5, 0xd4,
		0xe8, 0x96, 0x74, 0x0f, 0x30, 0x21, 0xd6, 0x31, 0x26, 0x81, 0x67, 0xbd, 0x0f, 0x63, 0x7c, 0x63,
		0xc2, 0x59, 0x73, 0xe5, 0x55, 0x95, 0xa4, 0x10, 0x0f, 0xbe, 0x69, 0x43, 0xd2, 0x0d, 0x70, 0xf5,
		0xf4, 0xcf, 0x33, 0x70, 0x59, 0xa5, 0x86, 0x34, 0xb5, 0x07, 0xd3, 0xe2, 0x6e, 0xd7, 0xe5, 0x8a,
		0xd4, 0x67, 0x4f, 0x91, 0x90, 0x7b, 0xb3, 0x13, 0xd9, 0x38, 0x80, 0x8a, 0xa4, 0x3c, 0x45, 0xc2,
		0xb0, 0x62, 0x1d, 0x50, 0x12, 0x29, 0x25, 0x45, 0x6f, 0x86, 0x53, 0x74, 0xae, 0xfc, 0xc6, 0x00,
		0xf6, 0xe9, 0x68, 0x13, 0xca, 0xe7, 0x2e, 0xac, 0xec, 0x62, 0xba, 0x73, 0xff, 0x71, 0x8f, 0xb3,
		0xf8, 0x00, 0x40, 0x24, 0x0e, 0xf7, 0xc8, 0x0b, 0xf6, 0x3f, 0x88, 0x3c, 0x16, 0xad, 0x78, 0x3a,
		0xe6, 0x01, 0x8e, 0xfd, 0x22, 0x7a, 0x1b, 0xae, 0xf6, 0x90, 0x27, 0x8d, 0x7e, 0x08, 0x73, 0xa1,
		0x6a, 0xdf, 0x64, 0xd4, 0x81, 0xdc, 0x1b, 0x03, 0xca, 0x35, 0x66, 0xfd, 0x28, 0x80, 0xe8, 0xff,
		0xd6, 0xe0, 0x1a, 0x93, 0xcd, 0x43, 0x54, 0x8f, 0xed, 0x3e, 0x81, 0xa5, 0x9a, 0x45, 0xa8, 0xe9,
		0x63, 0xea, 0x3b, 0xb8, 0x85, 0x3b, 0x67, 0x1f, 0xc4, 0xf7, 0x5c, 0x79, 0x39, 0x91, 0x18, 0xf7,
		0x5d, 0x7a, 0xfb, 0xad, 0x27, 0xcc, 0xac, 0xc6, 0x22, 0xa3, 0x36, 0x02, 0x62, 0xc9, 0x7d, 0xdf,
		0xee, 0xf0, 0x95, 0x61, 0x37, 0xca, 0x37, 0x33, 0x20, 0xdf, 0x47, 0x01, 0x71, 0x97, 0x6f, 0xdc,
		0xd1, 0xb3, 0x49, 0x47, 0xf7, 0xe0, 0x95, 0xde, 0x3b, 0x97, 0x86, 0xdf, 0x85, 0xf1, 0x90, 0x9f,
		0x0f, 0xed, 0x57, 0x1d, 0x62, 0xfd, 0x4f, 0x1a, 0xcc, 0x1b, 0xd8, 0x6a, 0x34, 0x6a, 0x6d, 0x1e,
		0x24, 0xc9, 0x4b, 0xca, 0x18, 0xb7, 0x60, 0x8c, 0x07, 0x78, 0x22, 0x03, 0x56, 0x9f, 0xc0, 0x27,
		0x91, 0xf5, 0x3c, 0x2c, 0xc4, 0xb4, 0x97, 0x35, 0xc0, 0x6f, 0x32, 0xb0, 0xb4, 0x69, 0xdb, 0x07,
		0xd8, 0xf2, 0xab, 0x27, 0x9b, 0x54, 0x94, 0xdb, 0x9d, 0x42, 0xa0, 0x01, 0xb3, 0x84, 0xaf, 0x98,
		0x56, 0xb0, 0x24, 0xdd, 0xf6, 0xae, 0x22, 0x5c, 0x28, 0x79, 0x95, 0x62, 0x60, 0x11, 0x2b, 0x66,
		0x48, 0x14, 0x8a, 0xae, 0xc3, 0x34, 0xc1, 0xd5, 0xa6, 0xcf, 0x0b, 0x37, 0x9e, 0x08, 0x44, 0x98,
		0x9b, 0x0a, 0xa0, 0x3c, 0x26, 0x16, 0x1d, 0x98, 0x4f, 0xe3, 0x17, 0x0e, 0x2b, 0x13, 0x22, 0xac,
		0xdc, 0x09, 0x87, 0x95, 0xe9, 0xf2, 0xf5, 0x54, 0x7b, 0xed, 0xbb, 0x36, 0x7e, 0x8e, 0x6d, 0xee,
		0x96, 0xbc, 0x1c, 0x09, 0x05, 0x94, 0x8b, 0x50, 0x4c, 0xdb, 0x94, 0xb4, 0x5f, 0x01, 0x16, 0x83,
		0x6a, 0x65, 0x5b, 0xf8, 0xa7, 0xdc, 0xaf, 0xfe, 0xc7, 0x2c, 0xe4, 0x13, 0x4b, 0xd2, 0x2d, 0x4f,
		0x60, 0x89, 0x34, 0x1b, 0x0d, 0xcf, 0xa7, 0xd8, 0x36, 0xab, 0x35, 0x07, 0xbb, 0xd4, 0x94, 0x19,
		0x25, 0xf0, 0xd3, 0x37, 0x53, 0x15, 0x3d, 0x08, 0xa8, 0xb6, 0x39, 0x91, 0xcc, 0x4a, 0xc4, 0xc8,
		0x93, 0xf4, 0x05, 0x96, 0xe9, 0xea, 0x98, 0xb5, 0x29, 0xe4, 0xc4, 0x69, 0xf0, 0x80, 0x97, 0xee,
		0x83, 0xdd, 0x7b, 0xf0, 0xa0, 0x83, 0xce, 0x43, 0xdd, 0x74, 0x3d, 0xf2, 0x8d, 0x5c, 0x98, 0x6d,
		0x30, 0xe6, 0x84, 0x32, 0x3a, 0xc1, 0x31, 0xcb, 0x5d, 0x62, 0xbb, 0x4f, 0x4b, 0x17, 0x33, 0x42,
		0xe9, 0x51, 0x97, 0x0d, 0xe3, 0x2c, 0x1d, 0xa2, 0x11, 0x85, 0x16, 0x4f, 0x61, 0x3e, 0x0d, 0x31,
		0xe5, 0xa4, 0xdf, 0x8b, 0x26, 0x10, 0x65, 0x60, 0x8d, 0xb1, 0x0b, 0x9f, 0xf5, 0xef, 0x32, 0xb0,
		0x68, 0x60, 0xcb, 0xde, 0xb9, 0xff, 0x38, 0x1e, 0x44, 0x37, 0x60, 0x84, 0x17, 0xb4, 0x1a, 0x77,
		0xa3, 0x2b, 0xca, 0xc6, 0xed, 0xfe, 0x63, 0xee, 0x40, 0x1c, 0x39, 0x52, 0x48, 0x67, 0xa2, 0x85,
		0x34, 0x73, 0x74, 0xaf, 0xe9, 0x57, 0xb1, 0x29, 0xe3, 0x9a, 0x0c, 0x73, 0x53, 0x02, 0x2a, 0x8d,
		0x85, 0x0e, 0xa1, 0xe0, 0xb8, 0x0c, 0xc3, 0x69, 0x61, 0x93, 0x95, 0x77, 0xa1, 0x10, 0x3b, 0xd2,
		0x3f, 0xc4, 0x2e, 0x74, 0x88, 0xef, 0xba, 0xa1, 0x08, 0xfb, 0x42, 0x2a, 0xbc, 0x3f, 0x64, 0x20,
		0x9f, 0x30, 0x96, 0x74, 0xf0, 0x33, 0x59, 0x2b, 0x35, 0x4b, 0x66, 0xfe, 0xcb, 0x2c, 0x89, 0x2c,
		0x58, 0x4c, 0x70, 0x0d, 0xbb, 0xed, 0x50, 0x89, 0x7f, 0x3e, 0xce, 0x9e, 0xdf, 0x89, 0x14, 0x8b,
		0x8d, 0xa4, 0x59, 0xec, 0x4b, 0x0d, 0xf2, 0x8f, 0x9a, 0xfe, 0x31, 0xfe, 0x8a, 0xfb, 0x97, 0x5e,
		0x84, 0x42, 0x72, 0x9f, 0x32, 0x62, 0xfe, 0x3e, 0x03, 0xf9, 0x07, 0xf8, 0xab, 0x6f, 0x84, 0x17,
		0x73, 0xc9, 0xb6, 0xa0, 0x90, 0x34, 0xd6, 0x70, 0x5d, 0x93, 0xfe, 0x13, 0x0d, 0x96, 0x0d, 0x7c,
		0xe4, 0x63, 0x72, 0x12, 0xd4, 0x18, 0xdc, 0x77, 0x5f, 0xd2, 0x44, 0xf9, 0x32, 0x5c, 0x4c, 0xd7,
		0x46, 0x3a, 0xc8, 0x5f, 0x33, 0x70, 0xc9, 0xc0, 0x04, 0xbb, 0x76, 0xec, 0x06, 0x92, 0xd0, 0x48,
		0x53, 0x0e, 0xd3, 0x64, 0x01, 0x3b, 0x61, 0x8c, 0x0b, 0xc0, 0xbe, 0xfd, 0xbf, 0x2a, 0xbc, 0xae,
		0xc3, 0xb4, 0x8f, 0xeb, 0x1e, 0x4d, 0xb8, 0x92, 0x80, 0x06, 0xae, 0x14, 0xeb, 0xe8, 0x47, 0x5e,
		0x5c, 0x47, 0x3f, 0x7a, 0xf6, 0x8e, 0x5e, 0x5f, 0x81, 0xcb, 0x2a, 0x8b, 0x4a, 0xa3, 0x5b, 0xb0,
		0xbc, 0x8b, 0xe9, 0xb6, 0xef, 0x11, 0x22, 0xb7, 0x12, 0xb7, 0x78, 0x77, 0xb6, 0xa9, 0xc5, 0x66,
		0x9b, 0xd7, 0x61, 0x9a, 0x5a, 0xfe, 0x31, 0xa6, 0x1d, 0xd3, 0xc8, 0x9a, 0x4d, 0x40, 0x25, 0x3f,
		0xfd, 0x9f, 0x59, 0xb8, 0x98, 0x2e, 0x43, 0xfa, 0xf3, 0x29, 0xe3, 0xc3, 0xa2, 0x73, 0xa5, 0x2d,
		0x26, 0xad, 0x7d, 0x6a, 0xcd, 0x5e, 0xcc, 0xf8, 0x64, 0x89, 0x6c, 0xb5, 0x79, 0xeb, 0x29, 0x4a,
		0x8b, 0x49, 0x1a, 0x02, 0xa1, 0x1f, 0xc0, 0xc2, 0x91, 0xe5, 0xd4, 0x58, 0xfd, 0x65, 0x35, 0x09,
		0xee, 0xca, 0x14, 0x09, 0xe7, 0xc3, 0xb3, 0xc8, 0xbc, 0xc7, 0x19, 0x6e, 0x33, 0x7e, 0x11, 0xc9,
		0xe8, 0x28, 0xb1, 0x50, 0x7c, 0x0a, 0x73, 0x09, 0x15, 0x53, 0xba, 0xe2, 0x7b, 0xd1, 0xa2, 0xe6,
		0xa6, 0xea, 0xf8, 0xe3, 0x4a, 0xc9, 0x83, 0x0b, 0xb7, 0xc6, 0xc5, 0xa7, 0x90, 0x57, 0x68, 0x98,
		0x22, 0xf8, 0xfd, 0x68, 0xdd, 0xac, 0xf4, 0xbb, 0x5d, 0x4c, 0x99, 0xbc, 0x10, 0xe3, 0x70, 0x41,
		0xf5, 0xb9, 0x06, 0x79, 0xd6, 0xa8, 0xb5, 0x5d, 0xab, 0xee, 0x54, 0xb7, 0x3d, 0xf7, 0xc8, 0x39,
		0x0e, 0x7c, 0xea, 0x0a, 0xe4, 0xaa, 0x1c, 0x20, 0xba, 0x3c, 0x71, 0x8f, 0x41, 0x80, 0xf8, 0x20,
		0x71, 0x07, 0xce, 0x1f, 0x39, 0x35, 0x8a, 0xfd, 0xa0, 0x0a, 0x78, 0x5d, 0x55, 0x61, 0x86, 0xd9,
		0xdf, 0xe3, 0x24, 0x46, 0x40, 0xaa, 0x3f, 0x84, 0x42, 0x52, 0x83, 0x4e, 0x99, 0x22, 0x37, 0xa9,
		0x0d, 0xd2, 0x4c, 0x09, 0x5c, 0xfd, 0xa7, 0x1a, 0x14, 0x3f, 0x6e, 0xd8, 0x16, 0xc5, 0x67, 0xdb,
		0xd6, 0x47, 0x30, 0x25, 0x11, 0x38, 0xbf, 0x60, 0x73, 0xaf, 0x0d, 0xb2, 0x39, 0x91, 0x70, 0x26,
		0xab, 0xdd, 0x0f, 0xa2, 0x5f, 0x82, 0xe5, 0x54, 0x75, 0xe4, 0xcd, 0xfe, 0x82, 0x47, 0x7f, 0x16,
		0x15, 0xf0, 0xcb, 0x3c, 0x06, 0x1e, 0xf5, 0xd3, 0xb4, 0x90, 0x6a, 0xde, 0x81, 0xc2, 0x7d, 0x87,
		0x9c, 0xcd, 0x53, 0xf4, 0xef, 0xc1, 0x52, 0x0a, 0xb1, 0x3c, 0xe4, 0x6d, 0x38, 0x8f, 0x5d, 0xea,
		0x3b, 0x9d, 0x51, 0xd7, 0x40, 0x96, 0x16, 0x37, 0x37, 0xa0, 0xd4, 0x4f, 0x01, 0x25, 0x97, 0x11,
		0x82, 0x91, 0x90, 0x46, 0xfc, 0x37, 0xda, 0x84, 0x31, 0x79, 0xae, 0xd9, 0x61, 0xcf, 0x55, 0x12,
		0xea, 0x3f, 0xd7, 0x62, 0xd2, 0xf8, 0xf2, 0x99, 0xbc, 0xf5, 0x05, 0x9d, 0xde, 0x77, 0xe1, 0x42,
		0xca, 0x7a, 0xea, 0xfe, 0x37, 0xa2, 0x11, 0x6b, 0x20, 0x2d, 0xcb, 0x7f, 0xce, 0xc3, 0xf8, 0x26,
		0xd3, 0x64, 0xf3, 0xd1, 0x3e, 0xfa, 0x99, 0x06, 0x4b, 0xca, 0x27, 0x67, 0xf4, 0xf5, 0x3e, 0x6d,
		0xa6, 0xea, 0xe1, 0xbc, 0xf8, 0xf6, 0xf0, 0x84, 0xd2, 0x83, 0x3e, 0x83, 0x0b, 0x29, 0x4f, 0x84,
		0x68, 0xbd, 0x0f, 0xc3, 0xe4, 0xd3, 0x72, 0xb1, 0x3c, 0x0c, 0x89, 0x94, 0x1e, 0x36, 0x47, 0xe2,
		0x59, 0xb4, 0xaf, 0x39, 0x54, 0xef, 0xc2, 0x7d, 0xcd, 0xa1, 0x7e, 0xf5, 0xb5, 0x00, 0xba, 0xaf,
		0x7f, 0x68, 0x55, 0xc1, 0x27, 0xf1, 0xa0, 0x58, 0x7c, 0x6d, 0x00, 0xcc, 0xae, 0x88, 0xee, 0xcb,
		0x9a, 0x52, 0x44, 0xe2, 0xb1, 0x51, 0x29, 0x22, 0xf9, 0x4c, 0x27, 0x44, 0x04, 0x6f, 0x62, 0x3d,
		0x44, 0xc4, 0x1e, 0xf2, 0x7a, 0x88, 0x88, 0x3f, 0xb0, 0xa1, 0xef, 0xc3, 0x54, 0xe4, 0x29, 0x0b,
		0xbd, 0xd1, 0xc7, 0xe6, 0x11, 0x41, 0x6f, 0x0e, 0x86, 0x2c, 0x65, 0xfd, 0x56, 0xe3, 0x83, 0xef,
		0x9e, 0xef, 0x2d, 0xe8, 0x1b, 0xea, 0xaa, 0x66, 0x90, 0xe7, 0xb1, 0xe2, 0x37, 0xcf, 0x4c, 0x2f,
		0xb5, 0xfc, 0xb1, 0x06, 0x8b, 0xe9, 0x2f, 0x0a, 0xe8, 0xad, 0x21, 0x1f, 0x20, 0x84, 0x46, 0xb7,
		0xce, 0xf4, 0x6c, 0xc1, 0xef, 0x94, 0x72, 0x6c, 0xaf, 0xbc, 0x53, 0xfd, 0x1e, 0x16, 0x94, 0x77,
		0xaa, 0xff, 0x0b, 0xc1, 0xaf, 0x35, 0x5e, 0x1c, 0x2b, 0x27, 0xda, 0xe8, 0xdd, 0x1e, 0xac, 0xfb,
		0x3c, 0x00, 0x14, 0xef, 0x9c, 0x89, 0xb6, 0xeb, 0xc4, 0x91, 0xd1, 0xb1, 0xd2, 0x89, 0xd3, 0xc6,
		0xe3, 0x4a, 0x27, 0x4e, 0x9d, 0x46, 0xa3, 0x36, 0xa0, 0xe4, 0xac, 0x15, 0xdd, 0x1c, 0x76, 0xd6,
		0x5c, 0x5c, 0x1f, 0x82, 0x42, 0x8a, 0x6e, 0xc0, 0x4c, 0x6c, 0x50, 0x89, 0xbe, 0x36, 0xe8, 0x40,
		0x53, 0x08, 0x2d, 0x0d, 0x37, 0xff, 0x64, 0x12, 0x63, 0xe3, 0x33, 0xa5, 0xc4, 0xf4, 0x99, 0xa4,
		0x52, 0xa2, 0x6a, 0x2a, 0x47, 0x60, 0x36, 0x3e, 0x96, 0x41, 0x2a, 0x1e, 0x8a, 0x39, 0x55, 0x71,
		0x6d, 0x60, 0xfc, 0xae, 0xd0, 0xf8, 0x04, 0x43, 0x29, 0x54, 0x31, 0x17, 0x52, 0x0a, 0x55, 0x8e,
		0x46, 0x7e, 0x08, 0xf3, 0x69, 0x33, 0x06, 0x54, 0x56, 0x5a, 0x4c, 0x39, 0x1e, 0x29, 0x6e, 0x0c,
		0x45, 0x13, 0x0a, 0x74, 0xe9, 0x2d, 0xb7, 0x32, 0xd0, 0xf5, 0x9c, 0x79, 0x28, 0x03, 0x5d, 0xef,
		0xbe, 0x9e, 0x19, 0x22, 0xad, 0x65, 0x55, 0x1a, 0xa2, 0xc7, 0x10, 0x40, 0x69, 0x88, 0x9e, 0x4d,
		0x3d, 0x81, 0xd9, 0x78, 0xfb, 0xa5, 0x3c, 0x7e, 0x45, 0xa7, 0xa8, 0x3c, 0x7e, 0x65, 0x5f, 0xf7,
		0x19, 0x5c, 0x48, 0x69, 0x89, 0x94, 0x05, 0x9b, 0xba, 0x9b, 0x53, 0x16, 0x6c, 0x3d, 0x3a, 0x2e,
		0xe1, 0x7c, 0xc9, 0x56, 0xa7, 0x87, 0xf3, 0x29, 0xbb, 0xb3, 0x1e, 0xce, 0xa7, 0xee, 0xa5, 0x50,
		0x0b, 0xe6, 0x12, 0xed, 0x10, 0x52, 0x19, 0x51, 0xd5, 0x75, 0x15, 0x6f, 0x0e, 0x4e, 0x20, 0xe4,
		0x6e, 0xdd, 0xfa, 0xf6, 0xc6, 0xb1, 0x43, 0x4f, 0x9a, 0x95, 0x52, 0xd5, 0xab, 0xaf, 0x45, 0xfe,
		0xf6, 0x5a, 0x3a, 0xc6, 0xae, 0xf8, 0x67, 0x6f, 0xe7, 0x6f, 0xc3, 0x77, 0xf8, 0x8f, 0xd6, 0x7a,
		0x65, 0x8c, 0xc3, 0x37, 0xfe, 0x13, 0x00, 0x00, 0xff, 0xff, 0x8b, 0xc2, 0xab, 0xa6, 0x5e, 0x2c,
		0x00, 0x00,
	},
	// google/protobuf/timestamp.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0x92, 0x4f, 0xcf, 0xcf, 0x4f,
		0xcf, 0x49, 0xd5, 0x2f, 0x28, 0xca, 0x2f, 0xc9, 0x4f, 0x2a, 0x4d, 0xd3, 0x2f, 0xc9, 0xcc, 0x4d,
		0x2d, 0x2e, 0x49, 0xcc, 0x2d, 0xd0, 0x03, 0x0b, 0x09, 0xf1, 0x43, 0x14, 0xe8, 0xc1, 0x14, 0x28,
		0x59, 0x73, 0x71, 0x86, 0xc0, 0xd4, 0x08, 0x49, 0x70, 0xb1, 0x17, 0xa7, 0x26, 0xe7, 0xe7, 0xa5,
		0x14, 0x4b, 0x30, 0x2a, 0x30, 0x6a, 0x30, 0x07, 0xc1, 0xb8, 0x42, 0x22, 0x5c, 0xac, 0x79, 0x89,
		0x79, 0xf9, 0xc5, 0x12, 0x4c, 0x0a, 0x8c, 0x1a, 0xac, 0x41, 0x10, 0x8e, 0x53, 0x2b, 0x23, 0x97,
		0x70, 0x72, 0x7e, 0xae, 0x1e, 0x9a, 0xa1, 0x4e, 0x7c, 0x70, 0x23, 0x03, 0x40, 0x42, 0x01, 0x8c,
		0x51, 0x46, 0x50, 0x25, 0xe9, 0xf9, 0x39, 0x89, 0x79, 0xe9, 0x7a, 0xf9, 0x45, 0xe9, 0x48, 0x6e,
		0xac, 0x2c, 0x48, 0x2d, 0xd6, 0xcf, 0xce, 0xcb, 0x2f, 0xcf, 0x43, 0xb8, 0xb7, 0x20, 0xe9, 0x07,
		0x23, 0xe3, 0x22, 0x26, 0x66, 0xf7, 0x00, 0xa7, 0x55, 0x4c, 0x72, 0xee, 0x10, 0xdd, 0x01, 0x50,
		0x2d, 0x7a, 0xe1, 0xa9, 0x39, 0x39, 0xde, 0x20, 0x0d, 0x21, 0x20, 0xbd, 0x49, 0x6c, 0x60, 0xb3,
		0x8c, 0x01, 0x01, 0x00, 0x00, 0xff, 0xff, 0xae, 0x65, 0xce, 0x7d, 0xff, 0x00, 0x00, 0x00,
	},
	// google/protobuf/wrappers.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0x92, 0x4b, 0xcf, 0xcf, 0x4f,
		0xcf, 0x49, 0xd5, 0x2f, 0x28, 0xca, 0x2f, 0xc9, 0x4f, 0x2a, 0x4d, 0xd3, 0x2f, 0x2f, 0x4a, 0x2c,
		0x28, 0x48, 0x2d, 0x2a, 0xd6, 0x03, 0x8b, 0x08, 0xf1, 0x43, 0xe4, 0xf5, 0x60, 0xf2, 0x4a, 0xca,
		0x5c, 0xdc, 0x2e, 0xf9, 0xa5, 0x49, 0x39, 0xa9, 0x61, 0x89, 0x39, 0xa5, 0xa9, 0x42, 0x22, 0x5c,
		0xac, 0x65, 0x20, 0x86, 0x04, 0xa3, 0x02, 0xa3, 0x06, 0x63, 0x10, 0x84, 0xa3, 0xa4, 0xc4, 0xc5,
		0xe5, 0x96, 0x93, 0x9f, 0x58, 0x82, 0x45, 0x0d, 0x13, 0x92, 0x1a, 0xcf, 0xbc, 0x12, 0x33, 0x13,
		0x2c, 0x6a, 0x98, 0x61, 0x6a, 0x94, 0xb9, 0xb8, 0x43, 0x71, 0x29, 0x62, 0x41, 0x35, 0xc8, 0xd8,
		0x08, 0x8b, 0x1a, 0x56, 0x34, 0x83, 0xb0, 0x2a, 0xe2, 0x85, 0x29, 0x52, 0xe4, 0xe2, 0x74, 0xca,
		0xcf, 0xcf, 0xc1, 0xa2, 0x84, 0x03, 0xc9, 0x9c, 0xe0, 0x92, 0xa2, 0xcc, 0xbc, 0x74, 0x2c, 0x8a,
		0x38, 0x91, 0x1c, 0xe4, 0x54, 0x59, 0x92, 0x5a, 0x8c, 0x45, 0x0d, 0x0f, 0x54, 0x8d, 0x53, 0x33,
		0x23, 0x97, 0x70, 0x72, 0x7e, 0xae, 0x1e, 0x5a, 0xf0, 0x3a, 0xf1, 0x86, 0x43, 0xc3, 0x3f, 0x00,
		0x24, 0x12, 0xc0, 0x18, 0x65, 0x08, 0x55, 0x91, 0x9e, 0x9f, 0x93, 0x98, 0x97, 0xae, 0x97, 0x5f,
		0x94, 0x8e, 0x88, 0xab, 0x92, 0xca, 0x82, 0xd4, 0x62, 0xfd, 0xec, 0xbc, 0xfc, 0xf2, 0x3c, 0x78,
		0xbc, 0x15, 0x24, 0xfd, 0x60, 0x64, 0x5c, 0xc4, 0xc4, 0xec, 0x1e, 0xe0, 0xb4, 0x8a, 0x49, 0xce,
		0x1d, 0xa2, 0x39, 0x00, 0xaa, 0x43, 0x2f, 0x3c, 0x35, 0x27, 0xc7, 0x1b, 0xa4, 0x3e, 0x04, 0xa4,
		0x35, 0x89, 0x0d, 0x6c, 0x94, 0x31, 0x20, 0x00, 0x00, 0xff, 0xff, 0x3c, 0x92, 0x48, 0x30, 0x06,
		0x02, 0x00, 0x00,
	},
	// uber/cadence/api/v1/common.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xbc, 0x55, 0x4f, 0x6f, 0xdb, 0x36,
		0x14, 0x9f, 0xe2, 0xda, 0x49, 0x9f, 0xdd, 0xd4, 0x63, 0xd6, 0xd4, 0xc9, 0xfe, 0x79, 0x06, 0x86,
		0x66, 0x3b, 0x48, 0x88, 0x7b, 0x29, 0x56, 0x14, 0x83, 0x13, 0x3b, 0xab, 0xda, 0x2d, 0x31, 0x64,
		0x23, 0xc1, 0x76, 0x98, 0x40, 0x4b, 0x4f, 0x2e, 0x67, 0x89, 0x14, 0x28, 0xca, 0x89, 0x6f, 0xfb,
		0x24, 0x3b, 0xec, 0x2b, 0xed, 0x0b, 0x0d, 0x94, 0xe8, 0xd8, 0xee, 0x3c, 0xf4, 0x32, 0xec, 0x46,
		0xbe, 0xdf, 0x9f, 0xf7, 0xa3, 0xf0, 0x48, 0x41, 0x3b, 0x9f, 0xa0, 0x74, 0x02, 0x1a, 0x22, 0x0f,
		0xd0, 0xa1, 0x29, 0x73, 0xe6, 0xa7, 0x4e, 0x20, 0x92, 0x44, 0x70, 0x3b, 0x95, 0x42, 0x09, 0x72,
		0xa0, 0x19, 0xb6, 0x61, 0xd8, 0x34, 0x65, 0xf6, 0xfc, 0xf4, 0xf8, 0x8b, 0xa9, 0x10, 0xd3, 0x18,
		0x9d, 0x82, 0x32, 0xc9, 0x23, 0x27, 0xcc, 0x25, 0x55, 0x6c, 0x29, 0xea, 0xbc, 0x85, 0x8f, 0x6f,
		0x84, 0x9c, 0x45, 0xb1, 0xb8, 0x1d, 0xdc, 0x61, 0x90, 0x6b, 0x88, 0x7c, 0x09, 0xf5, 0x5b, 0x53,
		0xf4, 0x59, 0xd8, 0xb2, 0xda, 0xd6, 0xc9, 0x43, 0x0f, 0x96, 0x25, 0x37, 0x24, 0x4f, 0xa0, 0x26,
		0x73, 0xae, 0xb1, 0x9d, 0x02, 0xab, 0xca, 0x9c, 0xbb, 0x61, 0xa7, 0x03, 0x8d, 0xa5, 0xd9, 0x78,
		0x91, 0x22, 0x21, 0xf0, 0x80, 0xd3, 0x04, 0x8d, 0x41, 0xb1, 0xd6, 0x9c, 0x5e, 0xa0, 0xd8, 0x9c,
		0xa9, 0xc5, 0xbf, 0x72, 0x3e, 0x87, 0xdd, 0x21, 0x5d, 0xc4, 0x82, 0x86, 0x1a, 0x0e, 0xa9, 0xa2,
		0x05, 0xdc, 0xf0, 0x8a, 0x75, 0xe7, 0x25, 0xec, 0x5e, 0x50, 0x16, 0xe7, 0x12, 0xc9, 0x21, 0xd4,
		0x24, 0xd2, 0x4c, 0x70, 0xa3, 0x37, 0x3b, 0xd2, 0x82, 0xdd, 0x10, 0x15, 0x65, 0x71, 0x56, 0x24,
		0x6c, 0x78, 0xcb, 0x6d, 0xe7, 0x0f, 0x0b, 0x1e, 0xfc, 0x84, 0x89, 0x20, 0xaf, 0xa0, 0x16, 0x31,
		0x8c, 0xc3, 0xac, 0x65, 0xb5, 0x2b, 0x27, 0xf5, 0xee, 0xd7, 0xf6, 0x96, 0xef, 0x67, 0x6b, 0xaa,
		0x7d, 0x51, 0xf0, 0x06, 0x5c, 0xc9, 0x85, 0x67, 0x44, 0xc7, 0x37, 0x50, 0x5f, 0x2b, 0x93, 0x26,
		0x54, 0x66, 0xb8, 0x30, 0x29, 0xf4, 0x92, 0x74, 0xa1, 0x3a, 0xa7, 0x71, 0x8e, 0x45, 0x80, 0x7a,
		0xf7, 0xb3, 0xad, 0xf6, 0xe6, 0x98, 0x5e, 0x49, 0xfd, 0x6e, 0xe7, 0x85, 0xd5, 0xf9, 0xd3, 0x82,
		0xda, 0x6b, 0xa4, 0x21, 0x4a, 0xf2, 0xfd, 0x7b, 0x11, 0x9f, 0x6d, 0xf5, 0x28, 0xc9, 0xff, 0x6f,
		0xc8, 0xbf, 0x2c, 0x68, 0x8e, 0x90, 0xca, 0xe0, 0x5d, 0x4f, 0x29, 0xc9, 0x26, 0xb9, 0xc2, 0x8c,
		0xf8, 0xb0, 0xcf, 0x78, 0x88, 0x77, 0x18, 0xfa, 0x1b, 0xb1, 0x5f, 0x6c, 0x75, 0x7d, 0x5f, 0x6e,
		0xbb, 0xa5, 0x76, 0xfd, 0x1c, 0x8f, 0xd8, 0x7a, 0xed, 0xf8, 0x57, 0x20, 0xff, 0x24, 0xfd, 0x87,
		0xa7, 0x8a, 0x60, 0xaf, 0x4f, 0x15, 0x3d, 0x8b, 0xc5, 0x84, 0x5c, 0xc0, 0x23, 0xe4, 0x81, 0x08,
		0x19, 0x9f, 0xfa, 0x6a, 0x91, 0x96, 0x03, 0xba, 0xdf, 0xfd, 0x6a, 0xab, 0xd7, 0xc0, 0x30, 0xf5,
		0x44, 0x7b, 0x0d, 0x5c, 0xdb, 0xdd, 0x0f, 0xf0, 0xce, 0xda, 0x00, 0x0f, 0xcb, 0x4b, 0x87, 0xf2,
		0x1a, 0x65, 0xc6, 0x04, 0x77, 0x79, 0x24, 0x34, 0x91, 0x25, 0x69, 0xbc, 0xbc, 0x08, 0x7a, 0x4d,
		0x9e, 0xc1, 0xe3, 0x08, 0xa9, 0xca, 0x25, 0xfa, 0xf3, 0x92, 0x6a, 0x2e, 0xdc, 0xbe, 0x29, 0x1b,
		0x83, 0xce, 0x5b, 0x78, 0x3a, 0xca, 0xd3, 0x54, 0x48, 0x85, 0xe1, 0x79, 0xcc, 0x90, 0x2b, 0x83,
		0x64, 0xfa, 0xae, 0x4e, 0x85, 0x9f, 0x85, 0x33, 0xe3, 0x5c, 0x9d, 0x8a, 0x51, 0x38, 0x23, 0x47,
		0xb0, 0xf7, 0x1b, 0x9d, 0xd3, 0x02, 0x28, 0x3d, 0x77, 0xf5, 0x7e, 0x14, 0xce, 0x3a, 0xbf, 0x57,
		0xa0, 0xee, 0xa1, 0x92, 0x8b, 0xa1, 0x88, 0x59, 0xb0, 0x20, 0x7d, 0x68, 0x32, 0xce, 0x14, 0xa3,
		0xb1, 0xcf, 0xb8, 0x42, 0x39, 0xa7, 0x65, 0xca, 0x7a, 0xf7, 0xc8, 0x2e, 0x9f, 0x17, 0x7b, 0xf9,
		0xbc, 0xd8, 0x7d, 0xf3, 0xbc, 0x78, 0x8f, 0x8d, 0xc4, 0x35, 0x0a, 0xe2, 0xc0, 0xc1, 0x84, 0x06,
		0x33, 0x11, 0x45, 0x7e, 0x20, 0x30, 0x8a, 0x58, 0xa0, 0x63, 0x16, 0xbd, 0x2d, 0x8f, 0x18, 0xe8,
		0x7c, 0x85, 0xe8, 0xb6, 0x09, 0xbd, 0x63, 0x49, 0x9e, 0xac, 0xda, 0x56, 0x3e, 0xd8, 0xd6, 0x48,
		0xee, 0xdb, 0x7e, 0xb3, 0x72, 0xa1, 0x4a, 0x61, 0x92, 0xaa, 0xac, 0xf5, 0xa0, 0x6d, 0x9d, 0x54,
		0xef, 0xa9, 0x3d, 0x53, 0x26, 0xaf, 0xe0, 0x53, 0x2e, 0xb8, 0x2f, 0xf5, 0xd1, 0xe9, 0x24, 0x46,
		0x1f, 0xa5, 0x14, 0xd2, 0x2f, 0x9f, 0x94, 0xac, 0x55, 0x6d, 0x57, 0x4e, 0x1e, 0x7a, 0x2d, 0x2e,
		0xb8, 0xb7, 0x64, 0x0c, 0x34, 0xc1, 0x2b, 0x71, 0xf2, 0x06, 0x0e, 0xf0, 0x2e, 0x65, 0x65, 0x90,
		0x55, 0xe4, 0xda, 0x87, 0x22, 0x93, 0x95, 0x6a, 0x99, 0xfa, 0xdb, 0x5b, 0x68, 0xac, 0xcf, 0x14,
		0x39, 0x82, 0x27, 0x83, 0xcb, 0xf3, 0xab, 0xbe, 0x7b, 0xf9, 0x83, 0x3f, 0xfe, 0x79, 0x38, 0xf0,
		0xdd, 0xcb, 0xeb, 0xde, 0x8f, 0x6e, 0xbf, 0xf9, 0x11, 0x39, 0x86, 0xc3, 0x4d, 0x68, 0xfc, 0xda,
		0x73, 0x2f, 0xc6, 0xde, 0x4d, 0xd3, 0x22, 0x87, 0x40, 0x36, 0xb1, 0x37, 0xa3, 0xab, 0xcb, 0xe6,
		0x0e, 0x69, 0xc1, 0x27, 0x9b, 0xf5, 0xa1, 0x77, 0x35, 0xbe, 0x7a, 0xde, 0xac, 0x9c, 0x5d, 0xc3,
		0xd3, 0x40, 0x24, 0xdb, 0x86, 0xfc, 0x6c, 0xaf, 0x97, 0xb2, 0xa1, 0x4e, 0x3f, 0xb4, 0x7e, 0x71,
		0xa6, 0x4c, 0xbd, 0xcb, 0x27, 0x76, 0x20, 0x12, 0x67, 0xe3, 0xc7, 0x64, 0x4f, 0x91, 0x97, 0x3f,
		0x1b, 0xf3, 0x8f, 0x7a, 0x49, 0x53, 0x36, 0x3f, 0x9d, 0xd4, 0x8a, 0xda, 0xf3, 0xbf, 0x03, 0x00,
		0x00, 0xff, 0xff, 0xdc, 0x8c, 0x77, 0x9a, 0xc7, 0x06, 0x00, 0x00,
	},
	// google/protobuf/duration.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0x92, 0x4b, 0xcf, 0xcf, 0x4f,
		0xcf, 0x49, 0xd5, 0x2f, 0x28, 0xca, 0x2f, 0xc9, 0x4f, 0x2a, 0x4d, 0xd3, 0x4f, 0x29, 0x2d, 0x4a,
		0x2c, 0xc9, 0xcc, 0xcf, 0xd3, 0x03, 0x8b, 0x08, 0xf1, 0x43, 0xe4, 0xf5, 0x60, 0xf2, 0x4a, 0x56,
		0x5c, 0x1c, 0x2e, 0x50, 0x25, 0x42, 0x12, 0x5c, 0xec, 0xc5, 0xa9, 0xc9, 0xf9, 0x79, 0x29, 0xc5,
		0x12, 0x8c, 0x0a, 0x8c, 0x1a, 0xcc, 0x41, 0x30, 0xae, 0x90, 0x08, 0x17, 0x6b, 0x5e, 0x62, 0x5e,
		0x7e, 0xb1, 0x04, 0x93, 0x02, 0xa3, 0x06, 0x6b, 0x10, 0x84, 0xe3, 0xd4, 0xcc, 0xc8, 0x25, 0x9c,
		0x9c, 0x9f, 0xab, 0x87, 0x66, 0xa6, 0x13, 0x2f, 0xcc, 0xc4, 0x00, 0x90, 0x48, 0x00, 0x63, 0x94,
		0x21, 0x54, 0x45, 0x7a, 0x7e, 0x4e, 0x62, 0x5e, 0xba, 0x5e, 0x7e, 0x51, 0x3a, 0xc2, 0x81, 0x25,
		0x95, 0x05, 0xa9, 0xc5, 0xfa, 0xd9, 0x79, 0xf9, 0xe5, 0x79, 0x70, 0xc7, 0x16, 0x24, 0xfd, 0x60,
		0x64, 0x5c, 0xc4, 0xc4, 0xec, 0x1e, 0xe0, 0xb4, 0x8a, 0x49, 0xce, 0x1d, 0xa2, 0x39, 0x00, 0xaa,
		0x43, 0x2f, 0x3c, 0x35, 0x27, 0xc7, 0x1b, 0xa4, 0x3e, 0x04, 0xa4, 0x35, 0x89, 0x0d, 0x6c, 0x94,
		0x31, 0x20, 0x00, 0x00, 0xff, 0xff, 0xef, 0x8a, 0xb4, 0xc3, 0xfb, 0x00, 0x00, 0x00,
	},
	// uber/cadence/api/v1/visibility.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x84, 0x92, 0xcd, 0x6e, 0xd3, 0x40,
		0x14, 0x85, 0x71, 0x68, 0x23, 0xb8, 0x29, 0x60, 0x0d, 0x82, 0x80, 0x2b, 0x08, 0xb2, 0x58, 0x54,
		0x2c, 0xc6, 0x4a, 0x59, 0x76, 0x81, 0x12, 0x3c, 0xa0, 0x11, 0x21, 0x09, 0x8e, 0x9b, 0x12, 0x36,
		0xd6, 0xd8, 0x9e, 0x86, 0x11, 0xb6, 0xc7, 0xb2, 0xc7, 0x6e, 0xfb, 0x14, 0xbc, 0x27, 0x4f, 0x81,
		0xfc, 0x87, 0x84, 0x70, 0xc5, 0xce, 0x3e, 0xf7, 0x9c, 0x4f, 0x73, 0x7f, 0xe0, 0x75, 0xe1, 0xf3,
		0xcc, 0x0a, 0x58, 0xc8, 0x93, 0x80, 0x5b, 0x2c, 0x15, 0x56, 0x39, 0xb5, 0x4a, 0x91, 0x0b, 0x5f,
		0x44, 0x42, 0xdd, 0xe0, 0x34, 0x93, 0x4a, 0xa2, 0xc7, 0x95, 0x0b, 0xb7, 0x2e, 0xcc, 0x52, 0x81,
		0xcb, 0xa9, 0x31, 0xd9, 0x4b, 0xb9, 0x8f, 0xb8, 0x55, 0x5b, 0xfc, 0xe2, 0xd2, 0x52, 0x22, 0xe6,
		0xb9, 0x62, 0x71, 0xda, 0xa4, 0x0c, 0xb3, 0x8f, 0x7d, 0x25, 0xb3, 0x1f, 0x97, 0x91, 0xbc, 0x6a,
		0x3c, 0xe6, 0x17, 0x18, 0x5f, 0xb4, 0x0a, 0xb9, 0xe6, 0x41, 0xa1, 0x84, 0x4c, 0x3e, 0x88, 0x48,
		0xf1, 0x0c, 0x4d, 0x60, 0xd4, 0x99, 0x3d, 0x11, 0x3e, 0xd3, 0x5e, 0x69, 0x27, 0xf7, 0x1d, 0xe8,
		0x24, 0x1a, 0xa2, 0x27, 0x30, 0xcc, 0x8a, 0xa4, 0xaa, 0x0d, 0xea, 0xda, 0x61, 0x56, 0x24, 0x34,
		0x34, 0x4f, 0x00, 0x75, 0x48, 0xf7, 0x26, 0xe5, 0x2d, 0x0d, 0xc1, 0x41, 0xc2, 0x62, 0xde, 0x62,
		0xea, 0x6f, 0xf3, 0xa7, 0x06, 0x8f, 0x36, 0x8a, 0x65, 0xca, 0x15, 0x71, 0xe7, 0x7b, 0x07, 0x0f,
		0x38, 0xcb, 0x22, 0xc1, 0x73, 0xe5, 0x55, 0x0d, 0xd5, 0x81, 0xd1, 0xa9, 0x81, 0x9b, 0x6e, 0x71,
		0xd7, 0x2d, 0x76, 0xbb, 0x6e, 0x9d, 0xa3, 0x2e, 0x50, 0x49, 0xe8, 0x0c, 0x46, 0x11, 0x53, 0x7f,
		0xe2, 0x83, 0xff, 0xc6, 0xa1, 0xb1, 0x57, 0x82, 0xb9, 0x83, 0xa3, 0x8d, 0x62, 0xaa, 0xc8, 0xdb,
		0xd7, 0x50, 0x18, 0xe6, 0xf5, 0x7f, 0xfd, 0x8c, 0x87, 0xa7, 0x53, 0xdc, 0xb3, 0x09, 0xfc, 0xcf,
		0x04, 0xdf, 0x47, 0x32, 0xe7, 0x0d, 0xc8, 0x69, 0x01, 0x6f, 0x7e, 0x69, 0xa0, 0xd3, 0x24, 0xe4,
		0xd7, 0x3c, 0xdc, 0xb2, 0xa8, 0xe0, 0xd5, 0x6c, 0xd0, 0x4b, 0x30, 0xe8, 0xd2, 0x26, 0x5f, 0x89,
		0xed, 0x6d, 0x67, 0x8b, 0x73, 0xe2, 0xb9, 0xbb, 0x35, 0xf1, 0xe8, 0x72, 0x3b, 0x5b, 0x50, 0x5b,
		0xbf, 0x83, 0x5e, 0xc0, 0xf3, 0x9e, 0xfa, 0xc6, 0x75, 0xe8, 0xf2, 0xa3, 0xae, 0xdd, 0x12, 0xff,
		0x44, 0x76, 0x17, 0x2b, 0xc7, 0xd6, 0x07, 0xc8, 0x80, 0xa7, 0xbd, 0x78, 0x57, 0xbf, 0x7b, 0x0b,
		0xda, 0x5e, 0x9d, 0xcf, 0x17, 0x44, 0x3f, 0x40, 0xc7, 0x30, 0xee, 0x29, 0xcf, 0x57, 0xab, 0x85,
		0x7e, 0x88, 0x26, 0x70, 0xdc, 0x97, 0x9d, 0xb9, 0xc4, 0xa5, 0x9f, 0x89, 0x3e, 0x9c, 0x6f, 0x61,
		0x1c, 0xc8, 0xb8, 0x6f, 0x58, 0xf3, 0x7b, 0xb3, 0x54, 0xac, 0xab, 0x2d, 0xac, 0xb5, 0x6f, 0xd6,
		0x5e, 0xa8, 0xef, 0x85, 0x8f, 0x03, 0x19, 0x5b, 0x7f, 0x1d, 0x2b, 0xde, 0xf3, 0xa4, 0x39, 0xec,
		0xf6, 0x6e, 0xcf, 0x58, 0x2a, 0xca, 0xa9, 0x3f, 0xac, 0xb5, 0xb7, 0xbf, 0x03, 0x00, 0x00, 0xff,
		0xff, 0xd7, 0x22, 0x00, 0x73, 0x37, 0x03, 0x00, 0x00,
	},
	// uber/cadence/api/v1/workflow.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xc4, 0x59, 0x4d, 0x6f, 0xdb, 0xca,
		0xd5, 0x7e, 0x29, 0xd9, 0x8e, 0x7d, 0xe4, 0x0f, 0x7a, 0x1c, 0xc7, 0xca, 0xb7, 0xa3, 0xfb, 0x26,
		0x71, 0xd4, 0x1b, 0xf9, 0x3a, 0xb9, 0xb9, 0x69, 0x6e, 0x9a, 0xa6, 0x34, 0x49, 0xc7, 0x4c, 0x64,
		0x4a, 0x1d, 0x51, 0x71, 0x7c, 0x51, 0x94, 0xa0, 0xa5, 0xb1, 0x4d, 0x44, 0x22, 0x05, 0x72, 0x94,
		0xc4, 0xfb, 0x02, 0x5d, 0x77, 0x57, 0xb4, 0x9b, 0xfe, 0x80, 0x02, 0x45, 0x7f, 0x40, 0xd1, 0xa2,
		0x8b, 0xee, 0xba, 0xed, 0xb2, 0xfb, 0xfe, 0x8b, 0x62, 0x86, 0x43, 0x89, 0xb2, 0x3e, 0xa8, 0xb4,
		0xc0, 0xed, 0xce, 0x3c, 0x7c, 0x9e, 0x87, 0x67, 0xce, 0x9c, 0xf3, 0x70, 0x68, 0x41, 0xa1, 0x7b,
		0x4c, 0x82, 0xed, 0x86, 0xd3, 0x24, 0x5e, 0x83, 0x6c, 0x3b, 0x1d, 0x77, 0xfb, 0xc3, 0xce, 0xf6,
		0x47, 0x3f, 0x78, 0x7f, 0xd2, 0xf2, 0x3f, 0x96, 0x3a, 0x81, 0x4f, 0x7d, 0xb4, 0xc6, 0x30, 0x25,
		0x81, 0x29, 0x39, 0x1d, 0xb7, 0xf4, 0x61, 0xe7, 0xda, 0xad, 0x53, 0xdf, 0x3f, 0x6d, 0x91, 0x6d,
		0x0e, 0x39, 0xee, 0x9e, 0x6c, 0x37, 0xbb, 0x81, 0x43, 0x5d, 0xdf, 0x8b, 0x48, 0xd7, 0x6e, 0x5f,
		0xbc, 0x4f, 0xdd, 0x36, 0x09, 0xa9, 0xd3, 0xee, 0x08, 0xc0, 0xe6, 0xa8, 0x27, 0x37, 0xfc, 0x76,
		0xbb, 0x27, 0x31, 0x32, 0x37, 0xea, 0x84, 0xef, 0x5b, 0x6e, 0x48, 0x23, 0x4c, 0xe1, 0x2f, 0x73,
		0xb0, 0x7e, 0x28, 0xd2, 0xd5, 0x3f, 0x91, 0x46, 0x97, 0xa5, 0x60, 0x78, 0x27, 0x3e, 0xaa, 0x03,
		0x8a, 0xd7, 0x61, 0x93, 0xf8, 0x4e, 0x5e, 0xda, 0x94, 0xb6, 0x72, 0x8f, 0xee, 0x95, 0x46, 0x2c,
		0xa9, 0x34, 0xa4, 0x83, 0x57, 0x3f, 0x5e, 0x0c, 0xa1, 0x27, 0x30, 0x43, 0xcf, 0x3b, 0x24, 0x9f,
		0xe1, 0x42, 0x77, 0x26, 0x0a, 0x59, 0xe7, 0x1d, 0x82, 0x39, 0x1c, 0x3d, 0x03, 0x08, 0xa9, 0x13,
		0x50, 0x9b, 0x95, 0x21, 0x9f, 0xe5, 0xe4, 0x6b, 0xa5, 0xa8, 0x46, 0xa5, 0xb8, 0x46, 0x25, 0x2b,
		0xae, 0x11, 0x5e, 0xe0, 0x68, 0x76, 0xcd, 0xa8, 0x8d, 0x96, 0x1f, 0x92, 0x88, 0x3a, 0x93, 0x4e,
		0xe5, 0x68, 0x4e, 0xb5, 0x60, 0x31, 0xa2, 0x86, 0xd4, 0xa1, 0xdd, 0x30, 0x3f, 0xbb, 0x29, 0x6d,
		0x2d, 0x3f, 0xda, 0x99, 0x6e, 0xf5, 0x2a, 0x63, 0xd6, 0x38, 0x11, 0xe7, 0x1a, 0xfd, 0x0b, 0x74,
		0x17, 0x96, 0xcf, 0xdc, 0x90, 0xfa, 0xc1, 0xb9, 0xdd, 0x22, 0xde, 0x29, 0x3d, 0xcb, 0xcf, 0x6d,
		0x4a, 0x5b, 0x59, 0xbc, 0x24, 0xa2, 0x65, 0x1e, 0x44, 0x3f, 0x83, 0xf5, 0x8e, 0x13, 0x10, 0x8f,
		0xf6, 0xcb, 0x6f, 0xbb, 0xde, 0x89, 0x9f, 0xbf, 0xc4, 0x97, 0xb0, 0x35, 0x32, 0x8b, 0x2a, 0x67,
		0x0c, 0xec, 0x24, 0x5e, 0xeb, 0x0c, 0x07, 0x91, 0x02, 0xcb, 0x7d, 0x59, 0x5e, 0x99, 0xf9, 0xd4,
		0xca, 0x2c, 0xf5, 0x18, 0xbc, 0x3a, 0x0f, 0x61, 0xa6, 0x4d, 0xda, 0x7e, 0x7e, 0x81, 0x13, 0xaf,
		0x8e, 0xcc, 0xe7, 0x80, 0xb4, 0x7d, 0xcc, 0x61, 0x08, 0xc3, 0x6a, 0x48, 0x9c, 0xa0, 0x71, 0x66,
		0x3b, 0x94, 0x06, 0xee, 0x71, 0x97, 0x92, 0x30, 0x0f, 0x9c, 0x7b, 0x77, 0x24, 0xb7, 0xc6, 0xd1,
		0x4a, 0x0f, 0x8c, 0xe5, 0xf0, 0x42, 0x04, 0x95, 0x61, 0xd5, 0xe9, 0x52, 0xdf, 0x0e, 0x48, 0x48,
		0xa8, 0xdd, 0xf1, 0x5d, 0x8f, 0x86, 0xf9, 0x1c, 0xd7, 0xdc, 0x1c, 0xa9, 0x89, 0x19, 0xb0, 0xca,
		0x71, 0x78, 0x85, 0x51, 0x13, 0x01, 0x74, 0x1d, 0x16, 0xd8, 0x78, 0xd8, 0x6c, 0x3e, 0xf2, 0x8b,
		0x9b, 0xd2, 0xd6, 0x02, 0x9e, 0x67, 0x81, 0xb2, 0x1b, 0x52, 0xb4, 0x01, 0x97, 0xdc, 0xd0, 0x6e,
		0x04, 0xbe, 0x97, 0x5f, 0xda, 0x94, 0xb6, 0xe6, 0xf1, 0x9c, 0x1b, 0xaa, 0x81, 0xef, 0x15, 0x7e,
		0x9d, 0x81, 0x5b, 0xc3, 0x9b, 0xef, 0x7b, 0x27, 0xee, 0xa9, 0x18, 0x69, 0xf4, 0x6d, 0x52, 0x38,
		0x1a, 0xa1, 0x9b, 0x23, 0xd3, 0xb3, 0xc4, 0xd3, 0x12, 0xcf, 0x75, 0x60, 0xb3, 0xbf, 0x51, 0x62,
		0x06, 0x7c, 0xbb, 0xdf, 0xd1, 0x7e, 0x97, 0x8a, 0x61, 0xba, 0x3a, 0xb4, 0x75, 0x9a, 0x48, 0x00,
		0xdf, 0xe8, 0x49, 0xd4, 0xf8, 0x5c, 0xf8, 0x6a, 0xdc, 0xe3, 0x7e, 0x97, 0xa2, 0x43, 0xb8, 0xce,
		0xd3, 0x1b, 0xa3, 0x9e, 0x4d, 0x53, 0xdf, 0x60, 0xec, 0x11, 0xc2, 0x85, 0xbf, 0x4b, 0xb0, 0x36,
		0xa2, 0x23, 0x59, 0xa1, 0x9b, 0x7e, 0xdb, 0x71, 0x3d, 0xdb, 0x6d, 0xf2, 0x7a, 0x2c, 0xe0, 0xf9,
		0x28, 0x60, 0x34, 0xd1, 0x6d, 0xc8, 0x89, 0x9b, 0x9e, 0xd3, 0x8e, 0x8c, 0x62, 0x01, 0x43, 0x14,
		0x32, 0x9d, 0x36, 0x19, 0xe3, 0x4c, 0xd9, 0xff, 0xd6, 0x99, 0xee, 0xc0, 0xa2, 0xeb, 0xb9, 0xd4,
		0x75, 0x28, 0x69, 0xb2, 0xbc, 0x66, 0xf8, 0x50, 0xe6, 0x7a, 0x31, 0xa3, 0x59, 0xf8, 0x95, 0x04,
		0xeb, 0xfa, 0x27, 0x4a, 0x02, 0xcf, 0x69, 0x7d, 0x2f, 0x6e, 0x79, 0x31, 0xa7, 0xcc, 0x70, 0x4e,
		0xff, 0x9c, 0x85, 0xb5, 0x2a, 0xf1, 0x9a, 0xae, 0x77, 0xaa, 0x34, 0xa8, 0xfb, 0xc1, 0xa5, 0xe7,
		0x3c, 0xa3, 0xdb, 0x90, 0x73, 0xc4, 0x75, 0xbf, 0xca, 0x10, 0x87, 0x8c, 0x26, 0xda, 0x83, 0xa5,
		0x1e, 0x20, 0xd5, 0x92, 0x63, 0x69, 0x6e, 0xc9, 0x8b, 0x4e, 0xe2, 0x0a, 0xbd, 0x84, 0x59, 0x66,
		0x8f, 0x91, 0x2b, 0x2f, 0x3f, 0x7a, 0x30, 0xda, 0x97, 0x06, 0x33, 0x64, 0x4e, 0x48, 0x70, 0xc4,
		0x43, 0x06, 0xac, 0x9e, 0x11, 0x27, 0xa0, 0xc7, 0xc4, 0xa1, 0x76, 0x93, 0x50, 0xc7, 0x6d, 0x85,
		0xc2, 0xa7, 0x6f, 0x8c, 0x31, 0xb9, 0xf3, 0x96, 0xef, 0x34, 0xb1, 0xdc, 0xa3, 0x69, 0x11, 0x0b,
		0xbd, 0x86, 0xb5, 0x96, 0x13, 0x52, 0xbb, 0xaf, 0xc7, 0xad, 0x6d, 0x36, 0xd5, 0xda, 0x56, 0x19,
		0x6d, 0x3f, 0x66, 0x71, 0x7b, 0xdb, 0x03, 0x1e, 0x8c, 0xa6, 0x82, 0x34, 0x23, 0xa5, 0xb9, 0x54,
		0xa5, 0x15, 0x46, 0xaa, 0x45, 0x1c, 0xae, 0x93, 0x87, 0x4b, 0x0e, 0xa5, 0xa4, 0xdd, 0xa1, 0xdc,
		0xb9, 0x67, 0x71, 0x7c, 0x89, 0x1e, 0x80, 0xdc, 0x76, 0x3e, 0xb9, 0xed, 0x6e, 0xdb, 0x16, 0xa1,
		0x90, 0xbb, 0xf0, 0x2c, 0x5e, 0x11, 0x71, 0x45, 0x84, 0x99, 0x5d, 0x87, 0x8d, 0x33, 0xd2, 0xec,
		0xb6, 0xe2, 0x4c, 0x16, 0xd2, 0xed, 0xba, 0xc7, 0xe0, 0x79, 0xa8, 0xb0, 0x42, 0x3e, 0x75, 0xdc,
		0x68, 0x66, 0x23, 0x0d, 0x48, 0xd5, 0x58, 0xee, 0x53, 0xb8, 0xc8, 0x4b, 0x58, 0xe4, 0x45, 0x39,
		0x71, 0xdc, 0x56, 0x37, 0x20, 0xc2, 0x6b, 0x47, 0x6f, 0xd3, 0x5e, 0x84, 0xc1, 0x39, 0xc6, 0x10,
		0x17, 0xe8, 0x2b, 0xb8, 0xcc, 0x05, 0x58, 0xaf, 0x93, 0xc0, 0x76, 0x9b, 0xc4, 0xa3, 0x2e, 0x3d,
		0x17, 0x76, 0x8b, 0xd8, 0xbd, 0x43, 0x7e, 0xcb, 0x10, 0x77, 0x0a, 0xbf, 0xcd, 0xc0, 0x55, 0xd1,
		0x3e, 0xea, 0x99, 0xdb, 0x6a, 0x7e, 0x2f, 0x83, 0xf7, 0x65, 0x42, 0x96, 0x0d, 0x47, 0xd2, 0x8b,
		0xe4, 0x8f, 0x89, 0xf3, 0x09, 0x77, 0xa4, 0x8b, 0x63, 0x9a, 0x1d, 0x1a, 0x53, 0xf4, 0x16, 0xc4,
		0x6b, 0x58, 0x98, 0x6b, 0xc7, 0x6f, 0xb9, 0x8d, 0x73, 0xde, 0xe6, 0xcb, 0x63, 0x12, 0x8d, 0x9c,
		0x93, 0x1b, 0x6a, 0x95, 0xa3, 0xf1, 0x6a, 0xe7, 0x62, 0xa8, 0xf0, 0xb7, 0x4c, 0x6f, 0xfc, 0x35,
		0xd2, 0x70, 0xc3, 0xb8, 0x2e, 0xbd, 0xa9, 0x94, 0xd2, 0xa7, 0x32, 0x26, 0x0e, 0x4c, 0xe5, 0x70,
		0xc7, 0x65, 0x3e, 0xb7, 0xe3, 0x5e, 0xc0, 0xe2, 0xc0, 0xf0, 0xa4, 0x1f, 0xdb, 0x72, 0xe1, 0xe8,
		0xc1, 0x99, 0x19, 0x1c, 0x1c, 0x0c, 0x1b, 0x7e, 0xe0, 0x9e, 0xba, 0x9e, 0xd3, 0xb2, 0x2f, 0x24,
		0x99, 0x3e, 0xea, 0xeb, 0x31, 0xb5, 0x96, 0x4c, 0xb6, 0xf0, 0xa7, 0x0c, 0x5c, 0x8d, 0xed, 0xa9,
		0xec, 0x37, 0x9c, 0x96, 0xe6, 0x86, 0x1d, 0x87, 0x36, 0xce, 0xa6, 0x73, 0xd3, 0xff, 0x7d, 0xb9,
		0x7e, 0x0e, 0xb7, 0x06, 0x33, 0xb0, 0xfd, 0x13, 0x9b, 0x9e, 0xb9, 0xa1, 0x9d, 0xac, 0xe2, 0x64,
		0xc1, 0x6b, 0x03, 0x19, 0x55, 0x4e, 0xac, 0x33, 0x37, 0x14, 0x1e, 0x84, 0x6e, 0x02, 0xf0, 0x53,
		0x02, 0xf5, 0xdf, 0x13, 0x8f, 0xd7, 0x79, 0x11, 0xf3, 0x63, 0x8d, 0xc5, 0x02, 0x85, 0xd7, 0x90,
		0x4b, 0x9e, 0xa5, 0x9e, 0xc3, 0x9c, 0x38, 0x8e, 0x49, 0x9b, 0xd9, 0xad, 0xdc, 0xa3, 0x2f, 0x52,
		0x8e, 0x63, 0xfc, 0xa4, 0x2a, 0x28, 0x85, 0x3f, 0x64, 0x60, 0x79, 0xf0, 0x16, 0xba, 0x0f, 0x2b,
		0xc7, 0xae, 0xe7, 0x04, 0xe7, 0x76, 0xe3, 0x8c, 0x34, 0xde, 0x87, 0xdd, 0xb6, 0xd8, 0x84, 0xe5,
		0x28, 0xac, 0x8a, 0x28, 0x5a, 0x87, 0xb9, 0xa0, 0xeb, 0xc5, 0x2f, 0xcb, 0x05, 0x3c, 0x1b, 0x74,
		0xd9, 0xa9, 0xe2, 0x05, 0x5c, 0x3f, 0x71, 0x83, 0x90, 0xbd, 0x60, 0xa2, 0x66, 0xb7, 0x1b, 0x7e,
		0xbb, 0xd3, 0x22, 0x03, 0x13, 0x9b, 0xe7, 0x90, 0x78, 0x1c, 0xd4, 0x18, 0xc0, 0xe9, 0x8b, 0x8d,
		0x80, 0x38, 0xbd, 0xbd, 0x49, 0x2f, 0x65, 0x4e, 0xe0, 0x85, 0x6d, 0x2e, 0x71, 0x23, 0x75, 0xbd,
		0xd3, 0x69, 0xdb, 0x74, 0x31, 0x26, 0x70, 0x81, 0x5b, 0x00, 0xfc, 0x8c, 0x4b, 0x9d, 0xe3, 0x56,
		0xf4, 0x16, 0x9a, 0xc7, 0x89, 0x48, 0xf1, 0x8f, 0x12, 0x5c, 0x1e, 0xf5, 0x8e, 0x45, 0x05, 0xb8,
		0x55, 0xd5, 0x4d, 0xcd, 0x30, 0x5f, 0xd9, 0x8a, 0x6a, 0x19, 0x6f, 0x0d, 0xeb, 0xc8, 0xae, 0x59,
		0x8a, 0xa5, 0xdb, 0x86, 0xf9, 0x56, 0x29, 0x1b, 0x9a, 0xfc, 0x7f, 0xe8, 0xff, 0x61, 0x73, 0x0c,
		0xa6, 0xa6, 0xee, 0xeb, 0x5a, 0xbd, 0xac, 0x6b, 0xb2, 0x34, 0x41, 0xa9, 0x66, 0x29, 0xd8, 0xd2,
		0x35, 0x39, 0x83, 0x7e, 0x00, 0xf7, 0xc7, 0x60, 0x54, 0xc5, 0x54, 0xf5, 0xb2, 0x8d, 0xf5, 0x9f,
		0xd6, 0xf5, 0x1a, 0x03, 0x67, 0x8b, 0xbf, 0xe8, 0xe7, 0x3c, 0xe0, 0x40, 0xc9, 0x27, 0x69, 0xba,
		0x6a, 0xd4, 0x8c, 0x8a, 0x39, 0x29, 0xe7, 0x0b, 0x98, 0x31, 0x39, 0x5f, 0x44, 0xc5, 0x39, 0x17,
		0x7f, 0x99, 0xe9, 0x7f, 0x02, 0x1b, 0x4d, 0x4c, 0xba, 0xb1, 0xb7, 0xb2, 0x67, 0x1c, 0x56, 0xf0,
		0x9b, 0xbd, 0x72, 0xe5, 0xd0, 0x36, 0x34, 0x1b, 0xeb, 0xf5, 0x9a, 0x6e, 0x57, 0x2b, 0x65, 0x43,
		0x3d, 0x4a, 0x64, 0xf2, 0x43, 0xf8, 0x7a, 0x2c, 0x4a, 0x29, 0xb3, 0xa8, 0x56, 0xaf, 0x96, 0x0d,
		0x95, 0x3d, 0x75, 0x4f, 0x31, 0xca, 0xba, 0x66, 0x57, 0xcc, 0xf2, 0x91, 0x2c, 0xa1, 0x2f, 0x61,
		0x6b, 0x5a, 0xa6, 0x9c, 0x41, 0x0f, 0xe1, 0xc1, 0x58, 0x34, 0xd6, 0x5f, 0xeb, 0xaa, 0x95, 0x80,
		0x67, 0xd1, 0x0e, 0x3c, 0x1c, 0x0b, 0xb7, 0x74, 0x7c, 0x60, 0x98, 0xbc, 0xa0, 0x7b, 0x36, 0xae,
		0x9b, 0xa6, 0x61, 0xbe, 0x92, 0x67, 0x8a, 0xbf, 0x93, 0x60, 0x75, 0xe8, 0xa5, 0x83, 0x6e, 0xc3,
		0xf5, 0xaa, 0x82, 0x75, 0xd3, 0xb2, 0xd5, 0x72, 0x65, 0x54, 0x01, 0xc6, 0x00, 0x94, 0x5d, 0xc5,
		0xd4, 0x2a, 0xa6, 0x2c, 0xa1, 0x7b, 0x50, 0x18, 0x05, 0x10, 0xbd, 0x20, 0x5a, 0x43, 0xce, 0xa0,
		0x3b, 0x70, 0x73, 0x14, 0xae, 0x97, 0xad, 0x9c, 0x2d, 0xfe, 0x2b, 0x03, 0x37, 0x26, 0x7d, 0x69,
		0xb3, 0x0e, 0xec, 0x2d, 0x5b, 0x7f, 0xa7, 0xab, 0x75, 0x8b, 0xed, 0x79, 0xa4, 0xc7, 0x76, 0xbe,
		0x5e, 0x4b, 0x64, 0x9e, 0x2c, 0xe9, 0x18, 0xb0, 0x5a, 0x39, 0xa8, 0x96, 0x75, 0x8b, 0x77, 0x53,
		0x11, 0xee, 0xa5, 0xc1, 0xa3, 0x0d, 0x96, 0x33, 0x03, 0x7b, 0x3b, 0x4e, 0x9a, 0xaf, 0x9b, 0x8d,
		0x02, 0x2a, 0x41, 0x31, 0x0d, 0xdd, 0xab, 0x82, 0x26, 0xcf, 0xa0, 0xaf, 0xe1, 0xab, 0xf4, 0xc4,
		0x4d, 0xcb, 0x30, 0xeb, 0xba, 0x66, 0x2b, 0x35, 0xdb, 0xd4, 0x0f, 0xe5, 0xd9, 0x69, 0x96, 0x6b,
		0x19, 0x07, 0xac, 0x3f, 0xeb, 0x96, 0x3c, 0x57, 0xfc, 0xb3, 0x04, 0x57, 0x54, 0xdf, 0xa3, 0xae,
		0xd7, 0x25, 0x4a, 0x68, 0x92, 0x8f, 0x46, 0x74, 0x9e, 0xf1, 0x03, 0x74, 0x17, 0xee, 0xc4, 0xfa,
		0x42, 0xde, 0x36, 0x4c, 0xc3, 0x32, 0x14, 0xab, 0x82, 0x13, 0xf5, 0x9d, 0x08, 0x63, 0x03, 0xa9,
		0xe9, 0x38, 0xaa, 0xeb, 0x78, 0x18, 0xd6, 0x2d, 0x7c, 0x24, 0x5a, 0x21, 0x72, 0x98, 0xf1, 0x58,
		0x15, 0xb3, 0xf9, 0x16, 0xf3, 0x2f, 0x67, 0x8b, 0xbf, 0x97, 0x20, 0x27, 0xbe, 0x45, 0xf9, 0xa7,
		0x4a, 0x1e, 0x2e, 0xb3, 0x05, 0x56, 0xea, 0x96, 0x6d, 0x1d, 0x55, 0xf5, 0xc1, 0x1e, 0x1e, 0xb8,
		0xc3, 0xed, 0xc1, 0xb6, 0x2a, 0x51, 0x75, 0x22, 0x27, 0x19, 0x04, 0x88, 0xa7, 0x30, 0x0c, 0x07,
		0xcb, 0x99, 0x89, 0x98, 0x48, 0x27, 0x8b, 0xae, 0xc1, 0x95, 0x01, 0xcc, 0xbe, 0xae, 0x60, 0x6b,
		0x57, 0x57, 0x2c, 0x79, 0xa6, 0xf8, 0x1b, 0x09, 0xae, 0xc6, 0x4e, 0x68, 0xb1, 0x17, 0xab, 0xdb,
		0x26, 0xcd, 0x4a, 0x97, 0xaa, 0x4e, 0x37, 0x24, 0xe8, 0x01, 0xdc, 0xed, 0x79, 0x98, 0xa5, 0xd4,
		0xde, 0xf4, 0xf7, 0xca, 0x56, 0x15, 0x36, 0xdc, 0xfd, 0xd5, 0xa4, 0x42, 0x45, 0x0a, 0xb2, 0x84,
		0xee, 0xc3, 0x17, 0x93, 0xa1, 0x58, 0xaf, 0xe9, 0x96, 0x9c, 0x29, 0xfe, 0x23, 0x07, 0x1b, 0xc9,
		0xe4, 0xd8, 0x81, 0x9e, 0x34, 0xa3, 0xd4, 0xee, 0x41, 0x61, 0x50, 0x44, 0xf8, 0xdc, 0xc5, 0xbc,
		0x76, 0xe0, 0xe1, 0x04, 0x5c, 0xdd, 0xdc, 0x57, 0x4c, 0x8d, 0x5d, 0xc7, 0x20, 0x59, 0x42, 0x2f,
		0xe1, 0xf9, 0x04, 0xca, 0xae, 0xa2, 0xf5, 0xab, 0xdc, 0x7b, 0xe3, 0x28, 0x96, 0x85, 0x8d, 0xdd,
		0xba, 0xa5, 0xd7, 0xe4, 0x0c, 0xd2, 0x41, 0x49, 0x11, 0x18, 0xf4, 0xa1, 0x91, 0x32, 0x59, 0xf4,
		0x0c, 0x9e, 0xa4, 0xe5, 0x11, 0xb5, 0x8c, 0x71, 0xa0, 0xe3, 0x24, 0x75, 0x06, 0x7d, 0x0b, 0xdf,
		0xa4, 0x50, 0xc5, 0x93, 0x87, 0xb8, 0xb3, 0xe8, 0x39, 0x3c, 0x4d, 0xcd, 0x5e, 0xad, 0x60, 0xcd,
		0x3e, 0x50, 0xf0, 0x9b, 0x41, 0xf2, 0x1c, 0x32, 0x40, 0x4f, 0x7b, 0xb0, 0x70, 0x37, 0x7b, 0x84,
		0x2f, 0x24, 0xa4, 0x2e, 0x4d, 0x51, 0x45, 0x16, 0x48, 0x91, 0x99, 0x47, 0xaf, 0x40, 0x9d, 0xae,
		0x14, 0x93, 0x85, 0x16, 0xd0, 0x3b, 0xb0, 0x3e, 0x6f, 0x57, 0xf5, 0x77, 0x96, 0x8e, 0x4d, 0x25,
		0x4d, 0x19, 0xd0, 0x0b, 0x78, 0x96, 0x5a, 0xb4, 0x41, 0xff, 0x49, 0xd0, 0x73, 0xe8, 0x29, 0x3c,
		0x9e, 0x40, 0x4f, 0xf6, 0x48, 0xff, 0x54, 0x60, 0x68, 0xf2, 0x22, 0x7a, 0x02, 0x3b, 0x13, 0x88,
		0x7c, 0x0a, 0xed, 0x9a, 0x65, 0xa8, 0x6f, 0x8e, 0xa2, 0xdb, 0x65, 0xa3, 0x66, 0xc9, 0x4b, 0xe8,
		0x27, 0xf0, 0xa3, 0x09, 0xb4, 0xde, 0x62, 0xd9, 0x1f, 0x3a, 0x4e, 0x8c, 0x18, 0x83, 0xd5, 0xb1,
		0x2e, 0x2f, 0x4f, 0xb1, 0x27, 0x35, 0xe3, 0x55, 0x7a, 0xe5, 0x56, 0x90, 0x0a, 0x2f, 0xa7, 0x1a,
		0x11, 0x75, 0xdf, 0x28, 0x6b, 0xa3, 0x45, 0x64, 0xf4, 0x18, 0xb6, 0x27, 0x88, 0xec, 0x55, 0xb0,
		0xaa, 0x8b, 0x37, 0x56, 0xcf, 0x24, 0x56, 0xd1, 0x37, 0xf0, 0x68, 0x12, 0x49, 0x31, 0xca, 0x95,
		0xb7, 0x3a, 0xbe, 0xc8, 0x43, 0xec, 0x35, 0x3a, 0xdd, 0xd2, 0x0d, 0xb3, 0x5a, 0xb7, 0xec, 0x9a,
		0xf1, 0x9d, 0x2e, 0xaf, 0xb1, 0xd7, 0x68, 0xea, 0x4e, 0xc5, 0xb5, 0x92, 0x2f, 0x0f, 0x9b, 0xf1,
		0xd0, 0x43, 0x76, 0x0d, 0x53, 0xc1, 0x47, 0xf2, 0x7a, 0x4a, 0xef, 0x0d, 0x1b, 0xdd, 0x40, 0x0b,
		0x5d, 0x99, 0x66, 0x39, 0xba, 0x82, 0xd5, 0xfd, 0x64, 0xc5, 0x37, 0xd8, 0x5b, 0xe7, 0x0e, 0xff,
		0xc7, 0xca, 0xd0, 0xb9, 0x2a, 0x69, 0xf1, 0x3b, 0xf0, 0x30, 0xda, 0xb7, 0x11, 0x5d, 0x30, 0xc6,
		0xed, 0x77, 0xe1, 0xc7, 0xd3, 0x51, 0x7a, 0xf7, 0x95, 0x32, 0xd6, 0x15, 0xed, 0xa8, 0x77, 0x24,
		0x95, 0x8a, 0x7f, 0x95, 0xa0, 0xa8, 0x3a, 0x5e, 0x83, 0xb4, 0xe2, 0xff, 0xbb, 0x4e, 0xcc, 0xf2,
		0x39, 0x3c, 0x9d, 0x62, 0xde, 0xc7, 0xe4, 0x7b, 0x08, 0xb5, 0xcf, 0x25, 0xd7, 0xcd, 0x37, 0x66,
		0xe5, 0xd0, 0x9c, 0x44, 0x10, 0x8b, 0xa8, 0xb9, 0xa7, 0xfc, 0x9f, 0xc6, 0xd3, 0x2d, 0x42, 0xb4,
		0xdd, 0x7f, 0xb6, 0x88, 0xcf, 0x25, 0x4f, 0xb5, 0x88, 0xdd, 0xb7, 0xb0, 0xd1, 0xf0, 0xdb, 0xa3,
		0xbe, 0xe2, 0x77, 0xe7, 0x95, 0x8e, 0x5b, 0x65, 0x5f, 0xb0, 0x55, 0xe9, 0xbb, 0xed, 0x53, 0x97,
		0x9e, 0x75, 0x8f, 0x4b, 0x0d, 0xbf, 0xbd, 0x3d, 0xf0, 0xfb, 0x63, 0xe9, 0x94, 0x78, 0xd1, 0xaf,
		0x99, 0xe2, 0xa7, 0xc8, 0xe7, 0x4e, 0xc7, 0xfd, 0xb0, 0x73, 0x3c, 0xc7, 0x63, 0x8f, 0xff, 0x1d,
		0x00, 0x00, 0xff, 0xff, 0x1c, 0xfe, 0xdc, 0x7d, 0x4a, 0x1d, 0x00, 0x00,
	},
	// uber/cadence/api/v1/tasklist.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x7c, 0x54, 0xdd, 0x6e, 0xdb, 0x36,
		0x14, 0x9e, 0xe2, 0xb4, 0x73, 0x98, 0x25, 0xd5, 0xb8, 0xb5, 0x8d, 0xdd, 0x75, 0xcb, 0x74, 0x51,
		0x04, 0xc5, 0x20, 0x21, 0x19, 0x76, 0xb5, 0x8b, 0xc1, 0x89, 0x83, 0x55, 0x88, 0xe3, 0x1a, 0x92,
		0x1a, 0x20, 0xbb, 0xe1, 0x28, 0xf1, 0xd4, 0x21, 0xf4, 0x43, 0x81, 0xa4, 0x92, 0xf8, 0x45, 0xf6,
		0x30, 0x7b, 0xa2, 0x3d, 0xc6, 0x40, 0x4a, 0xf6, 0xdc, 0xc4, 0xeb, 0x1d, 0x79, 0xbe, 0xf3, 0x9d,
		0x9f, 0x8f, 0xe7, 0x10, 0x79, 0x4d, 0x0a, 0x32, 0xc8, 0x28, 0x83, 0x2a, 0x83, 0x80, 0xd6, 0x3c,
		0xb8, 0x3d, 0x0e, 0x34, 0x55, 0x79, 0xc1, 0x95, 0xf6, 0x6b, 0x29, 0xb4, 0xc0, 0xdf, 0x18, 0x1f,
		0xbf, 0xf3, 0xf1, 0x69, 0xcd, 0xfd, 0xdb, 0xe3, 0xe1, 0xf7, 0x73, 0x21, 0xe6, 0x05, 0x04, 0xd6,
		0x25, 0x6d, 0x3e, 0x06, 0xac, 0x91, 0x54, 0x73, 0x51, 0xb5, 0xa4, 0xe1, 0x0f, 0x0f, 0x71, 0xcd,
		0x4b, 0x50, 0x9a, 0x96, 0x75, 0xe7, 0xf0, 0x28, 0xc0, 0x9d, 0xa4, 0x75, 0x0d, 0x52, 0xb5, 0xb8,
		0xf7, 0x01, 0xf5, 0x13, 0xaa, 0xf2, 0x09, 0x57, 0x1a, 0x63, 0xb4, 0x5d, 0xd1, 0x12, 0x0e, 0x9c,
		0x43, 0xe7, 0x68, 0x27, 0xb2, 0x67, 0xfc, 0x0b, 0xda, 0xce, 0x79, 0xc5, 0x0e, 0xb6, 0x0e, 0x9d,
		0xa3, 0xfd, 0x93, 0x1f, 0xfd, 0x0d, 0x45, 0xfa, 0xcb, 0x00, 0x17, 0xbc, 0x62, 0x91, 0x75, 0xf7,
		0x28, 0x72, 0x97, 0xd6, 0x4b, 0xd0, 0x94, 0x51, 0x4d, 0xf1, 0x25, 0xfa, 0xb6, 0xa4, 0xf7, 0xc4,
		0xb4, 0xad, 0x48, 0x0d, 0x92, 0x28, 0xc8, 0x44, 0xc5, 0x6c, 0xba, 0xdd, 0x93, 0xef, 0xfc, 0xb6,
		0x52, 0x7f, 0x59, 0xa9, 0x3f, 0x16, 0x4d, 0x5a, 0xc0, 0x15, 0x2d, 0x1a, 0x88, 0xbe, 0x2e, 0xe9,
		0xbd, 0x09, 0xa8, 0x66, 0x20, 0x63, 0x4b, 0xf3, 0x3e, 0xa0, 0xc1, 0x32, 0xc5, 0x8c, 0x4a, 0xcd,
		0x8d, 0x2a, 0xab, 0x5c, 0x2e, 0xea, 0xe5, 0xb0, 0xe8, 0x3a, 0x31, 0x47, 0xfc, 0x06, 0x3d, 0x13,
		0x77, 0x15, 0x48, 0x72, 0x23, 0x94, 0x26, 0xb6, 0xcf, 0x2d, 0x8b, 0xee, 0x59, 0xf3, 0x3b, 0xa1,
		0xf4, 0x94, 0x96, 0xe0, 0xfd, 0xe3, 0xa0, 0xfd, 0x65, 0xdc, 0x58, 0x53, 0xdd, 0x28, 0xfc, 0x13,
		0xc2, 0x29, 0xcd, 0xf2, 0x42, 0xcc, 0x49, 0x26, 0x9a, 0x4a, 0x93, 0x1b, 0x5e, 0x69, 0x1b, 0xbb,
		0x17, 0xb9, 0x1d, 0x72, 0x66, 0x80, 0x77, 0xbc, 0xd2, 0xf8, 0x35, 0x42, 0x12, 0x28, 0x23, 0x05,
		0xdc, 0x42, 0x61, 0x73, 0xf4, 0xa2, 0x1d, 0x63, 0x99, 0x18, 0x03, 0x7e, 0x85, 0x76, 0x68, 0x96,
		0x77, 0x68, 0xcf, 0xa2, 0x7d, 0x9a, 0xe5, 0x2d, 0xf8, 0x06, 0x3d, 0x93, 0x54, 0xc3, 0xba, 0x3a,
		0xdb, 0x87, 0xce, 0x91, 0x13, 0xed, 0x19, 0xf3, 0xaa, 0x77, 0x3c, 0x46, 0x7b, 0x46, 0x46, 0xc2,
		0x19, 0x49, 0x0b, 0x91, 0xe5, 0x07, 0x4f, 0xac, 0x86, 0x87, 0xff, 0xfb, 0x3c, 0xe1, 0xf8, 0xd4,
		0xf8, 0x45, 0xbb, 0x86, 0x16, 0x32, 0x7b, 0xf1, 0x7e, 0x43, 0xbb, 0x6b, 0x18, 0x1e, 0xa0, 0xbe,
		0xd2, 0x54, 0x6a, 0xc2, 0x59, 0xd7, 0xdc, 0x97, 0xf6, 0x1e, 0x32, 0xfc, 0x1c, 0x3d, 0x85, 0x8a,
		0x19, 0xa0, 0xed, 0xe7, 0x09, 0x54, 0x2c, 0x64, 0xde, 0x5f, 0x0e, 0x42, 0x33, 0x51, 0x14, 0x20,
		0xc3, 0xea, 0xa3, 0xc0, 0x63, 0xe4, 0x16, 0x54, 0x69, 0x42, 0xb3, 0x0c, 0x94, 0x22, 0x66, 0x14,
		0xbb, 0xc7, 0x1d, 0x3e, 0x7a, 0xdc, 0x64, 0x39, 0xa7, 0xd1, 0xbe, 0xe1, 0x8c, 0x2c, 0xc5, 0x18,
		0xf1, 0x10, 0xf5, 0x39, 0x83, 0x4a, 0x73, 0xbd, 0xe8, 0x5e, 0x68, 0x75, 0xdf, 0xa4, 0x4f, 0x6f,
		0x83, 0x3e, 0xde, 0xdf, 0x0e, 0x1a, 0xc4, 0x9a, 0x67, 0xf9, 0xe2, 0xfc, 0x1e, 0xb2, 0xc6, 0x8c,
		0xc6, 0x48, 0x6b, 0xc9, 0xd3, 0x46, 0x83, 0xc2, 0xbf, 0x23, 0xf7, 0x4e, 0xc8, 0x1c, 0xa4, 0x9d,
		0x45, 0x62, 0x76, 0xb0, 0xab, 0xf3, 0xf5, 0x67, 0xe7, 0x3b, 0xda, 0x6f, 0x69, 0xab, 0x85, 0x49,
		0xd0, 0x40, 0x65, 0x37, 0xc0, 0x9a, 0x02, 0x88, 0x16, 0xa4, 0x55, 0xcf, 0xb4, 0x2d, 0x1a, 0x6d,
		0x6b, 0xdf, 0x3d, 0x19, 0x3c, 0x1e, 0xeb, 0x6e, 0x83, 0xa3, 0x17, 0x4b, 0x6e, 0x22, 0x62, 0xc3,
		0x4c, 0x5a, 0xe2, 0xdb, 0x3f, 0xd1, 0x57, 0xeb, 0x1b, 0x85, 0x87, 0xe8, 0x45, 0x32, 0x8a, 0x2f,
		0xc8, 0x24, 0x8c, 0x13, 0x72, 0x11, 0x4e, 0xc7, 0x24, 0x9c, 0x5e, 0x8d, 0x26, 0xe1, 0xd8, 0xfd,
		0x02, 0x0f, 0xd0, 0xf3, 0x07, 0xd8, 0xf4, 0x7d, 0x74, 0x39, 0x9a, 0xb8, 0xce, 0x06, 0x28, 0x4e,
		0xc2, 0xb3, 0x8b, 0x6b, 0x77, 0xeb, 0x2d, 0xfb, 0x2f, 0x43, 0xb2, 0xa8, 0xe1, 0xd3, 0x0c, 0xc9,
		0xf5, 0xec, 0x7c, 0x2d, 0xc3, 0x2b, 0xf4, 0xf2, 0x01, 0x36, 0x3e, 0x3f, 0x0b, 0xe3, 0xf0, 0xfd,
		0xd4, 0x75, 0x36, 0x80, 0xa3, 0xb3, 0x24, 0xbc, 0x0a, 0x93, 0x6b, 0x77, 0xeb, 0xf4, 0x0a, 0xbd,
		0xcc, 0x44, 0xb9, 0x49, 0xd1, 0xd3, 0xfe, 0xa8, 0xe6, 0x33, 0x23, 0xc8, 0xcc, 0xf9, 0x23, 0x98,
		0x73, 0x7d, 0xd3, 0xa4, 0x7e, 0x26, 0xca, 0xe0, 0x93, 0x6f, 0xd2, 0x9f, 0x43, 0xd5, 0xfe, 0x5b,
		0xdd, 0x8f, 0xf9, 0x2b, 0xad, 0xf9, 0xed, 0x71, 0xfa, 0xd4, 0xda, 0x7e, 0xfe, 0x37, 0x00, 0x00,
		0xff, 0xff, 0x58, 0x62, 0x2b, 0xbf, 0x55, 0x05, 0x00, 0x00,
	},
	// uber/cadence/shared/v1/cluster.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x53, 0xdf, 0x8b, 0xd3, 0x40,
		0x10, 0x26, 0x17, 0x6b, 0xdb, 0xe9, 0xe1, 0x9d, 0x8b, 0x3f, 0x82, 0x22, 0xc4, 0x20, 0x52, 0x14,
		0x12, 0x7a, 0xa2, 0xc2, 0x29, 0x22, 0x57, 0x39, 0xec, 0x83, 0x3f, 0x58, 0xdf, 0x7c, 0x09, 0x9b,
		0xcd, 0x34, 0x59, 0xae, 0xd9, 0x3d, 0x36, 0x9b, 0x42, 0x1f, 0xfc, 0x13, 0xfc, 0x87, 0xf4, 0x9f,
		0x93, 0xec, 0x26, 0xd5, 0xc3, 0x1e, 0x77, 0x6f, 0x33, 0x3b, 0xdf, 0xf7, 0xed, 0x37, 0x33, 0x0c,
		0x3c, 0x69, 0x32, 0xd4, 0x09, 0x67, 0x39, 0x4a, 0x8e, 0x49, 0x5d, 0x32, 0x8d, 0x79, 0xb2, 0x9e,
		0x25, 0x7c, 0xd5, 0xd4, 0x06, 0x75, 0x7c, 0xae, 0x95, 0x51, 0xe4, 0x5e, 0x8b, 0x8a, 0x3b, 0x54,
		0xec, 0x50, 0xf1, 0x7a, 0x16, 0x3d, 0x85, 0xd1, 0x47, 0x55, 0x9b, 0x85, 0x5c, 0x2a, 0xf2, 0x00,
		0x46, 0x22, 0x47, 0x69, 0x84, 0xd9, 0x04, 0x5e, 0xe8, 0x4d, 0xc7, 0x74, 0x9b, 0x47, 0x3f, 0x60,
		0x44, 0x85, 0x2c, 0x2c, 0x8e, 0xc0, 0x0d, 0xad, 0x56, 0xd8, 0x61, 0x6c, 0x4c, 0x1e, 0xc3, 0x7e,
		0x85, 0x55, 0x86, 0x3a, 0xe5, 0xaa, 0x91, 0x26, 0xd8, 0x0b, 0xbd, 0xe9, 0x80, 0x4e, 0xdc, 0xdb,
		0xbc, 0x7d, 0x22, 0xc7, 0x30, 0x74, 0x69, 0x1d, 0xf8, 0xa1, 0x3f, 0x9d, 0x1c, 0x85, 0xf1, 0x6e,
		0x53, 0x71, 0xef, 0x88, 0xf6, 0x84, 0xe8, 0x97, 0x07, 0xb7, 0x3e, 0xb9, 0xb8, 0x14, 0xe7, 0xd6,
		0xc5, 0x1c, 0xf6, 0x79, 0xa3, 0x35, 0x4a, 0x93, 0x96, 0xaa, 0x36, 0xd6, 0xcd, 0x75, 0x34, 0x27,
		0x1d, 0xab, 0x7d, 0x20, 0xcf, 0xe1, 0xb6, 0x46, 0xc6, 0x4b, 0x96, 0xad, 0x30, 0xed, 0xdd, 0xed,
		0x85, 0xfe, 0x74, 0x4c, 0x0f, 0xb7, 0x85, 0xee, 0x63, 0xf2, 0x0a, 0x06, 0x5a, 0xc8, 0xe2, 0x4a,
		0xfb, 0xfd, 0xa0, 0xa8, 0x83, 0x47, 0x3f, 0x3d, 0x38, 0xf8, 0xa0, 0x2a, 0x26, 0xe4, 0x9c, 0xf1,
		0x12, 0xad, 0xfb, 0x63, 0x78, 0x28, 0x9b, 0x2a, 0x55, 0xcb, 0x54, 0x18, 0xac, 0xea, 0x54, 0xc8,
		0x94, 0xb7, 0xc5, 0x34, 0xdb, 0xa4, 0x22, 0xb7, 0xcd, 0xf8, 0xf4, 0xae, 0x6c, 0xaa, 0x2f, 0xcb,
		0x45, 0x0b, 0x58, 0x38, 0xee, 0xc9, 0x66, 0x91, 0x93, 0x77, 0xf0, 0xe8, 0x52, 0xae, 0x64, 0x15,
		0xda, 0xe1, 0xfb, 0xf4, 0xfe, 0x0e, 0xf6, 0x67, 0x56, 0x61, 0xf4, 0x16, 0xc8, 0x57, 0xd4, 0xb5,
		0xa8, 0x4d, 0x6b, 0xfc, 0x1b, 0x1a, 0x23, 0x64, 0x41, 0x0e, 0xc1, 0x3f, 0xc3, 0x7e, 0xf1, 0x6d,
		0x48, 0xee, 0xc0, 0x60, 0xcd, 0x56, 0x8d, 0xd3, 0x1b, 0x53, 0x97, 0x44, 0xef, 0x2f, 0xb0, 0x4f,
		0x91, 0x99, 0x46, 0xe3, 0x0e, 0x76, 0x00, 0x43, 0x94, 0xed, 0xf8, 0x72, 0xcb, 0x1f, 0xd1, 0x3e,
		0x8d, 0x7e, 0x7b, 0x70, 0xf0, 0x8f, 0x84, 0x9d, 0x47, 0x00, 0xc3, 0x8c, 0xf1, 0x33, 0x94, 0x79,
		0xa7, 0xd1, 0xa7, 0xe4, 0x14, 0x46, 0xb5, 0xb3, 0xe8, 0x36, 0x33, 0x39, 0x7a, 0x76, 0xd9, 0xe0,
		0xff, 0xef, 0x8a, 0x6e, 0xb9, 0xad, 0xce, 0xd2, 0x99, 0xed, 0x17, 0x78, 0x1d, 0x9d, 0xae, 0x3f,
		0xba, 0xe5, 0x9e, 0xbc, 0xfe, 0xfe, 0xb2, 0x10, 0xa6, 0x6c, 0xb2, 0x98, 0xab, 0x2a, 0xb9, 0x70,
		0x7c, 0x71, 0x81, 0x32, 0xb1, 0xf7, 0xf6, 0xf7, 0x0e, 0xdf, 0xb8, 0x68, 0x3d, 0xcb, 0x6e, 0xda,
		0xca, 0x8b, 0x3f, 0x01, 0x00, 0x00, 0xff, 0xff, 0x90, 0xef, 0x39, 0x7d, 0xb1, 0x03, 0x00, 0x00,
	},
	// uber/cadence/shared/v1/history.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x92, 0xc1, 0x4a, 0xeb, 0x40,
		0x18, 0x85, 0x49, 0x4b, 0x6f, 0xef, 0x9d, 0xf6, 0x56, 0x19, 0x50, 0x6a, 0x41, 0x68, 0x83, 0x48,
		0x71, 0x31, 0x21, 0x15, 0x71, 0xe1, 0x46, 0xa5, 0x8a, 0x71, 0x19, 0x8a, 0x0b, 0x37, 0x21, 0xc9,
		0xfc, 0x36, 0x83, 0x76, 0xa6, 0xcc, 0x4c, 0x82, 0x3e, 0x8b, 0x8f, 0xe0, 0x4b, 0x4a, 0x26, 0xd3,
		0x96, 0x58, 0x17, 0xdd, 0xe5, 0xcc, 0x9c, 0xf3, 0xfd, 0x27, 0xc9, 0x8f, 0x4e, 0xf2, 0x04, 0xa4,
		0x97, 0xc6, 0x14, 0x78, 0x0a, 0x9e, 0xca, 0x62, 0x09, 0xd4, 0x2b, 0x7c, 0x2f, 0x63, 0x4a, 0x0b,
		0xf9, 0x41, 0x96, 0x52, 0x68, 0x81, 0x0f, 0x4b, 0x17, 0xb1, 0x2e, 0x52, 0xb9, 0x48, 0xe1, 0x0f,
		0x46, 0xb5, 0x74, 0xbc, 0x64, 0x5b, 0x51, 0xf7, 0xcb, 0x41, 0x07, 0x33, 0x19, 0x73, 0xc5, 0x80,
		0xeb, 0x29, 0xa4, 0x4c, 0x31, 0xc1, 0x03, 0xfe, 0x22, 0xf0, 0x23, 0xda, 0x53, 0x69, 0x06, 0x34,
		0x7f, 0x03, 0x1a, 0x41, 0x01, 0x5c, 0xf7, 0x9d, 0xa1, 0x33, 0xee, 0x4c, 0x46, 0xa4, 0x36, 0x2e,
		0x5e, 0x32, 0x52, 0xf8, 0xe4, 0xa1, 0xc2, 0xde, 0x95, 0xc6, 0xb0, 0xb7, 0x4e, 0x1a, 0x8d, 0xef,
		0xd1, 0x7f, 0xa5, 0x63, 0xa9, 0xd7, 0xa4, 0xc6, 0xae, 0xa4, 0xae, 0xcd, 0x19, 0xe5, 0x06, 0x08,
		0x3f, 0x81, 0x2c, 0x2b, 0x5a, 0x53, 0xa0, 0x61, 0x81, 0x8f, 0xd0, 0x5f, 0x43, 0x8d, 0x18, 0x35,
		0x15, 0x9b, 0x61, 0xdb, 0xe8, 0x80, 0xe2, 0x3e, 0x6a, 0x17, 0x55, 0xc0, 0x8c, 0x6c, 0x86, 0x2b,
		0xe9, 0xe6, 0xa8, 0x57, 0x47, 0xe1, 0x11, 0xea, 0x26, 0x32, 0xe6, 0x69, 0x16, 0x69, 0xf1, 0x0a,
		0xdc, 0xa0, 0xba, 0x61, 0xa7, 0x3a, 0x9b, 0x95, 0x47, 0xf8, 0x1a, 0xb5, 0x98, 0x86, 0x85, 0xea,
		0x37, 0x86, 0xcd, 0x71, 0x67, 0x72, 0x46, 0x7e, 0xff, 0xf0, 0x64, 0xbb, 0x64, 0x58, 0x05, 0xdd,
		0x4f, 0x07, 0xed, 0xd7, 0x6e, 0x19, 0x28, 0x7c, 0x83, 0x8e, 0xd3, 0x5c, 0xca, 0xf2, 0x15, 0x6c,
		0xbd, 0xc8, 0xfe, 0xa5, 0x88, 0x71, 0x0a, 0xef, 0xa6, 0x4a, 0x2b, 0x1c, 0x58, 0xd3, 0x0f, 0x7a,
		0xe9, 0xc0, 0x53, 0xf4, 0x2f, 0x5b, 0xf1, 0x6c, 0xbb, 0xd3, 0xdd, 0xda, 0x85, 0x9b, 0xe0, 0xed,
		0xe5, 0xf3, 0xc5, 0x9c, 0xe9, 0x2c, 0x4f, 0x48, 0x2a, 0x16, 0x5e, 0x6d, 0x7b, 0xc8, 0x1c, 0xb8,
		0x67, 0x76, 0x66, 0xb3, 0x86, 0x57, 0xd5, 0x53, 0xe1, 0x27, 0x7f, 0xcc, 0xcd, 0xf9, 0x77, 0x00,
		0x00, 0x00, 0xff, 0xff, 0x84, 0xb4, 0x3e, 0x6c, 0xb0, 0x02, 0x00, 0x00,
	},
	// uber/cadence/api/v1/history.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xec, 0x5c, 0x5f, 0x6c, 0x1c, 0x57,
		0xd5, 0xef, 0xec, 0xda, 0xbb, 0xde, 0xb3, 0x8e, 0x63, 0xdf, 0x24, 0x8e, 0x9d, 0xbf, 0xce, 0x24,
		0x4d, 0x5c, 0xc7, 0x59, 0x27, 0x4e, 0x9a, 0x7c, 0x69, 0xbe, 0xb6, 0x38, 0x8e, 0xad, 0xae, 0x64,
		0x92, 0x68, 0xe2, 0xa4, 0x80, 0x90, 0x96, 0xf1, 0xcc, 0x75, 0x3c, 0xf2, 0xee, 0xcc, 0x76, 0x66,
		0xd6, 0x1b, 0x23, 0xf1, 0xc4, 0x03, 0x12, 0x6a, 0x05, 0x55, 0x85, 0x44, 0x05, 0x08, 0x84, 0x04,
		0x6a, 0x11, 0x52, 0x11, 0x08, 0x01, 0xe2, 0x05, 0x90, 0x10, 0x48, 0xa0, 0xc2, 0x13, 0x2f, 0x3c,
		0xc0, 0x03, 0x0f, 0xf4, 0x8d, 0x07, 0xca, 0x1b, 0x12, 0x9a, 0x3b, 0x77, 0x76, 0x77, 0x66, 0xee,
		0x9d, 0xb9, 0xb3, 0xde, 0xb4, 0xa0, 0xe6, 0xcd, 0x73, 0xe7, 0xdc, 0x33, 0xbf, 0x7b, 0xee, 0x39,
		0xe7, 0x9e, 0x7b, 0xce, 0x59, 0xc3, 0xa9, 0xd6, 0x06, 0xb6, 0x17, 0x34, 0x55, 0xc7, 0xa6, 0x86,
		0x17, 0xd4, 0xa6, 0xb1, 0xb0, 0x73, 0x69, 0x61, 0xcb, 0x70, 0x5c, 0xcb, 0xde, 0xad, 0x34, 0x6d,
		0xcb, 0xb5, 0xd0, 0x01, 0x8f, 0xa4, 0x42, 0x49, 0x2a, 0x6a, 0xd3, 0xa8, 0xec, 0x5c, 0x3a, 0x72,
		0xe2, 0xa1, 0x65, 0x3d, 0xac, 0xe3, 0x05, 0x42, 0xb2, 0xd1, 0xda, 0x5c, 0xd0, 0x5b, 0xb6, 0xea,
		0x1a, 0x96, 0xe9, 0x4f, 0x3a, 0x72, 0x32, 0xfa, 0xde, 0x35, 0x1a, 0xd8, 0x71, 0xd5, 0x46, 0x93,
		0x12, 0xcc, 0xb0, 0x3e, 0xac, 0x59, 0x8d, 0x46, 0x87, 0x85, 0xcc, 0xa2, 0x70, 0x55, 0x67, 0xbb,
		0x6e, 0x38, 0x6e, 0x12, 0x4d, 0xdb, 0xb2, 0xb7, 0x37, 0xeb, 0x56, 0xdb, 0xa7, 0x91, 0x6f, 0x41,
		0xf1, 0x25, 0x7f, 0x41, 0xe8, 0x3a, 0x14, 0xf0, 0x0e, 0x36, 0x5d, 0x67, 0x4a, 0x9a, 0xc9, 0xcf,
		0x96, 0x17, 0x4f, 0x55, 0x18, 0x6b, 0xab, 0x50, 0xea, 0x15, 0x8f, 0x52, 0xa1, 0x13, 0xe4, 0xf7,
		0xae, 0xc1, 0x68, 0xef, 0x0b, 0x34, 0x0d, 0x23, 0xe4, 0x55, 0xcd, 0xd0, 0xa7, 0xa4, 0x19, 0x69,
		0x36, 0xaf, 0x14, 0xc9, 0x73, 0x55, 0x47, 0xd7, 0x01, 0xfc, 0x57, 0xde, 0xa2, 0xa7, 0x72, 0x33,
		0xd2, 0x6c, 0x79, 0xf1, 0x48, 0xc5, 0x97, 0x48, 0x25, 0x90, 0x48, 0x65, 0x3d, 0x90, 0x88, 0x52,
		0x22, 0xd4, 0xde, 0x33, 0x9a, 0x82, 0xe2, 0x0e, 0xb6, 0x1d, 0xc3, 0x32, 0xa7, 0xf2, 0x3e, 0x53,
		0xfa, 0x88, 0x0e, 0x43, 0xd1, 0x5b, 0xbc, 0xf7, 0xb9, 0x21, 0xf2, 0xa6, 0xe0, 0x3d, 0x56, 0x75,
		0xf4, 0x75, 0x09, 0xce, 0x07, 0x4b, 0xae, 0xe1, 0x47, 0x58, 0x6b, 0x79, 0xfb, 0x50, 0x73, 0x5c,
		0xd5, 0x76, 0xb1, 0x5e, 0xf3, 0x91, 0xa8, 0xae, 0x6b, 0x1b, 0x1b, 0x2d, 0x17, 0x3b, 0x53, 0xc3,
		0x04, 0xcf, 0xff, 0x33, 0x97, 0xfe, 0x32, 0xe5, 0xb3, 0x12, 0xb0, 0xb9, 0xe7, 0x73, 0x21, 0x4b,
		0x5e, 0xea, 0xf0, 0x78, 0xe9, 0x29, 0xe5, 0x5c, 0x5b, 0x8c, 0x14, 0x7d, 0x5b, 0x82, 0x0b, 0x0c,
		0x78, 0x9a, 0xd5, 0x68, 0xd6, 0x31, 0x13, 0x60, 0x81, 0x00, 0x7c, 0x41, 0x0c, 0xe0, 0x72, 0xc0,
		0x27, 0x0e, 0xf1, 0x99, 0xb6, 0x28, 0x31, 0x7a, 0x53, 0x82, 0x39, 0x06, 0xc8, 0x4d, 0xd5, 0xa8,
		0xb3, 0x10, 0x16, 0x09, 0xc2, 0x1b, 0x62, 0x08, 0x57, 0x09, 0x93, 0x38, 0xbc, 0xb3, 0x6d, 0x21,
		0x4a, 0xf4, 0x2d, 0xb6, 0x00, 0x3d, 0xdd, 0xd2, 0x6b, 0x56, 0xcb, 0x8d, 0xc3, 0x1b, 0x21, 0xf0,
		0x9e, 0x17, 0x83, 0xe7, 0xa9, 0x9d, 0x7e, 0xa7, 0xe5, 0xc6, 0x01, 0xce, 0xb6, 0x05, 0x69, 0xd1,
		0x1b, 0x12, 0xcc, 0xea, 0x58, 0x33, 0x1c, 0x02, 0xcc, 0xd3, 0x52, 0x47, 0xdb, 0xc2, 0x7a, 0x8b,
		0x29, 0xbc, 0x12, 0x41, 0x77, 0x9d, 0x89, 0xee, 0x16, 0x65, 0xb2, 0xae, 0x3a, 0xdb, 0xf7, 0x02,
		0x16, 0x71, 0x64, 0x67, 0x74, 0x01, 0x3a, 0xf4, 0x9a, 0x04, 0x67, 0x23, 0xa8, 0x78, 0x36, 0x01,
		0x04, 0xd3, 0xb5, 0x74, 0x4c, 0x3c, 0x73, 0x90, 0xf5, 0x54, 0x2a, 0x86, 0x94, 0x12, 0x8c, 0xa0,
		0x2c, 0x28, 0xa5, 0x04, 0xfd, 0x0f, 0x49, 0x89, 0xab, 0xfa, 0xaf, 0xc7, 0x50, 0x25, 0x68, 0xd6,
		0x28, 0x41, 0xf5, 0x7f, 0xa9, 0xa8, 0xf8, 0x4a, 0x75, 0x5a, 0x4f, 0x27, 0x43, 0x5f, 0x94, 0xe0,
		0xe9, 0x30, 0x26, 0x9e, 0x25, 0xee, 0x23, 0x80, 0xae, 0xa6, 0x02, 0xe2, 0x19, 0xe1, 0x29, 0x3d,
		0x8d, 0x88, 0x6c, 0x9b, 0xaa, 0xb9, 0xc6, 0x8e, 0xe1, 0xee, 0xa6, 0x2a, 0xf7, 0x58, 0xc2, 0xb6,
		0x2d, 0x51, 0x26, 0x69, 0xca, 0xad, 0x0a, 0xd0, 0x11, 0xe5, 0x8e, 0xa0, 0xe2, 0x29, 0xf7, 0xfe,
		0x04, 0xe5, 0x0e, 0x61, 0xe2, 0x2a, 0xb7, 0x9a, 0x4a, 0xc5, 0x90, 0x52, 0x82, 0x72, 0x8f, 0x0b,
		0x4a, 0x29, 0x49, 0xb9, 0x55, 0x01, 0x3a, 0xa2, 0x48, 0x61, 0x54, 0x3c, 0x45, 0x9a, 0x48, 0x50,
		0xa4, 0x5e, 0x48, 0x5c, 0x45, 0x52, 0xd3, 0x88, 0x88, 0xa5, 0x85, 0xc1, 0x24, 0x58, 0x1a, 0x4a,
		0xb0, 0xb4, 0x5e, 0x3c, 0x09, 0x96, 0xa6, 0xa6, 0x93, 0xa1, 0x36, 0x9c, 0xf0, 0x40, 0xd8, 0x7c,
		0xed, 0x39, 0x40, 0x80, 0x5c, 0x64, 0x02, 0xf1, 0xb8, 0xda, 0x5c, 0xb5, 0x39, 0xea, 0xf2, 0x5f,
		0xa3, 0x57, 0xe0, 0x98, 0xff, 0xe1, 0x4d, 0xc3, 0x66, 0x7d, 0xf6, 0x20, 0xf9, 0x6c, 0x85, 0xff,
		0xd9, 0x55, 0x6f, 0x5e, 0xfc, 0xa3, 0xd3, 0x2e, 0xef, 0x25, 0xfa, 0xae, 0x04, 0x0b, 0x11, 0x15,
		0x55, 0x4d, 0x0d, 0xd7, 0x6b, 0x36, 0x7e, 0xa5, 0x85, 0x1d, 0xe6, 0xea, 0x0f, 0x11, 0x18, 0x2f,
		0xa6, 0x6b, 0x2a, 0xe1, 0xa4, 0x04, 0x8c, 0xe2, 0xb8, 0xe6, 0x54, 0x61, 0x6a, 0xf4, 0x23, 0x09,
		0xae, 0x50, 0x4c, 0x01, 0x44, 0x31, 0x25, 0x9e, 0x24, 0x68, 0x97, 0x99, 0x68, 0xe9, 0xd7, 0xfc,
		0x4f, 0x8b, 0x68, 0x74, 0xc5, 0xce, 0x34, 0x03, 0x7d, 0x59, 0x82, 0x73, 0x2c, 0xf1, 0xb2, 0x80,
		0x1e, 0x16, 0xd4, 0xee, 0x65, 0xca, 0x21, 0x45, 0xbb, 0x39, 0x64, 0xe8, 0xb3, 0x70, 0xd2, 0x57,
		0x32, 0x3e, 0x92, 0x29, 0x82, 0xe4, 0x12, 0x5f, 0xcf, 0xf8, 0x10, 0x7c, 0x05, 0xe6, 0x7d, 0xfb,
		0x0b, 0x12, 0x9c, 0xa1, 0x9b, 0x47, 0x15, 0x9d, 0xb3, 0x69, 0xd3, 0x04, 0xc1, 0xb3, 0x4c, 0x04,
		0x3e, 0x73, 0x5f, 0xdf, 0x39, 0xdb, 0x34, 0xa3, 0xa5, 0xd0, 0xa0, 0xcf, 0xc1, 0x4c, 0x43, 0xb5,
		0xb7, 0xb1, 0x5d, 0xb3, 0xb1, 0x66, 0xd9, 0x3a, 0x0b, 0xc4, 0x11, 0x02, 0x62, 0x91, 0x09, 0xe2,
		0xe3, 0x64, 0xb2, 0x42, 0xe7, 0xc6, 0x11, 0x1c, 0x6f, 0x24, 0x11, 0xa0, 0x6f, 0x4a, 0x30, 0xcf,
		0xba, 0x9f, 0x18, 0x0f, 0x4d, 0x95, 0x29, 0x90, 0xa3, 0x59, 0xc2, 0xd7, 0x7b, 0x94, 0x8d, 0x48,
		0xf8, 0xca, 0xa1, 0x45, 0xdf, 0x91, 0xa0, 0xc2, 0x8a, 0xb0, 0xb1, 0xdd, 0x30, 0x4c, 0x95, 0xe9,
		0x17, 0x8e, 0x25, 0xf8, 0x85, 0x78, 0x88, 0xdd, 0x61, 0xc4, 0xf0, 0x0b, 0x6d, 0x61, 0x6a, 0xf4,
		0x63, 0x09, 0xae, 0xb0, 0xae, 0x52, 0xa9, 0x5e, 0xec, 0x38, 0x41, 0x7b, 0x4b, 0xf0, 0x46, 0x95,
		0xe6, 0xca, 0x16, 0xda, 0xd9, 0xa6, 0xf0, 0x34, 0x80, 0x6f, 0x94, 0x27, 0xb2, 0x68, 0x00, 0xdf,
		0x40, 0x67, 0xdb, 0x82, 0xb4, 0xe8, 0x6f, 0x12, 0xac, 0x44, 0x3c, 0x2e, 0x7e, 0xe4, 0x62, 0xdb,
		0x54, 0xeb, 0x35, 0x06, 0x72, 0xc3, 0x34, 0x5c, 0x83, 0xad, 0x18, 0x27, 0x09, 0xf4, 0x7b, 0xe9,
		0x2e, 0x78, 0x85, 0xf2, 0x8f, 0xad, 0xa7, 0x1a, 0x30, 0x8f, 0x2f, 0xe8, 0x05, 0x7b, 0x4f, 0x1c,
		0xd0, 0x9f, 0x25, 0xb8, 0x99, 0x61, 0x99, 0x3c, 0x8f, 0x35, 0x43, 0xd6, 0x78, 0x77, 0x0f, 0x6b,
		0xe4, 0x39, 0xb3, 0x1b, 0x76, 0xff, 0xd3, 0xd1, 0xbb, 0x12, 0x3c, 0x9f, 0xb4, 0x9c, 0x74, 0x3b,
		0x39, 0x45, 0x16, 0xb6, 0xc6, 0x5c, 0x18, 0x17, 0x4c, 0xaa, 0xbd, 0x5c, 0xc3, 0xfd, 0x4d, 0x25,
		0x71, 0x00, 0x33, 0x75, 0x62, 0xba, 0x86, 0xd9, 0xc2, 0x7a, 0x4d, 0x75, 0x6a, 0x26, 0x6e, 0xc7,
		0xd7, 0x21, 0x27, 0xc4, 0x01, 0x8c, 0x0c, 0x0a, 0x65, 0xb7, 0xe4, 0xdc, 0xc6, 0x6d, 0x46, 0x1c,
		0xd0, 0xce, 0x34, 0x03, 0xfd, 0x4a, 0x82, 0xeb, 0x24, 0x9a, 0xac, 0x69, 0x5b, 0x46, 0x5d, 0xcf,
		0x68, 0x3f, 0xa7, 0x09, 0xf4, 0x97, 0x98, 0xd0, 0x49, 0x28, 0xb9, 0xec, 0x31, 0xcd, 0x62, 0x34,
		0x97, 0x9d, 0xec, 0xd3, 0xd0, 0xcf, 0x24, 0xb8, 0x9a, 0xb2, 0x08, 0x9e, 0x75, 0x9c, 0x21, 0x2b,
		0x58, 0xc9, 0xba, 0x02, 0x9e, 0x49, 0x5c, 0x74, 0x32, 0xce, 0x41, 0xdf, 0x97, 0xe0, 0x12, 0x17,
		0x35, 0x37, 0xce, 0x7f, 0x9a, 0xc0, 0x5e, 0x62, 0x87, 0x21, 0xcc, 0xaf, 0x73, 0x03, 0xff, 0x79,
		0x2d, 0x03, 0x3d, 0xfa, 0xa1, 0x04, 0x97, 0xb9, 0x70, 0x13, 0x2e, 0x91, 0x67, 0x13, 0x94, 0x9c,
		0x0d, 0x38, 0xe1, 0x3a, 0x59, 0xd1, 0x32, 0xcd, 0x40, 0x6f, 0x4b, 0x70, 0x31, 0xb3, 0x66, 0x9c,
		0x23, 0x88, 0x3f, 0x96, 0x01, 0x31, 0x4f, 0x29, 0xce, 0x6b, 0x19, 0xf4, 0xe1, 0x1d, 0x09, 0x16,
		0xf9, 0x02, 0xe6, 0x1e, 0xc2, 0xb3, 0x04, 0xed, 0xcd, 0x2c, 0xf2, 0xe5, 0x9e, 0xc4, 0x17, 0xb4,
		0x2c, 0x13, 0xd0, 0x0f, 0x92, 0x54, 0x22, 0xe1, 0xd2, 0xfc, 0x4c, 0x66, 0xc8, 0xfc, 0xeb, 0x33,
		0x07, 0x32, 0xef, 0x22, 0xed, 0xc5, 0x66, 0x7c, 0xc8, 0x09, 0x91, 0xe4, 0x5c, 0x42, 0x6c, 0xc6,
		0xc1, 0x9c, 0x10, 0x4e, 0x2e, 0x68, 0xd9, 0xa6, 0x90, 0x43, 0xd3, 0x0f, 0xc5, 0xfb, 0x8d, 0x78,
		0xce, 0x27, 0x1c, 0x9a, 0x7e, 0xc4, 0xdd, 0x4f, 0xa8, 0x73, 0xcd, 0xe9, 0x6f, 0x2a, 0xfa, 0xb5,
		0x04, 0xcf, 0x09, 0x2c, 0x88, 0x67, 0xa3, 0xf3, 0x64, 0x35, 0xd5, 0x7e, 0x56, 0xc3, 0x33, 0xd6,
		0x2b, 0x4e, 0x1f, 0xf3, 0xd0, 0x4f, 0x25, 0x78, 0x36, 0x69, 0x01, 0xfc, 0xfb, 0xd3, 0x85, 0x84,
		0x03, 0x88, 0x0b, 0x82, 0x7f, 0x8f, 0xba, 0x88, 0x33, 0xce, 0x21, 0x0e, 0xa7, 0xd5, 0x74, 0xb0,
		0xed, 0x76, 0x81, 0x3b, 0x58, 0xb5, 0xb5, 0xad, 0x1e, 0x98, 0x71, 0xdc, 0x95, 0x04, 0xeb, 0xbd,
		0x4f, 0xd8, 0x05, 0x08, 0xee, 0x11, 0x66, 0xdd, 0x2f, 0x32, 0xac, 0xb7, 0x95, 0x65, 0xc2, 0xcd,
		0x51, 0x80, 0x2e, 0x10, 0xf9, 0xaf, 0x65, 0x38, 0x27, 0x7a, 0x7a, 0xad, 0xc2, 0xbe, 0xce, 0x1a,
		0xdd, 0xdd, 0x26, 0x26, 0xb5, 0x40, 0x5e, 0x65, 0x31, 0x60, 0xba, 0xbe, 0xdb, 0xc4, 0xca, 0x68,
		0xbb, 0xe7, 0x09, 0x7d, 0x1a, 0x0e, 0x35, 0x55, 0xdb, 0x93, 0x48, 0xaf, 0xd1, 0x6d, 0x5a, 0xb4,
		0x7c, 0x38, 0xcb, 0xe4, 0x77, 0x97, 0xcc, 0xe8, 0xb1, 0x89, 0x4d, 0x4b, 0x39, 0xd0, 0x8c, 0x0f,
		0xa2, 0xe7, 0xa0, 0x44, 0x32, 0x32, 0x75, 0xc3, 0x71, 0x49, 0x61, 0xb1, 0xbc, 0x78, 0x9c, 0x9d,
		0xf2, 0x50, 0x9d, 0xed, 0x35, 0xc3, 0x71, 0x95, 0x11, 0x97, 0xfe, 0x85, 0x16, 0x61, 0xd8, 0x30,
		0x9b, 0x2d, 0x97, 0x94, 0x1d, 0xcb, 0x8b, 0xc7, 0x38, 0x48, 0x76, 0xeb, 0x96, 0xaa, 0x2b, 0x3e,
		0x29, 0x52, 0x61, 0x26, 0x12, 0x72, 0xd4, 0x5c, 0xab, 0xa6, 0xd5, 0x2d, 0x07, 0x13, 0xff, 0x6d,
		0xb5, 0x5c, 0x5a, 0x87, 0x9c, 0x8e, 0xd5, 0x45, 0x6f, 0xd1, 0x4a, 0xb2, 0x72, 0x0c, 0x87, 0x64,
		0xbf, 0x6e, 0x2d, 0x7b, 0xf3, 0xd7, 0xfd, 0xe9, 0xe8, 0x65, 0x38, 0xda, 0x4d, 0x7b, 0xc7, 0xb9,
		0x17, 0xd2, 0xb8, 0x1f, 0x76, 0x83, 0x64, 0x76, 0x84, 0xf1, 0x0d, 0x38, 0xd2, 0x8d, 0xb0, 0xbb,
		0xab, 0xb0, 0x5b, 0x66, 0xcd, 0xd0, 0x49, 0xe9, 0xaf, 0xa4, 0x1c, 0xee, 0x50, 0x74, 0xe4, 0xac,
		0xb4, 0xcc, 0xaa, 0x8e, 0xaa, 0x50, 0xa2, 0xae, 0xd2, 0xb2, 0x49, 0x1d, 0x6e, 0x6c, 0xf1, 0x3c,
		0xdb, 0xb5, 0x53, 0x06, 0x24, 0x84, 0xae, 0x06, 0x53, 0x94, 0xee, 0x6c, 0x54, 0x85, 0x89, 0x2e,
		0x0e, 0xcf, 0x5d, 0xb5, 0x6c, 0x4c, 0x8b, 0x67, 0xec, 0x3d, 0x58, 0xf5, 0x69, 0x94, 0xf1, 0xce,
		0x34, 0x3a, 0x82, 0x14, 0x98, 0xac, 0xab, 0xde, 0x9d, 0xcf, 0x0f, 0x67, 0xc8, 0x72, 0xb0, 0xd3,
		0xaa, 0xbb, 0xb4, 0xf0, 0x95, 0xbc, 0xa7, 0x07, 0xbd, 0xb9, 0xcb, 0x9d, 0xa9, 0x0a, 0x99, 0x89,
		0xae, 0xc3, 0xb4, 0x65, 0x1b, 0x0f, 0x0d, 0xdf, 0xd1, 0x46, 0xa4, 0x54, 0x26, 0x52, 0x9a, 0x0c,
		0x08, 0x22, 0x42, 0x3a, 0x02, 0x23, 0x86, 0x8e, 0x4d, 0xd7, 0x70, 0x77, 0x49, 0x45, 0xa9, 0xa4,
		0x74, 0x9e, 0xd1, 0x65, 0x98, 0xdc, 0x34, 0x6c, 0xc7, 0x8d, 0xf3, 0xdc, 0x47, 0x28, 0x0f, 0x90,
		0xb7, 0x11, 0x86, 0xcb, 0x30, 0x6a, 0x63, 0xd7, 0xde, 0xad, 0x35, 0xad, 0xba, 0xa1, 0xed, 0xd2,
		0x2a, 0xcc, 0x0c, 0xe7, 0x82, 0xea, 0xda, 0xbb, 0x77, 0x09, 0x9d, 0x52, 0xb6, 0xbb, 0x0f, 0x68,
		0x0a, 0x8a, 0xaa, 0xeb, 0xe2, 0x46, 0xd3, 0x25, 0x15, 0x93, 0x61, 0x25, 0x78, 0x44, 0xcb, 0xb0,
		0x1f, 0x3f, 0x6a, 0x1a, 0xbe, 0xe2, 0xf8, 0x45, 0xfd, 0xf1, 0xd4, 0xa2, 0xfe, 0x58, 0x77, 0x0a,
		0xa9, 0xec, 0x9f, 0x86, 0x7d, 0x9a, 0xed, 0x59, 0x03, 0xad, 0xe8, 0x90, 0x8a, 0x43, 0x49, 0x19,
		0xf5, 0x06, 0x83, 0x2a, 0x0f, 0xfa, 0x04, 0x1c, 0xf5, 0x57, 0x1f, 0xae, 0x7e, 0x6d, 0xa8, 0xda,
		0xb6, 0xb5, 0xb9, 0x49, 0x8b, 0x02, 0x09, 0x4a, 0x3d, 0x45, 0x66, 0xf7, 0x16, 0xbe, 0x6e, 0xfa,
		0x53, 0xd1, 0x05, 0x18, 0x6a, 0xe0, 0x86, 0x45, 0xd3, 0xf9, 0xd3, 0xec, 0x44, 0x1f, 0x6e, 0x58,
		0x0a, 0x21, 0x43, 0x0a, 0x4c, 0xc4, 0x3c, 0x36, 0xcd, 0xc9, 0x3f, 0xcd, 0x3e, 0x1b, 0x23, 0x1e,
		0x56, 0x19, 0x77, 0x22, 0x23, 0xe8, 0x3e, 0x4c, 0x36, 0x6d, 0xbc, 0x53, 0x53, 0x5b, 0xae, 0xe5,
		0xe9, 0x1f, 0x76, 0x6b, 0x4d, 0xcb, 0x30, 0xdd, 0x20, 0xcb, 0xce, 0xdb, 0x2f, 0x07, 0xbb, 0x77,
		0x09, 0x9d, 0x72, 0xc0, 0x9b, 0xbf, 0xd4, 0x72, 0xad, 0x9e, 0x41, 0x74, 0x19, 0x0a, 0x5b, 0x58,
		0xd5, 0xb1, 0x4d, 0xd3, 0xdf, 0x47, 0xd9, 0x4d, 0x1d, 0x84, 0x44, 0xa1, 0xa4, 0xf2, 0xdb, 0x12,
		0x3c, 0x23, 0x1e, 0xed, 0x5f, 0x81, 0x02, 0xb5, 0x17, 0x49, 0xc0, 0x5e, 0x28, 0x2d, 0x5a, 0x85,
		0x99, 0xe4, 0x72, 0xaf, 0xa1, 0x13, 0xef, 0x9e, 0x57, 0x8e, 0xf1, 0x2b, 0xb5, 0x55, 0x5d, 0x7e,
		0x4b, 0x82, 0xb3, 0x82, 0x41, 0xc3, 0x55, 0x28, 0x06, 0x9e, 0x42, 0x12, 0xf0, 0x14, 0x01, 0xf1,
		0xc0, 0xa0, 0x5a, 0x30, 0x2b, 0x1c, 0x31, 0x2f, 0xc3, 0x28, 0x75, 0xd6, 0xdd, 0x83, 0x73, 0x8c,
		0xa3, 0x04, 0xd4, 0x37, 0x93, 0x73, 0xb3, 0xec, 0x76, 0x1f, 0xe4, 0xdf, 0x4b, 0x70, 0x46, 0xa4,
		0x69, 0x20, 0x7c, 0x02, 0x4a, 0xd9, 0x4e, 0xc0, 0xdb, 0x30, 0xc9, 0x39, 0x65, 0x72, 0x69, 0x06,
		0x79, 0xc0, 0x61, 0x9c, 0x30, 0x3d, 0x9e, 0x26, 0x1f, 0xf2, 0x34, 0xf2, 0x6b, 0x12, 0xc8, 0xe9,
		0xfd, 0x06, 0x68, 0x1e, 0x50, 0xb4, 0x06, 0xdd, 0xe9, 0x42, 0x1a, 0x77, 0x42, 0x22, 0x88, 0xb8,
		0xdb, 0x5c, 0xc4, 0xdd, 0x1e, 0x07, 0x08, 0x12, 0x82, 0x86, 0x4e, 0xd0, 0x94, 0x94, 0x12, 0x1d,
		0xa9, 0xea, 0xf2, 0x3f, 0x22, 0xe2, 0xe5, 0x5a, 0x48, 0x36, 0x44, 0xb3, 0x30, 0x1e, 0xce, 0x43,
		0x74, 0xd4, 0x6b, 0xcc, 0xe9, 0x59, 0x71, 0x04, 0x7b, 0x3e, 0x82, 0xfd, 0x1c, 0xec, 0xdf, 0x30,
		0x4c, 0xd5, 0xde, 0xad, 0x69, 0x5b, 0x58, 0xdb, 0x76, 0x5a, 0x0d, 0x12, 0xa2, 0x94, 0x94, 0x31,
		0x7f, 0x78, 0x99, 0x8e, 0xa2, 0xf3, 0x30, 0x11, 0xce, 0x9e, 0xe1, 0x47, 0x7e, 0xf8, 0x31, 0xaa,
		0x8c, 0xe3, 0xde, 0xa4, 0x16, 0x7e, 0xe4, 0xca, 0xaf, 0xe6, 0xe1, 0xb4, 0x40, 0x2b, 0xc3, 0x63,
		0x5b, 0x71, 0xd4, 0x2c, 0xf2, 0x7d, 0x98, 0x05, 0x3a, 0x01, 0xe5, 0x0d, 0xd5, 0xc1, 0xc1, 0xd1,
		0xe9, 0x8b, 0xa5, 0xe4, 0x0d, 0xf9, 0x07, 0xe6, 0x31, 0x00, 0x13, 0xb7, 0x83, 0xd7, 0xc3, 0xbe,
		0x60, 0x4d, 0xdc, 0xf6, 0xdf, 0xce, 0x03, 0xda, 0xb4, 0xec, 0x6d, 0x8a, 0x34, 0xe8, 0x47, 0x2b,
		0xf8, 0x4b, 0xf3, 0xde, 0x10, 0xac, 0x0f, 0x68, 0x63, 0xda, 0xa4, 0xe7, 0x1c, 0x55, 0xc7, 0x32,
		0x69, 0x6c, 0x44, 0x9f, 0xd0, 0x2d, 0x18, 0xd6, 0xd4, 0x96, 0x83, 0x69, 0x18, 0x54, 0x11, 0x6e,
		0x1a, 0x59, 0xf6, 0x66, 0x29, 0xfe, 0x64, 0xf9, 0xad, 0x3c, 0x9c, 0x4a, 0x6d, 0xe4, 0x78, 0x6c,
		0x9b, 0x71, 0x33, 0x58, 0x83, 0xbf, 0x0b, 0xf3, 0x82, 0x7d, 0x26, 0xbd, 0x2b, 0xe8, 0xf5, 0xc9,
		0x43, 0x59, 0x7c, 0x72, 0xaf, 0xea, 0x0f, 0x47, 0x54, 0x3f, 0xb2, 0xbf, 0x85, 0xe4, 0xfd, 0x2d,
		0x0a, 0xed, 0xef, 0x08, 0x67, 0x7f, 0x19, 0x66, 0x56, 0x62, 0x99, 0x99, 0xfc, 0x8d, 0x02, 0x9c,
		0x11, 0xe9, 0x71, 0x41, 0x27, 0xa1, 0xdc, 0x29, 0x14, 0xd3, 0x6d, 0x2a, 0x29, 0x10, 0x0c, 0x55,
		0x75, 0xef, 0x52, 0xd5, 0xad, 0x24, 0x7b, 0x46, 0x90, 0x4b, 0xb8, 0x54, 0x75, 0x3e, 0x49, 0x2e,
		0x55, 0x6a, 0xcf, 0x93, 0xa7, 0x9a, 0xba, 0xd5, 0x50, 0x0d, 0x93, 0xfa, 0x0e, 0xfa, 0x14, 0x3e,
		0x0c, 0x86, 0xfa, 0xbc, 0x0e, 0x15, 0xc4, 0xaf, 0x43, 0xeb, 0x30, 0x1d, 0x28, 0x61, 0xfc, 0x0c,
		0x29, 0xa6, 0x9d, 0x21, 0x93, 0xc1, 0xdc, 0xc8, 0x31, 0x12, 0xe1, 0x4a, 0x8f, 0x28, 0xca, 0x75,
		0x24, 0x03, 0x57, 0xff, 0x16, 0x44, 0xb9, 0xf2, 0x0f, 0xbb, 0x52, 0x5f, 0x87, 0xdd, 0x2a, 0x4c,
		0x6c, 0x61, 0xd5, 0x76, 0x37, 0xb0, 0xda, 0x45, 0x07, 0x69, 0xac, 0xc6, 0x3b, 0x73, 0xba, 0x7c,
		0xd2, 0x43, 0x94, 0x72, 0x7a, 0x88, 0x12, 0xbb, 0x2b, 0x8c, 0xf6, 0x73, 0x57, 0xe8, 0xc6, 0x9c,
		0xfb, 0xc4, 0x63, 0xce, 0xbf, 0x4b, 0x20, 0xa7, 0xf7, 0x5b, 0x7d, 0x60, 0x87, 0x7b, 0x6f, 0x18,
		0x32, 0x14, 0xbe, 0xf0, 0xbc, 0x08, 0xa3, 0xe4, 0xbe, 0x18, 0xf8, 0xad, 0x61, 0x01, 0xbf, 0x55,
		0xf6, 0x66, 0xd0, 0x07, 0xf9, 0x8f, 0x52, 0xd8, 0x15, 0x0c, 0x38, 0xb2, 0x66, 0x8b, 0x28, 0x97,
		0xc1, 0xdd, 0xe7, 0x53, 0xa3, 0x8d, 0xa1, 0xb0, 0x30, 0xe5, 0x3f, 0x48, 0x70, 0x2a, 0xbd, 0x09,
		0xa6, 0xdf, 0x00, 0xfc, 0xc3, 0x58, 0xd1, 0xcf, 0x73, 0x70, 0x5a, 0xa0, 0x95, 0xcc, 0x5b, 0x93,
		0x8e, 0x5d, 0xd5, 0xa8, 0x3b, 0x42, 0x9b, 0x14, 0x10, 0x3f, 0xb6, 0x35, 0x45, 0x23, 0xa4, 0xa1,
		0x7e, 0x22, 0xa4, 0x3d, 0xab, 0xf8, 0x57, 0x24, 0x98, 0x13, 0xef, 0x00, 0x13, 0x39, 0xf3, 0x06,
		0x73, 0x05, 0x7b, 0x47, 0x82, 0x8c, 0xbd, 0x5e, 0xe9, 0xd8, 0x0e, 0x06, 0x61, 0x90, 0xef, 0x61,
		0x68, 0x60, 0x23, 0x82, 0x38, 0x2f, 0x80, 0xf8, 0xcd, 0x88, 0x1e, 0xf2, 0xaa, 0x42, 0xfd, 0xea,
		0xe1, 0x2a, 0xcc, 0xd4, 0x55, 0xb7, 0xa7, 0xe7, 0x21, 0xda, 0x01, 0xd0, 0x95, 0xac, 0x4f, 0xc7,
		0xda, 0x4a, 0x3f, 0x6c, 0x62, 0xe8, 0x73, 0x3e, 0x83, 0x3e, 0x0f, 0xa5, 0xda, 0x68, 0x24, 0xd0,
		0x93, 0xdf, 0x95, 0xe0, 0x68, 0x42, 0x97, 0x25, 0x9a, 0x86, 0x11, 0xbf, 0xbb, 0xac, 0xb3, 0x6f,
		0x45, 0xf2, 0x5c, 0xd5, 0xd1, 0x1a, 0x1c, 0xea, 0x1c, 0xe4, 0x9b, 0x86, 0x9d, 0xe1, 0xd2, 0x8a,
		0xe8, 0x39, 0xbe, 0x6a, 0xd8, 0x38, 0xcb, 0xf1, 0x2b, 0xb2, 0xd9, 0x9f, 0x81, 0x69, 0x6e, 0xfb,
		0x66, 0xd2, 0x6a, 0x84, 0x63, 0x76, 0xf9, 0x37, 0x12, 0x1c, 0x4b, 0xea, 0xdc, 0x1b, 0xc8, 0x57,
		0x06, 0x25, 0x8f, 0x44, 0x07, 0xfd, 0x13, 0x09, 0x66, 0xd2, 0x3a, 0x00, 0x93, 0x56, 0xf3, 0x58,
		0xcd, 0x36, 0x11, 0xf9, 0xbf, 0x8b, 0x90, 0xb1, 0xd1, 0x04, 0x2d, 0xc0, 0x41, 0xd2, 0xcb, 0x12,
		0x4d, 0xfb, 0xfa, 0x6b, 0x9a, 0x30, 0x71, 0x3b, 0x92, 0xf4, 0x8d, 0x55, 0x5e, 0x72, 0xfd, 0x55,
		0x5e, 0x9e, 0xd4, 0x46, 0xc4, 0x6b, 0x23, 0x22, 0xba, 0x53, 0x14, 0xd0, 0x9d, 0x3b, 0x30, 0x49,
		0x73, 0xda, 0x14, 0xa3, 0x61, 0xba, 0xd8, 0xde, 0x51, 0xeb, 0xe9, 0xf7, 0x96, 0x83, 0x74, 0x22,
		0x81, 0x57, 0xa5, 0xd3, 0xc2, 0x75, 0x97, 0xd2, 0x9e, 0xea, 0x2e, 0x3d, 0x21, 0x1c, 0x64, 0x09,
		0xe1, 0xf8, 0x45, 0x96, 0x72, 0xdf, 0x45, 0x96, 0xee, 0x3d, 0x63, 0x54, 0xf8, 0x9e, 0xd1, 0x49,
		0xf5, 0xef, 0xdb, 0x43, 0xaa, 0x7f, 0x6c, 0x4f, 0xa9, 0x7e, 0xcf, 0x07, 0x2f, 0x64, 0xed, 0x76,
		0xeb, 0x78, 0x2b, 0xa9, 0xd7, 0x5b, 0x25, 0xdd, 0x6f, 0x36, 0xe0, 0x70, 0xa7, 0x42, 0x1e, 0xa9,
		0x9a, 0xfa, 0x76, 0x3c, 0x97, 0x58, 0x03, 0x0f, 0xd7, 0x4d, 0x0f, 0x61, 0xd6, 0xb0, 0xfc, 0x3d,
		0x89, 0x91, 0xd2, 0xe6, 0x9d, 0x2c, 0x22, 0xe6, 0x21, 0x09, 0x98, 0x47, 0x4f, 0xa4, 0x93, 0xcb,
		0x10, 0xe9, 0xc8, 0xef, 0x4b, 0x70, 0x3c, 0xb1, 0x5b, 0xdb, 0x0b, 0xf5, 0x68, 0x2f, 0xb8, 0xa9,
		0x36, 0x02, 0x51, 0x83, 0x3f, 0x74, 0x5b, 0x6d, 0xe0, 0x7e, 0x3f, 0x3d, 0xb0, 0x53, 0xa5, 0xab,
		0xf1, 0x43, 0xe2, 0x37, 0xeb, 0xaf, 0xb1, 0x36, 0x89, 0xd7, 0x9d, 0x70, 0x12, 0xca, 0xb4, 0x3f,
		0xa4, 0x57, 0x04, 0xfe, 0x10, 0x11, 0x41, 0xc7, 0xa9, 0xe7, 0xc4, 0x9d, 0x7a, 0x42, 0x9e, 0x5a,
		0xfe, 0xaa, 0x04, 0x73, 0x19, 0x3a, 0x72, 0xba, 0xf9, 0x54, 0x29, 0x94, 0x4f, 0xed, 0x77, 0x67,
		0x92, 0xa0, 0xfd, 0x32, 0x07, 0x2f, 0xec, 0xad, 0x2b, 0x79, 0x60, 0x3a, 0xdf, 0xcd, 0xd5, 0xe5,
		0x42, 0xb9, 0xba, 0xfb, 0x80, 0xe2, 0xdd, 0x2f, 0xd4, 0xbe, 0xcf, 0x8a, 0x75, 0xb8, 0x2a, 0x13,
		0xb1, 0x16, 0x56, 0x34, 0x05, 0x45, 0xcd, 0x32, 0x5d, 0xdb, 0xaa, 0x13, 0x45, 0x1b, 0x55, 0x82,
		0x47, 0x54, 0x81, 0x03, 0x91, 0x46, 0x2e, 0xcb, 0xac, 0xfb, 0x91, 0xf9, 0x88, 0x32, 0x11, 0xea,
		0xaf, 0xba, 0x63, 0xd6, 0x77, 0xe5, 0x37, 0xf2, 0x70, 0x63, 0x0f, 0x5d, 0xcf, 0xe8, 0x7e, 0xaf,
		0xdf, 0x1b, 0xe3, 0xfc, 0xa6, 0x40, 0x88, 0x73, 0x28, 0xed, 0x3c, 0xa0, 0xfb, 0x24, 0x37, 0x87,
		0xca, 0xde, 0x97, 0xa1, 0xbd, 0xee, 0xcb, 0x3c, 0xa0, 0x68, 0xaf, 0x19, 0xad, 0x50, 0xe4, 0x95,
		0x71, 0x23, 0xa4, 0x84, 0x7e, 0x0a, 0x2b, 0xd8, 0xc5, 0x42, 0x68, 0x17, 0xe5, 0x3f, 0x49, 0x70,
		0xad, 0xcf, 0x96, 0x6d, 0x0e, 0x06, 0x89, 0x83, 0xe1, 0x83, 0x55, 0x5c, 0xf9, 0x4b, 0x79, 0xb8,
		0xd6, 0x67, 0x5b, 0xdd, 0xff, 0xaa, 0xad, 0x46, 0x3c, 0xf6, 0x10, 0xdf, 0x63, 0x0f, 0x8b, 0x7b,
		0x6c, 0xae, 0xea, 0xf0, 0x1c, 0x40, 0x91, 0xe7, 0x00, 0x5e, 0xcd, 0xc3, 0x95, 0x7e, 0x5a, 0x03,
		0xc5, 0x2c, 0x5f, 0x88, 0xf3, 0x13, 0xcb, 0xef, 0x5a, 0xfe, 0x7b, 0x12, 0x5c, 0xcc, 0xda, 0xe6,
		0xf8, 0x5f, 0x6d, 0xf2, 0xfc, 0xb3, 0x4a, 0xfe, 0x9d, 0x04, 0x17, 0x32, 0xb5, 0x46, 0x0e, 0xcc,
		0x05, 0x30, 0x6f, 0x0d, 0xb9, 0xbd, 0xdd, 0x1a, 0xfe, 0x32, 0x02, 0x97, 0xfb, 0xf8, 0x8d, 0x47,
		0xcf, 0x76, 0x48, 0xa1, 0xed, 0x38, 0x09, 0xe5, 0xce, 0x76, 0x50, 0x9d, 0x2f, 0x29, 0x10, 0x0c,
		0xb1, 0x52, 0x08, 0xf9, 0x01, 0xa4, 0x10, 0xfa, 0xad, 0x27, 0x0e, 0x0f, 0x36, 0x85, 0x50, 0x78,
		0xac, 0x29, 0x84, 0x62, 0xdf, 0x29, 0x84, 0x07, 0x40, 0x3b, 0x54, 0x29, 0x47, 0x5a, 0x86, 0xf3,
		0x9b, 0x04, 0xce, 0x26, 0xb4, 0xb9, 0x12, 0x2e, 0xb4, 0x18, 0x37, 0xd1, 0x8c, 0x0e, 0xf5, 0x1a,
		0x49, 0x29, 0xec, 0xcf, 0x45, 0x54, 0x1e, 0x04, 0x54, 0x5e, 0x83, 0xa9, 0x1e, 0x75, 0xaa, 0xd9,
		0xb8, 0xd5, 0x85, 0x5f, 0x26, 0xf0, 0xe7, 0x12, 0x15, 0xa7, 0xaa, 0x2b, 0xde, 0x14, 0xba, 0x84,
		0x43, 0x6d, 0xd6, 0x70, 0xac, 0x3c, 0xb9, 0xaf, 0x9f, 0xf2, 0x64, 0xac, 0xd7, 0x70, 0x8c, 0xd1,
		0x6b, 0xd8, 0xbd, 0x69, 0xed, 0xcf, 0x9e, 0x5b, 0x18, 0xdf, 0x43, 0x6e, 0x61, 0x62, 0x6f, 0x6d,
		0x84, 0xcf, 0x41, 0x59, 0xc7, 0x75, 0x75, 0xd7, 0x57, 0xcd, 0xf4, 0x9e, 0x48, 0x20, 0xd4, 0x44,
		0x15, 0xe5, 0xd7, 0xf3, 0x70, 0x31, 0xeb, 0x6f, 0xb0, 0x3e, 0x7c, 0xf7, 0xb2, 0x16, 0xc4, 0x09,
		0x7e, 0xa5, 0xeb, 0x6a, 0xe6, 0x1f, 0x10, 0x85, 0xc2, 0x83, 0x1e, 0x43, 0x19, 0x0e, 0x1b, 0x0a,
		0xfb, 0x10, 0x2c, 0x70, 0x0e, 0xc1, 0x01, 0xe5, 0x02, 0xe5, 0xdf, 0xe6, 0x60, 0x3e, 0xcb, 0x0f,
		0xcc, 0xb8, 0xfb, 0xc1, 0x3e, 0x7d, 0x73, 0x7b, 0x3d, 0x7d, 0x07, 0xb5, 0x8b, 0x6c, 0xe9, 0x0e,
		0x71, 0xa4, 0xdb, 0xb5, 0xce, 0x61, 0xf1, 0x3c, 0xc8, 0xfb, 0x39, 0xc8, 0xf8, 0xd3, 0xb7, 0x8f,
		0x86, 0x30, 0x59, 0x65, 0x9d, 0x61, 0x66, 0x59, 0xa7, 0xdb, 0x8f, 0x50, 0x10, 0xef, 0x47, 0x90,
		0xff, 0x99, 0x83, 0xf3, 0x83, 0xf0, 0x28, 0x1f, 0x51, 0xa1, 0xf7, 0x64, 0xdc, 0x0b, 0x19, 0x32,
		0xee, 0xf2, 0xbf, 0x72, 0x70, 0x21, 0xd3, 0x2f, 0x11, 0x9f, 0x08, 0x3e, 0x26, 0xf8, 0x20, 0xa5,
		0x58, 0xc8, 0x92, 0x67, 0xfe, 0x7c, 0x9e, 0x27, 0x78, 0x5e, 0x0f, 0xc9, 0x13, 0xc1, 0x27, 0xb6,
		0xb0, 0x14, 0xfa, 0xe9, 0x7d, 0xff, 0x45, 0x0e, 0x16, 0x32, 0xfe, 0x42, 0xf4, 0xc9, 0x3e, 0x84,
		0xf6, 0x61, 0xce, 0x85, 0xfd, 0xe4, 0xcf, 0x55, 0xa3, 0xee, 0x62, 0x9b, 0x7c, 0xea, 0x38, 0x4c,
		0xaf, 0x3c, 0x58, 0xb9, 0xbd, 0x5e, 0x5b, 0xad, 0xae, 0xad, 0xaf, 0x28, 0xb5, 0xf5, 0x4f, 0xde,
		0x5d, 0xa9, 0x55, 0x6f, 0x3f, 0x58, 0x5a, 0xab, 0xde, 0x1a, 0x7f, 0x0a, 0x9d, 0x84, 0xa3, 0xf1,
		0xd7, 0x4b, 0x6b, 0x6b, 0x35, 0x32, 0x3a, 0x2e, 0xa1, 0x53, 0x70, 0x3c, 0x4e, 0xb0, 0xbc, 0x76,
		0xe7, 0xde, 0x0a, 0x25, 0xc9, 0xdd, 0x7c, 0x00, 0x87, 0x35, 0xab, 0xc1, 0x92, 0xc1, 0xcd, 0x91,
		0xa5, 0xa6, 0x71, 0xd7, 0x0b, 0x61, 0xef, 0x4a, 0x9f, 0x5a, 0x78, 0x68, 0xb8, 0x5b, 0xad, 0x8d,
		0x8a, 0x66, 0x35, 0x16, 0x42, 0xff, 0xe7, 0xb4, 0xf2, 0x10, 0x9b, 0xfe, 0x7f, 0x56, 0xa5, 0xff,
		0xf2, 0xf4, 0x86, 0xda, 0x34, 0x76, 0x2e, 0x6d, 0x14, 0xc8, 0xd8, 0xe5, 0xff, 0x04, 0x00, 0x00,
		0xff, 0xff, 0xee, 0x07, 0x38, 0xbd, 0xd5, 0x55, 0x00, 0x00,
	},
	// uber/cadence/shared/v1/queue.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xec, 0x58, 0x4f, 0x6f, 0xdb, 0xc6,
		0x12, 0x37, 0x25, 0x5b, 0xb1, 0x47, 0x7e, 0x09, 0xb3, 0x79, 0x89, 0x15, 0xe7, 0x19, 0x51, 0x14,
		0x20, 0x11, 0xfc, 0x1c, 0xea, 0xc9, 0x41, 0x90, 0x87, 0xb6, 0x68, 0x41, 0x53, 0xb4, 0xc5, 0x46,
		0x91, 0x8c, 0x25, 0x65, 0xc7, 0xb9, 0x10, 0x94, 0xb8, 0xb6, 0x09, 0x4b, 0xa4, 0x42, 0xae, 0x9c,
		0xea, 0xde, 0xe4, 0xdc, 0x7e, 0x85, 0x7e, 0x87, 0x1e, 0xfa, 0x15, 0x0a, 0xf4, 0xd0, 0x1e, 0x7a,
		0x09, 0x7a, 0xee, 0xd7, 0x28, 0xb8, 0xa4, 0x2c, 0x4a, 0xa2, 0xfe, 0xd8, 0xc9, 0xa1, 0x87, 0xde,
		0xac, 0xd9, 0xdf, 0xcc, 0xfe, 0x66, 0x66, 0xe7, 0x8f, 0x09, 0xb9, 0x6e, 0x83, 0xb8, 0x85, 0xa6,
		0x61, 0x12, 0xbb, 0x49, 0x0a, 0xde, 0xa9, 0xe1, 0x12, 0xb3, 0x70, 0x5e, 0x2c, 0xbc, 0xe9, 0x92,
		0x2e, 0x11, 0x3a, 0xae, 0x43, 0x1d, 0x74, 0xc7, 0xc7, 0x08, 0x21, 0x46, 0x08, 0x30, 0xc2, 0x79,
		0x71, 0xfd, 0xfe, 0x89, 0xe3, 0x9c, 0xb4, 0x48, 0x81, 0xa1, 0x1a, 0xdd, 0xe3, 0x02, 0xb5, 0xda,
		0xc4, 0xa3, 0x46, 0xbb, 0x13, 0x28, 0xae, 0x67, 0x87, 0x8c, 0x1b, 0x1d, 0xcb, 0xb7, 0xdc, 0x74,
		0xda, 0x6d, 0xc7, 0x0e, 0x11, 0x0f, 0xe2, 0x10, 0xa7, 0x96, 0x47, 0x1d, 0xb7, 0x17, 0x40, 0x72,
		0x1f, 0x12, 0xf0, 0x6f, 0xc9, 0x75, 0x3c, 0x4f, 0x6a, 0x75, 0x3d, 0x4a, 0x5c, 0xcd, 0xf0, 0xce,
		0x14, 0xfb, 0xd8, 0x41, 0xf7, 0x60, 0xc5, 0x74, 0xda, 0x86, 0x65, 0xeb, 0x96, 0x99, 0xe1, 0xb2,
		0x5c, 0x7e, 0x05, 0x2f, 0x07, 0x02, 0xc5, 0x44, 0x75, 0x40, 0x6f, 0x1d, 0xf7, 0xec, 0xb8, 0xe5,
		0xbc, 0xd5, 0xc9, 0x37, 0xa4, 0xd9, 0xa5, 0x96, 0x63, 0x67, 0x12, 0x59, 0x2e, 0x9f, 0xde, 0x7e,
		0x24, 0x0c, 0x39, 0x64, 0x74, 0x2c, 0xe1, 0xbc, 0x28, 0x1c, 0x86, 0x70, 0xb9, 0x8f, 0xc6, 0x37,
		0xdf, 0x8e, 0x8a, 0x90, 0x02, 0x2b, 0xd4, 0xf0, 0xce, 0x74, 0xda, 0xeb, 0x90, 0x4c, 0x32, 0xcb,
		0xe5, 0xaf, 0x6f, 0x6f, 0x09, 0xf1, 0xe1, 0x11, 0x46, 0x49, 0x6b, 0xbd, 0x0e, 0xc1, 0xcb, 0x34,
		0xfc, 0x0b, 0x6d, 0x00, 0x30, 0x53, 0x1e, 0x35, 0x28, 0xc9, 0x2c, 0x66, 0xb9, 0xfc, 0x12, 0x66,
		0xc6, 0x55, 0x5f, 0x80, 0xd6, 0xe0, 0x1a, 0x3b, 0xb6, 0xcc, 0xcc, 0x52, 0x96, 0xcb, 0x27, 0x71,
		0xca, 0xff, 0xa9, 0x98, 0xa8, 0x02, 0xb7, 0xce, 0x2d, 0xcf, 0x6a, 0x58, 0x2d, 0x8b, 0xf6, 0xb4,
		0x7e, 0xc4, 0x33, 0x29, 0xe6, 0xda, 0xba, 0x10, 0xe4, 0x44, 0xe8, 0xe7, 0x44, 0xb8, 0x40, 0xe0,
		0x38, 0xb5, 0xdc, 0xef, 0x09, 0xf8, 0x5f, 0x94, 0xa8, 0x4a, 0x0d, 0x97, 0x4a, 0xa7, 0x56, 0xcb,
		0x1c, 0xc4, 0x81, 0xbc, 0xe9, 0x12, 0x8f, 0x8a, 0x94, 0xba, 0x56, 0xa3, 0x4b, 0x89, 0x87, 0xf2,
		0xc0, 0x53, 0xc3, 0x3d, 0x21, 0x54, 0x1f, 0x4d, 0xc0, 0xf5, 0x40, 0x5e, 0xea, 0xa7, 0x61, 0x03,
		0xc0, 0x0d, 0xd4, 0x7d, 0x4c, 0x82, 0x61, 0x56, 0x42, 0x89, 0x62, 0xa2, 0x2d, 0x40, 0x96, 0x6d,
		0x51, 0xcb, 0xa0, 0xc4, 0xd4, 0xc9, 0x39, 0xb1, 0x19, 0x2c, 0xc9, 0xfc, 0xe5, 0x2f, 0x4e, 0x64,
		0xff, 0x40, 0x31, 0xd1, 0x7b, 0x0e, 0xd6, 0x47, 0xe1, 0xc6, 0x05, 0x2b, 0x16, 0xc2, 0xf4, 0x76,
		0x39, 0x36, 0xb9, 0x03, 0xb7, 0xc6, 0xd2, 0xac, 0x0c, 0x5d, 0x33, 0xf0, 0x12, 0x67, 0xac, 0x09,
		0x27, 0x28, 0x07, 0xff, 0x0a, 0xfd, 0x77, 0xbb, 0x76, 0x3f, 0x43, 0x2b, 0x38, 0x1d, 0x08, 0x71,
		0xd7, 0x56, 0xcc, 0xdc, 0xd7, 0x50, 0x9c, 0x19, 0x57, 0xaf, 0xe3, 0xd8, 0x1e, 0x89, 0x18, 0xbe,
		0x0d, 0xa9, 0xd0, 0x62, 0x10, 0xce, 0x25, 0x97, 0xd9, 0xfa, 0x29, 0x01, 0x5b, 0x51, 0x63, 0x92,
		0x61, 0x37, 0x49, 0xeb, 0x93, 0x24, 0xa8, 0x01, 0x77, 0x43, 0xe4, 0x47, 0x97, 0xcb, 0x5a, 0x60,
		0x68, 0xec, 0x60, 0xe4, 0x11, 0x24, 0xe7, 0x7b, 0x04, 0x8b, 0x13, 0x1e, 0x81, 0x00, 0xb7, 0x9a,
		0x7e, 0x18, 0x07, 0x7c, 0x1d, 0xbb, 0xd5, 0x63, 0x19, 0x58, 0xc6, 0x37, 0x9b, 0xd1, 0x14, 0xd7,
		0xec, 0x56, 0x2f, 0x57, 0x80, 0x27, 0x53, 0x43, 0x37, 0x9a, 0x83, 0xdc, 0x8f, 0xc9, 0xe1, 0x60,
		0xab, 0xd6, 0x89, 0x6d, 0xfc, 0x13, 0xec, 0x79, 0x82, 0x8d, 0xee, 0x43, 0xda, 0x63, 0xe1, 0xd2,
		0x6d, 0xa3, 0x4d, 0x58, 0x4f, 0x5a, 0xc1, 0x10, 0x88, 0xaa, 0x46, 0x9b, 0xa0, 0xaf, 0x60, 0x35,
		0x04, 0x58, 0x76, 0xa7, 0x4b, 0x33, 0xd7, 0x98, 0xd3, 0xff, 0x89, 0x75, 0x7a, 0xdf, 0xe8, 0xb5,
		0x1c, 0xc3, 0xc4, 0xa1, 0x49, 0xc5, 0x57, 0x40, 0x19, 0xb8, 0xd6, 0x74, 0x6c, 0xea, 0x3a, 0xad,
		0xcc, 0x72, 0x96, 0xcb, 0xaf, 0xe2, 0xfe, 0xcf, 0xd1, 0x44, 0x8f, 0xa5, 0x6d, 0x2c, 0xd1, 0xbf,
		0x24, 0x40, 0x8c, 0x6a, 0x60, 0xd2, 0x74, 0x5c, 0x33, 0xbe, 0x49, 0x48, 0x4e, 0xbb, 0xd3, 0x22,
		0x94, 0xfc, 0xdd, 0xb3, 0x7f, 0xb9, 0x86, 0x5a, 0x01, 0xbe, 0x19, 0x38, 0x66, 0x39, 0x76, 0x00,
		0x0f, 0xbb, 0xe8, 0x83, 0x58, 0x22, 0xe5, 0x60, 0x30, 0x33, 0x75, 0x7c, 0x63, 0xa0, 0xca, 0x04,
		0xb9, 0x12, 0xec, 0x5c, 0x3e, 0x9c, 0x63, 0x59, 0xf9, 0x73, 0x09, 0xd6, 0x46, 0x27, 0x67, 0x18,
		0xf5, 0x8b, 0xe9, 0x6b, 0xd9, 0xc7, 0x0e, 0x0b, 0x72, 0x7a, 0xfe, 0xe9, 0xeb, 0xaf, 0x0c, 0xc1,
		0xf4, 0x65, 0xcb, 0xc3, 0x77, 0x1c, 0x6c, 0x78, 0xe3, 0x3d, 0x79, 0x40, 0x24, 0xcc, 0x48, 0x79,
		0x1e, 0xfb, 0xf3, 0x0c, 0xcd, 0xf2, 0x02, 0x9e, 0x7e, 0x21, 0xfa, 0x96, 0x83, 0xbb, 0xcd, 0xe1,
		0xf6, 0x14, 0xa1, 0x93, 0x64, 0x74, 0x4a, 0xf3, 0xd0, 0x99, 0x35, 0x1e, 0xca, 0x0b, 0x78, 0xf2,
		0x45, 0x8c, 0x86, 0x37, 0x5c, 0x3c, 0xe2, 0xe8, 0x90, 0x9d, 0x8b, 0xc6, 0xac, 0xc6, 0xe9, 0xd3,
		0x98, 0x78, 0x11, 0xfa, 0x95, 0x83, 0x67, 0xee, 0x55, 0x2a, 0x92, 0x75, 0xa7, 0xf4, 0xf6, 0xd1,
		0x3c, 0x14, 0xaf, 0x54, 0xf2, 0xe5, 0x05, 0x7c, 0x35, 0x66, 0x3b, 0xab, 0x00, 0x83, 0x7d, 0x25,
		0xf7, 0x47, 0x0a, 0x32, 0xe3, 0x2f, 0x3d, 0x28, 0x88, 0xe8, 0xfa, 0xc7, 0x0d, 0xad, 0x7f, 0x43,
		0x1b, 0x68, 0xe2, 0xa3, 0x36, 0xd0, 0x03, 0x58, 0x3d, 0x36, 0xac, 0x16, 0x31, 0xf5, 0xa6, 0xd1,
		0xf5, 0xfa, 0xfb, 0xec, 0xd3, 0x79, 0xad, 0xed, 0x32, 0x5d, 0xc9, 0x57, 0xc5, 0xe9, 0xe3, 0xc1,
		0x0f, 0xf4, 0xfd, 0xcc, 0xda, 0x0a, 0x5e, 0x91, 0x72, 0xe5, 0xda, 0x1a, 0xed, 0x1a, 0xb3, 0x8b,
		0xeb, 0xdd, 0xd4, 0xe2, 0x0a, 0x9e, 0x8c, 0x7c, 0xa5, 0xe2, 0x8a, 0xe1, 0x32, 0xa5, 0xba, 0xde,
		0x4d, 0xad, 0xae, 0xd4, 0xfc, 0x3c, 0x66, 0xce, 0xb7, 0xe9, 0xe5, 0xf5, 0xdb, 0x95, 0xcb, 0x2b,
		0x18, 0xd9, 0xaf, 0x3f, 0x5d, 0x79, 0xc5, 0x10, 0xff, 0x24, 0xf5, 0xd5, 0x89, 0x2b, 0x2f, 0xa6,
		0xe2, 0x21, 0xcd, 0xdf, 0xe0, 0xbd, 0x33, 0x3d, 0x5c, 0x8c, 0xbc, 0x0c, 0x97, 0x4d, 0xe6, 0xd3,
		0xdb, 0x85, 0x79, 0xdf, 0x7e, 0x68, 0x08, 0xaf, 0xd2, 0x88, 0xd5, 0xcd, 0xf7, 0x1c, 0x2c, 0xf7,
		0xeb, 0x0c, 0xdd, 0x86, 0x9b, 0x9a, 0xa8, 0xbe, 0xd0, 0xb5, 0xa3, 0x7d, 0x59, 0x57, 0xaa, 0x07,
		0x62, 0x45, 0x29, 0xf1, 0x0b, 0xe8, 0x0e, 0xa0, 0x81, 0x58, 0xc3, 0x62, 0x55, 0xdd, 0x95, 0x31,
		0xcf, 0xa1, 0x5b, 0x70, 0x23, 0x22, 0x57, 0x5e, 0xca, 0x98, 0x4f, 0xa0, 0xbb, 0x70, 0x7b, 0x20,
		0xc4, 0xf2, 0x7e, 0x45, 0x91, 0x44, 0x4d, 0xa9, 0x55, 0xf9, 0x24, 0xba, 0x07, 0x6b, 0x83, 0x23,
		0x09, 0xd7, 0x54, 0x55, 0x97, 0x2a, 0x75, 0x55, 0x93, 0x31, 0xbf, 0xb8, 0xf9, 0x33, 0x37, 0xfe,
		0x3f, 0x33, 0x23, 0xf5, 0x10, 0xee, 0x0f, 0x61, 0xf5, 0x38, 0x8a, 0x45, 0x78, 0x32, 0x09, 0xa4,
		0x6a, 0x22, 0xd6, 0x74, 0xa9, 0xac, 0x54, 0x4a, 0xba, 0xfc, 0x4a, 0x96, 0xea, 0x8c, 0x0d, 0x87,
		0xb6, 0x20, 0x3f, 0x49, 0x45, 0x12, 0xab, 0x92, 0x5c, 0x89, 0xa0, 0x13, 0xd3, 0xd0, 0xaa, 0xb2,
		0x57, 0x15, 0xa3, 0xe8, 0xe4, 0xe6, 0x0f, 0x49, 0xb8, 0x37, 0xa5, 0xf7, 0xa0, 0xff, 0xc2, 0xe3,
		0x18, 0x6b, 0xbb, 0xa2, 0x52, 0x91, 0x4b, 0xba, 0x24, 0xd6, 0xd5, 0xa8, 0x6f, 0xcf, 0xa0, 0x38,
		0x0b, 0x5c, 0xaa, 0xbd, 0x14, 0x95, 0xaa, 0x5e, 0xad, 0x69, 0xba, 0x28, 0x69, 0xca, 0x81, 0xcc,
		0x73, 0x97, 0x54, 0x93, 0x5f, 0x29, 0xaa, 0xa6, 0xf2, 0x09, 0xf4, 0x05, 0xfc, 0x7f, 0x96, 0xda,
		0x61, 0x0d, 0xbf, 0xd8, 0xad, 0xd4, 0x0e, 0x75, 0xb1, 0x82, 0x65, 0xb1, 0x74, 0xa4, 0xe3, 0x7a,
		0xb5, 0xaa, 0x54, 0xf7, 0xf8, 0x24, 0x7a, 0x0e, 0x4f, 0xe7, 0xd6, 0x8e, 0x5c, 0xbb, 0x88, 0xbe,
		0x84, 0xcf, 0x2e, 0x7d, 0xad, 0x54, 0x7b, 0xb9, 0x5f, 0x91, 0x35, 0xb9, 0xc4, 0x2f, 0x4d, 0x78,
		0x00, 0x43, 0xfa, 0xf5, 0xaa, 0x24, 0x6a, 0xf2, 0x5e, 0x0d, 0x2b, 0xaf, 0xe5, 0x12, 0x9f, 0xda,
		0xfc, 0xc0, 0x01, 0xda, 0x23, 0x74, 0x34, 0x37, 0x0f, 0x60, 0x63, 0x4f, 0xd6, 0xa6, 0x66, 0xe4,
		0x11, 0xe4, 0xe2, 0x21, 0xaa, 0x8c, 0x0f, 0x14, 0x49, 0xd6, 0x77, 0xea, 0xea, 0x11, 0xcf, 0x4d,
		0x36, 0xe5, 0x17, 0x4b, 0xad, 0xae, 0xf1, 0x09, 0x24, 0xc0, 0xe6, 0x04, 0x53, 0x65, 0x11, 0x97,
		0xf4, 0xda, 0x61, 0x55, 0xc6, 0x6a, 0x59, 0xd9, 0xd7, 0x2b, 0x35, 0x55, 0xe3, 0x93, 0xe8, 0x31,
		0x3c, 0x8c, 0xc7, 0x0f, 0x7b, 0xb7, 0xb8, 0xf3, 0xfc, 0xf5, 0xb3, 0x13, 0x8b, 0x9e, 0x76, 0x1b,
		0x42, 0xd3, 0x69, 0x17, 0x86, 0xbe, 0x59, 0x09, 0x27, 0xc4, 0x0e, 0xbe, 0x80, 0x0d, 0xbe, 0x9e,
		0x7d, 0x1e, 0xfc, 0x75, 0x5e, 0x6c, 0xa4, 0xd8, 0xc9, 0xd3, 0xbf, 0x02, 0x00, 0x00, 0xff, 0xff,
		0x7e, 0x59, 0x61, 0xd4, 0x67, 0x13, 0x00, 0x00,
	},
	// uber/cadence/shared/v1/replication.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xc4, 0x58, 0x4d, 0x73, 0x1a, 0x47,
		0x13, 0xf6, 0x82, 0xf8, 0x50, 0x0b, 0x01, 0x1a, 0xe9, 0xb5, 0xb0, 0x64, 0xd5, 0x8b, 0x89, 0x6c,
		0xc9, 0x72, 0x0a, 0x6c, 0xb9, 0x9c, 0xcf, 0x4a, 0xb9, 0xd6, 0x02, 0x95, 0x36, 0xd6, 0x97, 0x87,
		0xb5, 0x5c, 0xca, 0x21, 0x5b, 0x2b, 0x76, 0x24, 0xb6, 0x04, 0xbb, 0xd4, 0xce, 0x80, 0xcc, 0x31,
		0xb9, 0xe7, 0x98, 0x5c, 0x72, 0xcc, 0xef, 0xc8, 0x35, 0x67, 0xff, 0xa4, 0xd4, 0xce, 0xcc, 0x02,
		0x0b, 0x0b, 0x96, 0xcb, 0x87, 0xdc, 0xb4, 0xdd, 0xcf, 0xd3, 0xdd, 0xd3, 0xdd, 0xd3, 0x3d, 0x02,
		0xb6, 0xbb, 0x17, 0xc4, 0xab, 0x34, 0x4c, 0x8b, 0x38, 0x0d, 0x52, 0xa1, 0x4d, 0xd3, 0x23, 0x56,
		0xa5, 0xf7, 0xac, 0xe2, 0x91, 0x4e, 0xcb, 0x6e, 0x98, 0xcc, 0x76, 0x9d, 0x72, 0xc7, 0x73, 0x99,
		0x8b, 0xee, 0xfa, 0xc8, 0xb2, 0x44, 0x96, 0x05, 0xb2, 0xdc, 0x7b, 0xb6, 0xf6, 0xff, 0x2b, 0xd7,
		0xbd, 0x6a, 0x91, 0x0a, 0x47, 0x5d, 0x74, 0x2f, 0x2b, 0xcc, 0x6e, 0x13, 0xca, 0xcc, 0x76, 0x47,
		0x10, 0xd7, 0x8a, 0x21, 0x17, 0x66, 0xc7, 0xf6, 0xed, 0x37, 0xdc, 0x76, 0x3b, 0x30, 0x1d, 0x8d,
		0xb0, 0xdc, 0xb6, 0x69, 0x07, 0x88, 0xcd, 0x29, 0x61, 0x36, 0x6d, 0xca, 0x5c, 0xaf, 0x2f, 0x50,
		0xa5, 0x3f, 0x62, 0xb0, 0x8c, 0x87, 0x81, 0x1f, 0x11, 0x4a, 0xcd, 0x2b, 0x42, 0x91, 0x0e, 0x4b,
		0x23, 0xe7, 0x31, 0x98, 0x49, 0xaf, 0x69, 0x41, 0x29, 0xc6, 0xb7, 0x17, 0x76, 0xb7, 0xca, 0xd1,
		0xc7, 0x2a, 0x8f, 0xd8, 0xd1, 0x4d, 0x7a, 0x8d, 0xf3, 0x5e, 0x58, 0x40, 0xd1, 0xb7, 0x70, 0xaf,
		0x65, 0x52, 0x66, 0x78, 0x84, 0x79, 0x36, 0xe9, 0x11, 0xcb, 0x68, 0x0b, 0x87, 0x86, 0x6d, 0x15,
		0x62, 0x45, 0x65, 0x3b, 0x8e, 0xef, 0xfa, 0x00, 0x1c, 0xe8, 0x65, 0x3c, 0x9a, 0x85, 0xee, 0x41,
		0xba, 0x69, 0x52, 0xa3, 0xed, 0x7a, 0xa4, 0x10, 0x2f, 0x2a, 0xdb, 0x69, 0x9c, 0x6a, 0x9a, 0xf4,
		0xc8, 0xf5, 0x08, 0xaa, 0xc3, 0x12, 0xed, 0x3b, 0x0d, 0xc3, 0x8f, 0xc4, 0x32, 0x28, 0x33, 0x59,
		0x97, 0x16, 0xe6, 0x8a, 0xca, 0xac, 0x58, 0xeb, 0x7d, 0xa7, 0x51, 0xf7, 0xf1, 0x75, 0x0e, 0xc7,
		0x39, 0x1a, 0x16, 0x94, 0x7e, 0x4f, 0x42, 0x6e, 0xec, 0x40, 0xe8, 0x00, 0xe6, 0xfd, 0x44, 0x18,
		0xac, 0xdf, 0x21, 0x05, 0xa5, 0xa8, 0x6c, 0x67, 0x77, 0x9f, 0xdc, 0x32, 0x19, 0x7a, 0xbf, 0x43,
		0x70, 0x9a, 0xc9, 0xbf, 0xd0, 0x26, 0x64, 0xa9, 0xdb, 0xf5, 0x1a, 0x84, 0x67, 0x76, 0x78, 0xfa,
		0x8c, 0x90, 0xfa, 0x0c, 0xcd, 0x42, 0x2f, 0x61, 0xb1, 0xe1, 0x11, 0x59, 0x01, 0xbb, 0x2d, 0x0e,
		0xbe, 0xb0, 0xbb, 0x56, 0x16, 0xfd, 0x53, 0x0e, 0xfa, 0xa7, 0xac, 0x07, 0xfd, 0x83, 0x33, 0x01,
		0xc1, 0x17, 0x21, 0x0b, 0xee, 0x8a, 0x9e, 0x10, 0x6e, 0x4c, 0xc6, 0x3c, 0xfb, 0xa2, 0xcb, 0x48,
		0x90, 0x9e, 0x2f, 0xa7, 0x45, 0x5f, 0xe5, 0x2c, 0x3f, 0x0c, 0x75, 0xc0, 0x39, 0xb8, 0x83, 0x57,
		0xac, 0x08, 0x39, 0xfa, 0x45, 0x81, 0x07, 0x13, 0x05, 0x98, 0xf0, 0x98, 0xe0, 0x1e, 0x5f, 0xdc,
		0xb2, 0x20, 0x13, 0xae, 0x37, 0xe8, 0x2c, 0x00, 0xba, 0x01, 0x0e, 0x30, 0xcc, 0x06, 0xb3, 0x7b,
		0x36, 0xeb, 0x4f, 0xb8, 0x4f, 0x72, 0xf7, 0xbb, 0xb3, 0xdc, 0xab, 0x92, 0x3b, 0xe1, 0x7b, 0x8d,
		0x4e, 0xd5, 0x22, 0x07, 0xd6, 0xe4, 0x8d, 0x12, 0x2e, 0x7b, 0xbb, 0xa3, 0x5e, 0x53, 0xdc, 0x6b,
		0x65, 0x9a, 0xd7, 0x03, 0xc1, 0xf4, 0x4d, 0x9e, 0xed, 0x86, 0x5c, 0xae, 0x36, 0xa3, 0x55, 0xa8,
		0x03, 0x6b, 0x97, 0xa6, 0xdd, 0x72, 0x7b, 0xc4, 0x33, 0xda, 0xa6, 0x77, 0x4d, 0xbc, 0x51, 0x7f,
		0x69, 0xee, 0xef, 0xe9, 0x34, 0x7f, 0xfb, 0x92, 0x79, 0xc4, 0x89, 0x21, 0x87, 0x85, 0xcb, 0x29,
		0xba, 0x57, 0x19, 0x80, 0xa1, 0x87, 0xd2, 0xdf, 0x31, 0x58, 0x89, 0xea, 0x0e, 0x84, 0x21, 0x2f,
		0x7b, 0xcd, 0xed, 0x10, 0x8f, 0xf7, 0xa0, 0xbc, 0x23, 0x5b, 0xb3, 0xbb, 0xec, 0x24, 0x80, 0xe3,
		0x9c, 0x15, 0x16, 0xa0, 0x2c, 0xc4, 0xe4, 0xd5, 0x98, 0xc7, 0x31, 0xdb, 0x42, 0xcf, 0x21, 0x29,
		0x20, 0xf2, 0x26, 0xac, 0x87, 0x2d, 0x9b, 0x1d, 0x7b, 0x68, 0x16, 0x4b, 0x28, 0x7a, 0x08, 0xd9,
		0x86, 0xeb, 0x5c, 0xda, 0x57, 0x46, 0x8f, 0x78, 0xd4, 0x0f, 0x6b, 0x8e, 0xdf, 0xb5, 0x45, 0x21,
		0x3d, 0x13, 0x42, 0xf4, 0x18, 0xf2, 0x83, 0xc4, 0x06, 0xc0, 0x04, 0x07, 0xe6, 0x02, 0x79, 0x00,
		0xfd, 0x0e, 0xee, 0x75, 0x3c, 0xd2, 0xb3, 0xdd, 0x2e, 0x35, 0x26, 0x38, 0x49, 0xce, 0x59, 0x0d,
		0x00, 0xfb, 0x61, 0x6e, 0xe9, 0x4f, 0x05, 0x36, 0x66, 0xf6, 0xba, 0x1f, 0xaf, 0x9c, 0x0d, 0x8d,
		0x56, 0x97, 0x32, 0xe2, 0xf1, 0x34, 0xce, 0xe3, 0x45, 0x21, 0xdd, 0x13, 0x42, 0x7f, 0x20, 0x8a,
		0xfb, 0x26, 0x33, 0x94, 0xc0, 0x29, 0xfe, 0xad, 0x59, 0xe8, 0x1b, 0x98, 0x1f, 0x6c, 0x94, 0x5b,
		0xcc, 0x8c, 0x21, 0xb8, 0xf4, 0x21, 0x01, 0x6b, 0xd3, 0xaf, 0x02, 0x5a, 0x87, 0x79, 0x59, 0x63,
		0xdb, 0x92, 0x51, 0xa5, 0x85, 0x40, 0xb3, 0xd0, 0x5b, 0x40, 0x37, 0xae, 0x77, 0x7d, 0xd9, 0x72,
		0x6f, 0x0c, 0xf2, 0x9e, 0x34, 0xba, 0xbc, 0x05, 0x62, 0xdc, 0xfd, 0xa3, 0xc8, 0x42, 0xbd, 0x93,
		0xf0, 0x5a, 0x80, 0xc6, 0x4b, 0x37, 0xe3, 0x22, 0x54, 0x80, 0x54, 0x90, 0xda, 0x38, 0x4f, 0x6d,
		0xf0, 0x89, 0x1e, 0x40, 0x86, 0x36, 0x9a, 0xc4, 0xea, 0xb6, 0x08, 0xcf, 0x82, 0x28, 0xeb, 0xc2,
		0x40, 0xa6, 0x59, 0x48, 0x85, 0xec, 0x10, 0xc2, 0x47, 0x68, 0xe2, 0xa3, 0xe9, 0x58, 0x1c, 0x30,
		0xf8, 0x0c, 0xdd, 0x00, 0xa0, 0xcc, 0xf4, 0x98, 0xf0, 0x21, 0xaa, 0x3b, 0x2f, 0x25, 0x9a, 0x85,
		0x7e, 0x80, 0x4c, 0xa0, 0xe6, 0xf6, 0x53, 0x1f, 0xb5, 0xbf, 0x20, 0xf1, 0xdc, 0xfa, 0x8f, 0xb0,
		0xcc, 0x37, 0x62, 0x93, 0x98, 0x1e, 0xbb, 0x20, 0x26, 0x13, 0x56, 0xd2, 0x1f, 0xb5, 0xb2, 0xe4,
		0xd3, 0x0e, 0x02, 0x16, 0xb7, 0xf5, 0x15, 0xa4, 0x2c, 0xc2, 0x4c, 0xbb, 0x45, 0x0b, 0xf3, 0x9c,
		0x7f, 0x3f, 0x32, 0xeb, 0xa7, 0x66, 0xbf, 0xe5, 0x9a, 0x16, 0x0e, 0xc0, 0x7e, 0x86, 0x4d, 0xc6,
		0x48, 0xbb, 0xc3, 0x0a, 0x20, 0x1a, 0x49, 0x7e, 0xa2, 0x97, 0x90, 0xe1, 0xd1, 0xf9, 0x4d, 0xde,
		0xf5, 0x48, 0x61, 0x61, 0x86, 0xd9, 0x7d, 0x81, 0xc1, 0x0b, 0x3e, 0x43, 0x7e, 0xa0, 0xa7, 0xb0,
		0xc2, 0x0d, 0xf8, 0x65, 0x25, 0x9e, 0x61, 0x5b, 0xc4, 0x61, 0x36, 0xeb, 0x17, 0x32, 0xbc, 0x77,
		0x90, 0xaf, 0x7b, 0xc7, 0x55, 0x9a, 0xd4, 0xa0, 0x13, 0xc8, 0xc9, 0xfa, 0x1a, 0x72, 0x04, 0x16,
		0x16, 0xa3, 0x5a, 0x68, 0x38, 0x45, 0xe4, 0xcd, 0x92, 0xb3, 0x14, 0x67, 0x7b, 0xa1, 0xef, 0xd2,
		0xaf, 0x71, 0x58, 0x9d, 0x32, 0x67, 0xd1, 0x2a, 0xa4, 0x82, 0xfd, 0xab, 0xf0, 0xc2, 0x26, 0x99,
		0xd8, 0xbc, 0xa1, 0x46, 0x8f, 0xdd, 0xaa, 0xd1, 0xe3, 0x9f, 0xdb, 0xe8, 0x3f, 0xc3, 0xff, 0xc6,
		0x4e, 0x6e, 0xd8, 0x8c, 0xb4, 0xfd, 0x5d, 0xed, 0x3f, 0xbb, 0x76, 0x6e, 0x77, 0x7e, 0x8d, 0x91,
		0x36, 0x5e, 0xee, 0x4d, 0xc8, 0x28, 0x7a, 0x01, 0x49, 0xd2, 0x23, 0x0e, 0x0b, 0x56, 0xf1, 0x46,
		0xf4, 0xf0, 0x34, 0x99, 0xf9, 0xaa, 0xe5, 0x5e, 0x60, 0x09, 0x46, 0x7b, 0x90, 0x75, 0xc8, 0x8d,
		0xe1, 0x75, 0x1d, 0x43, 0xd2, 0x93, 0xb7, 0xa1, 0x67, 0x1c, 0x72, 0x83, 0xbb, 0x4e, 0x8d, 0x53,
		0x4a, 0x7f, 0x29, 0x50, 0x98, 0xb6, 0x7c, 0x66, 0x4f, 0x95, 0xa8, 0xb1, 0x1c, 0x8b, 0x1e, 0xcb,
		0x9f, 0xfb, 0x5c, 0x2a, 0xfd, 0xa6, 0xc0, 0x72, 0x38, 0x4a, 0xdd, 0xbd, 0x26, 0x8e, 0x1f, 0x60,
		0x30, 0x6a, 0xc5, 0x23, 0x38, 0x81, 0xd3, 0x72, 0xd6, 0x52, 0x74, 0x0e, 0xb9, 0xb1, 0x85, 0x2c,
		0x67, 0xde, 0x27, 0x6f, 0x61, 0x9c, 0x0d, 0xef, 0xe0, 0xd2, 0x3f, 0xe1, 0xc7, 0x39, 0x7f, 0x15,
		0x3a, 0x97, 0xee, 0x7f, 0x32, 0x86, 0xd7, 0x47, 0xdf, 0xbe, 0x71, 0x3e, 0x26, 0x86, 0xcf, 0xd9,
		0x91, 0x7b, 0x34, 0x17, 0xba, 0x47, 0x23, 0xc3, 0x3b, 0x11, 0x1e, 0xde, 0x9b, 0x90, 0xbd, 0xb4,
		0x3d, 0xca, 0x44, 0x53, 0x0d, 0x47, 0x6b, 0x86, 0x4b, 0x79, 0xdb, 0x68, 0x16, 0x2a, 0xc1, 0xa2,
		0x43, 0xde, 0x8f, 0x80, 0x52, 0x62, 0xc6, 0xfb, 0xc2, 0x00, 0x33, 0xbe, 0x06, 0xd2, 0x13, 0x6b,
		0xc0, 0x6f, 0xbf, 0xfc, 0x68, 0x22, 0x79, 0x55, 0x47, 0x17, 0xa8, 0x12, 0x5e, 0xa0, 0x9f, 0xf1,
		0x7f, 0x4a, 0x40, 0xed, 0x78, 0x6e, 0x83, 0x50, 0x1a, 0xa6, 0xc6, 0x87, 0xd4, 0xd3, 0x40, 0x3f,
		0xa0, 0x96, 0x5e, 0x43, 0x6e, 0xec, 0x65, 0x10, 0xde, 0xe4, 0xca, 0x27, 0x6c, 0xf2, 0x9d, 0x0f,
		0x93, 0xbd, 0xc3, 0x4b, 0xf5, 0x00, 0x36, 0x70, 0xed, 0xf4, 0x50, 0xdb, 0x53, 0x75, 0xed, 0xe4,
		0xd8, 0xd0, 0xd5, 0xfa, 0x6b, 0x43, 0x3f, 0x3f, 0xad, 0x19, 0xda, 0xf1, 0x99, 0x7a, 0xa8, 0x55,
		0xf3, 0x77, 0x50, 0x11, 0xee, 0x47, 0x43, 0xaa, 0x27, 0x47, 0xaa, 0x76, 0x9c, 0x57, 0xa6, 0x1b,
		0x39, 0xd0, 0xea, 0xfa, 0x09, 0x3e, 0xcf, 0xc7, 0xd0, 0x13, 0xd8, 0x8a, 0x86, 0xd4, 0xcf, 0x8f,
		0xf7, 0x8c, 0xfa, 0x81, 0x8a, 0xab, 0x46, 0x5d, 0x57, 0xf5, 0xb7, 0xf5, 0x7c, 0x1c, 0x6d, 0xc1,
		0x17, 0x33, 0xc0, 0xea, 0x9e, 0xae, 0x9d, 0x69, 0xfa, 0x79, 0x7e, 0x0e, 0xed, 0xc0, 0xa3, 0x99,
		0x8e, 0x8d, 0xa3, 0x9a, 0xae, 0x56, 0x55, 0x5d, 0xcd, 0x27, 0xd0, 0x26, 0x14, 0x67, 0x63, 0xcf,
		0x76, 0xf3, 0x49, 0xf4, 0x18, 0x1e, 0x46, 0xa3, 0xf6, 0x55, 0xed, 0xf0, 0xe4, 0xac, 0x86, 0x8d,
		0x23, 0x15, 0xbf, 0xae, 0xe1, 0x7c, 0x6a, 0xc7, 0x86, 0xdc, 0xd8, 0x8b, 0x15, 0xdd, 0x87, 0x82,
		0x48, 0x8a, 0x71, 0x72, 0x5a, 0xc3, 0xc2, 0xc4, 0x30, 0x91, 0xeb, 0xb0, 0x3a, 0xa1, 0xdd, 0xc3,
		0x35, 0x55, 0xaf, 0xe5, 0x95, 0x48, 0xe5, 0xdb, 0xd3, 0xaa, 0xaf, 0x8c, 0xed, 0x1c, 0x43, 0xaa,
		0x7a, 0xf8, 0x86, 0x17, 0x6c, 0x05, 0xf2, 0xd5, 0xc3, 0x37, 0xe3, 0x35, 0x2a, 0xc0, 0xca, 0x40,
		0x3a, 0x12, 0x7f, 0x5e, 0x41, 0xcb, 0x90, 0x1b, 0x68, 0x64, 0xc1, 0x62, 0xaf, 0xbe, 0xfe, 0xe9,
		0xc5, 0x95, 0xcd, 0x9a, 0xdd, 0x8b, 0x72, 0xc3, 0x6d, 0x57, 0x42, 0xbf, 0x0c, 0x94, 0xaf, 0x88,
		0x23, 0x7e, 0x89, 0x18, 0xfe, 0x48, 0xf0, 0xbd, 0xf8, 0xab, 0xf7, 0xec, 0x22, 0xc9, 0x35, 0xcf,
		0xff, 0x0d, 0x00, 0x00, 0xff, 0xff, 0x7c, 0x50, 0xe1, 0x45, 0xf5, 0x10, 0x00, 0x00,
	},
	// uber/cadence/api/v1/domain.proto
	[]byte{
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x55, 0xdd, 0x72, 0xdb, 0x44,
		0x18, 0x45, 0x76, 0xea, 0x3a, 0x9f, 0x1c, 0xd7, 0x6c, 0x1b, 0xa2, 0x1a, 0x86, 0xa8, 0xe9, 0x30,
		0x63, 0x7a, 0x21, 0x13, 0xc3, 0x40, 0x0b, 0xc3, 0x85, 0x6d, 0x69, 0x8a, 0x99, 0x10, 0x3c, 0xb2,
		0x9b, 0x0b, 0xb8, 0xd0, 0xac, 0xa4, 0xb5, 0xbd, 0x53, 0x59, 0xab, 0x59, 0xfd, 0x84, 0xdc, 0x31,
		0x3c, 0x16, 0x0f, 0xc1, 0x33, 0x31, 0x5a, 0xad, 0x1c, 0xff, 0x68, 0x9a, 0xde, 0xed, 0x7e, 0x3f,
		0xe7, 0x3b, 0x3a, 0x3a, 0xbb, 0x0b, 0x7a, 0xea, 0x12, 0xde, 0xf7, 0xb0, 0x4f, 0x42, 0x8f, 0xf4,
		0x71, 0x44, 0xfb, 0xd9, 0x65, 0xdf, 0x67, 0x6b, 0x4c, 0x43, 0x23, 0xe2, 0x2c, 0x61, 0xe8, 0x69,
		0x5e, 0x61, 0xc8, 0x0a, 0x03, 0x47, 0xd4, 0xc8, 0x2e, 0xbb, 0x5f, 0x2e, 0x19, 0x5b, 0x06, 0xa4,
		0x2f, 0x4a, 0xdc, 0x74, 0xd1, 0xf7, 0x53, 0x8e, 0x13, 0xca, 0x64, 0x53, 0xf7, 0x7c, 0x3f, 0x9f,
		0xd0, 0x35, 0x89, 0x13, 0xbc, 0x8e, 0x8a, 0x82, 0x8b, 0xff, 0x1e, 0x43, 0xc3, 0x14, 0x63, 0x50,
		0x1b, 0x6a, 0xd4, 0xd7, 0x14, 0x5d, 0xe9, 0x1d, 0xdb, 0x35, 0xea, 0x23, 0x04, 0x47, 0x21, 0x5e,
		0x13, 0xad, 0x26, 0x22, 0x62, 0x8d, 0xde, 0x40, 0x23, 0x4e, 0x70, 0x92, 0xc6, 0x5a, 0x5d, 0x57,
		0x7a, 0xed, 0xc1, 0x0b, 0xa3, 0x82, 0x95, 0x51, 0x00, 0xce, 0x44, 0xa1, 0x2d, 0x1b, 0x90, 0x0e,
		0xaa, 0x4f, 0x62, 0x8f, 0xd3, 0x28, 0xe7, 0xa7, 0x1d, 0x09, 0xd4, 0xed, 0x10, 0x3a, 0x07, 0x95,
		0xdd, 0x86, 0x84, 0x3b, 0x64, 0x8d, 0x69, 0xa0, 0x3d, 0x12, 0x15, 0x20, 0x42, 0x56, 0x1e, 0x41,
		0x6f, 0xe0, 0xc8, 0xc7, 0x09, 0xd6, 0x1a, 0x7a, 0xbd, 0xa7, 0x0e, 0xbe, 0xfa, 0xc0, 0x6c, 0xc3,
		0xc4, 0x09, 0xb6, 0xc2, 0x84, 0xdf, 0xd9, 0xa2, 0x05, 0xad, 0xe0, 0xe5, 0x2d, 0xe3, 0xef, 0x17,
		0x01, 0xbb, 0x75, 0xc8, 0x5f, 0xc4, 0x4b, 0xf3, 0x89, 0x0e, 0x27, 0x09, 0x09, 0xc5, 0x2a, 0x22,
		0x9c, 0x32, 0x5f, 0x7b, 0xac, 0x2b, 0x3d, 0x75, 0xf0, 0xdc, 0x28, 0x64, 0x33, 0x4a, 0xd9, 0x0c,
		0x53, 0xca, 0x6a, 0xeb, 0x25, 0x8a, 0x55, 0x82, 0xd8, 0x25, 0xc6, 0x54, 0x40, 0xa0, 0x31, 0xb4,
		0x5c, 0xec, 0x3b, 0x2e, 0x0d, 0x31, 0xa7, 0x24, 0xd6, 0x9a, 0x02, 0x52, 0xaf, 0x24, 0x3b, 0xc2,
		0xfe, 0x48, 0xd6, 0xd9, 0xaa, 0x7b, 0xbf, 0x41, 0x7f, 0xc2, 0xd9, 0x8a, 0xc6, 0x09, 0xe3, 0x77,
		0x0e, 0xe6, 0xde, 0x8a, 0x66, 0x38, 0x70, 0xa4, 0xf0, 0xc7, 0x42, 0xf8, 0x97, 0x95, 0x78, 0x43,
		0x59, 0x2b, 0xa5, 0x3f, 0x95, 0x18, 0xbb, 0x61, 0xf4, 0x0d, 0x3c, 0x3b, 0x00, 0x4f, 0x39, 0xd5,
		0x40, 0x08, 0x8e, 0xf6, 0x9a, 0xde, 0x71, 0x8a, 0x30, 0x74, 0x33, 0x1a, 0x53, 0x97, 0x06, 0x34,
		0x39, 0x64, 0xa4, 0x7e, 0x3c, 0x23, 0xed, 0x1e, 0x66, 0x8f, 0xd4, 0xf7, 0x70, 0x56, 0x35, 0x22,
		0xe7, 0xd5, 0x12, 0xbc, 0x4e, 0x0f, 0x5b, 0x73, 0x6a, 0x06, 0x3c, 0xc5, 0x5e, 0x42, 0x33, 0xe2,
		0x78, 0x41, 0x1a, 0x27, 0x84, 0x3b, 0xc2, 0xb4, 0x27, 0xa2, 0xe7, 0xd3, 0x22, 0x35, 0x2e, 0x32,
		0xd7, 0xb9, 0x83, 0xa7, 0xd0, 0x94, 0x85, 0xb1, 0xd6, 0x16, 0x3e, 0xfa, 0xae, 0x92, 0xb8, 0xec,
		0xb1, 0x49, 0x14, 0x50, 0x4f, 0xfc, 0xfb, 0x31, 0x0b, 0x17, 0x74, 0x59, 0x1a, 0x61, 0x83, 0x82,
		0xbe, 0x86, 0xce, 0x02, 0xd3, 0x80, 0x65, 0x84, 0x3b, 0x19, 0xe1, 0x71, 0xee, 0xee, 0x27, 0xba,
		0xd2, 0xab, 0xdb, 0x4f, 0xca, 0xf8, 0x4d, 0x11, 0x46, 0x3d, 0xe8, 0xd0, 0xd8, 0x59, 0x06, 0xcc,
		0xc5, 0x81, 0x53, 0x9c, 0x6e, 0xad, 0xa3, 0x2b, 0xbd, 0xa6, 0xdd, 0xa6, 0xf1, 0x5b, 0x11, 0x2e,
		0xfc, 0xdb, 0xfd, 0x01, 0x8e, 0x37, 0x16, 0x46, 0x1d, 0xa8, 0xbf, 0x27, 0x77, 0xf2, 0x68, 0xe6,
		0x4b, 0xf4, 0x0c, 0x1e, 0x65, 0x38, 0x48, 0xcb, 0xc3, 0x59, 0x6c, 0x7e, 0xac, 0xbd, 0x56, 0x2e,
		0x4c, 0x38, 0x7f, 0x80, 0x3a, 0x7a, 0x01, 0xad, 0x1d, 0xad, 0x0a, 0x5c, 0xd5, 0xbb, 0x57, 0xe9,
		0xe2, 0x5f, 0x05, 0xd4, 0x2d, 0x73, 0xa2, 0x5f, 0xa1, 0xb9, 0x31, 0xb4, 0x22, 0x54, 0x33, 0x1e,
		0x32, 0xb4, 0x51, 0x2e, 0x8a, 0x63, 0xb8, 0xe9, 0xef, 0x3a, 0x70, 0xb2, 0x93, 0xaa, 0xf8, 0xbc,
		0xd7, 0xdb, 0x9f, 0xa7, 0x0e, 0x2e, 0x3e, 0x38, 0xeb, 0x6e, 0x12, 0x2e, 0xd8, 0xb6, 0x04, 0xff,
		0x28, 0x70, 0xb2, 0x93, 0x44, 0x9f, 0x41, 0x83, 0x13, 0x1c, 0xb3, 0x50, 0x0e, 0x91, 0x3b, 0xd4,
		0x85, 0x26, 0x8b, 0x08, 0xc7, 0x09, 0xe3, 0x52, 0xc9, 0xcd, 0x1e, 0xfd, 0x0c, 0x2d, 0x8f, 0x13,
		0x9c, 0x10, 0xdf, 0xc9, 0x2f, 0x4d, 0x71, 0xe1, 0xa9, 0x83, 0xee, 0xc1, 0xd5, 0x30, 0x2f, 0x6f,
		0x54, 0x5b, 0x95, 0xf5, 0x79, 0xe4, 0xd5, 0xdf, 0x0a, 0xb4, 0xb6, 0xef, 0x41, 0xf4, 0x1c, 0x4e,
		0xcd, 0xdf, 0x7f, 0x1b, 0x4e, 0xae, 0x9d, 0xd9, 0x7c, 0x38, 0x7f, 0x37, 0x73, 0x26, 0xd7, 0x37,
		0xc3, 0xab, 0x89, 0xd9, 0xf9, 0x04, 0x7d, 0x01, 0xda, 0x6e, 0xca, 0xb6, 0xde, 0x4e, 0x66, 0x73,
		0xcb, 0xb6, 0xcc, 0x8e, 0x72, 0x98, 0x35, 0xad, 0xa9, 0x6d, 0x8d, 0x87, 0x73, 0xcb, 0xec, 0xd4,
		0x0e, 0x61, 0x4d, 0xeb, 0xca, 0xca, 0x53, 0xf5, 0x57, 0x2b, 0x68, 0xef, 0x1d, 0xb2, 0xcf, 0xe1,
		0x6c, 0x68, 0x8f, 0x7f, 0x99, 0xdc, 0x0c, 0xaf, 0x2a, 0x59, 0xec, 0x27, 0xcd, 0xc9, 0x6c, 0x38,
		0xba, 0x12, 0x2c, 0x2a, 0x5a, 0xad, 0xeb, 0x22, 0x59, 0x1b, 0xdd, 0xc0, 0x99, 0xc7, 0xd6, 0x55,
		0x7f, 0x69, 0xd4, 0x1c, 0x46, 0x74, 0x9a, 0x6b, 0x35, 0x55, 0xfe, 0xe8, 0x2f, 0x69, 0xb2, 0x4a,
		0x5d, 0xc3, 0x63, 0xeb, 0xfe, 0xce, 0x7b, 0x67, 0x2c, 0x49, 0x58, 0xbc, 0x51, 0xf2, 0xe9, 0xfb,
		0x09, 0x47, 0x34, 0xbb, 0x74, 0x1b, 0x22, 0xf6, 0xed, 0xff, 0x01, 0x00, 0x00, 0xff, 0xff, 0xd4,
		0x52, 0xa7, 0xe0, 0x1e, 0x07, 0x00, 0x00,
	},
}

func init() {
	yarpc.RegisterClientBuilder(
		func(clientConfig transport.ClientConfig, structField reflect.StructField) AdminAPIYARPCClient {
			return NewAdminAPIYARPCClient(clientConfig, protobuf.ClientBuilderOptions(clientConfig, structField)...)
		},
	)
}
